%% QF02 stitching GCS for amira TR results

close all;clear all;

fnames{1} = 'partialresults-20081103.mat.mat';
fnames{2} = 'partialresults-20081103T164028.mat';
fnames{3} = 'partialresults-20081104T093616.mat';
ncomplete = [1,554;555,1051;1052,1204];

for iFNAME = 1:3
    load(fnames{iFNAME},'BridgeStrands','GapConfidences','connectionsbyrelaxation','-mat');
    BridgeStrands_collected(ncomplete(iFNAME,1):ncomplete(iFNAME,2)) = BridgeStrands(ncomplete(iFNAME,1):ncomplete(iFNAME,2));
    GapConfidences_collected(ncomplete(iFNAME,1):ncomplete(iFNAME,2)) = GapConfidences(ncomplete(iFNAME,1):ncomplete(iFNAME,2));
    connectionsbyrelaxation_collected(ncomplete(iFNAME,1):ncomplete(iFNAME,2)) = connectionsbyrelaxation(ncomplete(iFNAME,1):ncomplete(iFNAME,2));
end

load(fnames{iFNAME},'-mat');
BridgeStrands = BridgeStrands_collected;
GapConfidences = GapConfidences_collected;
connectionsbyrelaxation = connectionsbyrelaxation_collected;

save tmp2
