function jBlock=GetBlockFromStack(fname,coords)

%Copyright 2008 J.Kaufhold

% This file is part of ThresholdRelaxationAlgorithmV0.1
% 
%     ThresholdRelaxationAlgorithmV0.1 is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     ThresholdRelaxationAlgorithmV0.1 is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with ThresholdRelaxationAlgorithmV0.1.  If not, see <http://www.gnu.org/licenses/>.

x3ir=[coords.x3min:coords.x3max];
x2ir=[coords.x2min:coords.x2max];
x1ir=[coords.x1min:coords.x1max];

ztmp=imread(fname,'tif',x3ir(1));
zinf=whos('ztmp');
dtype=zinf.class;
jBlock=zeros(length(x1ir),length(x2ir),length(x3ir),dtype);

for x3i=1:length(x3ir)
  jtmp=imread(fname,'tif',x3ir(x3i));
  try
    jBlock(:,:,x3i)=jtmp(x1ir,x2ir);
  catch
    keyboard
  end
  
end
