function h = ShowStrandsNDeep(Strands,Vertices,startVert,nStrandsDeep)

% Pick a start vertex
rVert = startVert;
% Show it
plot3(Vertices.AllVerts(rVert,1),Vertices.AllVerts(rVert,2),Vertices.AllVerts(rVert,3),'r.');
% Get vertex strand
% % rStrands = unique(Vertices.StrandIndices{rVert});
tempStrand = Vertices.StrandIndices(rVert,:);
tempStrand = tempStrand(tempStrand~=0);
rStrands = unique(tempStrand);

% Show its strand(s)
SColors = repmat([1 1 0],numel(rStrands),1);
plotstrands3(Strands,Vertices,rStrands,SColors);

colorByDepth = jet(nStrandsDeep);
for i = 1:nStrandsDeep
    % Get all start and end vertices of strands
    rVert = unique([[Strands(rStrands).StartVertexIndex],[Strands(rStrands).EndVertexIndex]]);
    % Show them
    plot3(Vertices.AllVerts(rVert,1),Vertices.AllVerts(rVert,2),Vertices.AllVerts(rVert,3),'k.');
    % Get vertex strands
% %     rStrands = unique([Vertices.StrandIndices{rVert}]);
    tempStrand = Vertices.StrandIndices(rVert,:);
    tempStrand = tempStrand(tempStrand~=0);
    rStrands = unique(tempStrand);
end
%   Show the strands connected to those endpoints
SColors = repmat(colorByDepth(i,:),numel(rStrands),1);
h = plotstrands3(Strands,Vertices,rStrands,SColors);
