function [outExp] = VidaRunSaveOrSkip2(inExp,expFileName,currentStage)
%[outExp] = VidaRunSaveOrSkip2(inExp,expFileName,currentProgressFlag)
%---
progressFlags = inExp.progressFlags;
rootDataFolder = inExp.globalParameters.rootDataFolder;
%---
currentProgressFlag = [currentStage,'Completed'];
functionsFolderField = [currentStage,'FunctionsFolder'];
currentStageCap = [upper(currentStage(1)),currentStage(2:end)];
functionCallString = ['Vida',currentStageCap];
functionHandle = str2func(functionCallString);
completionField = [currentStage,'CompletionDate'];
%---
try
    stageCompletionDate = inExp.completionDates.(completionField);
catch
    stageCompletionDate = 'unknown date';
end
statusString = [currentStageCap,' previously completed on ',stageCompletionDate];
%---
if ~isfield(progressFlags,currentProgressFlag),
    progressFlags.(currentProgressFlag) = 0;
end %if ~isfield
%---
if progressFlags.(currentProgressFlag) ~= 1,
    addpath(inExp.codeFolders.(functionsFolderField));
    disp(['rootDataFolder : ',rootDataFolder]);
        postRunExp = functionHandle(inExp);
    %---
    progressFlags.(currentProgressFlag) = 1;
    postRunExp.progressFlags = progressFlags;
    experiment = postRunExp;
    save(expFileName,'experiment');
else
    disp(statusString);
    postRunExp = inExp;
end%if getfield(progressFlags,currentProgressFlag) ~= 1,
%---
outExp = postRunExp;
outExp.progressFlags = progressFlags;
%---
return




