function [E,EiB] = ComputeTotalEnergy(Blocks,Offsets,MarginalOffsetEnergies)

if ~isfield(MarginalOffsetEnergies,'Offset3DEnergy'),
    numAdjacentPairs = size(MarginalOffsetEnergies,2);
    for adjacentPairIter = 1:numAdjacentPairs,
        registrationDataFileNameList{adjacentPairIter} = MarginalOffsetEnergies.registrationDataFileName;
    end%for adjacentPairIter = 1:numAdjacentPairs,
else%if ~isfield(MarginalOffsetEnergies,'Offset3DEnergy'),
    registrationDataFileNameList = [];
end%if-else ~isfield(MarginalOffsetEnergies,'Offset3DEnergy'),


OffsetSearch = [0 0 0];
EiB = zeros(1,numel(Blocks));
for iB = 1:numel(Blocks)
    [Offset_minE,Etmp] = LocalOffsetSearch(iB,OffsetSearch,Blocks,Offsets,MarginalOffsetEnergies,registrationDataFileNameList);
    EiB(iB) = Etmp;
end
E = sum(EiB);
