function outputParameters = VidaAutoDectectRootFolder(inputParameters)

disp('Automatically Detecting Data based on current folder');
currentDir = cd;
strPos = findstr(currentDir,'\ProcessedData');
if ~isempty(strPos),
    rootDataFolder = currentDir(1:strPos-1);
    rootDirectoryFlag = 0;
else
    rootDataFolder = currentDir;
    rootDirectoryFlag = 1;
end

%Automatically detect fileRootName
if rootDirectoryFlag == 0,
    expFiles = dir('*-Experiment.mat');
    if ~isempty(expFiles),
        expFile = expFiles(1).name;
        strPos = findstr(expFile,'-Experiment.mat');
        fileRootName = expFile(1:strPos-1);
    else%if ~isempty(expFiles),
        FITCFiles = dir('*-FITC*');
        FITCFile = FITCFiles(1).name;
        strPos = findstr(FITCFile,'-');
        fileRootName = FITCFile(1:strPos(1)-1);
    end%if ~isempty(expFiles),
else%if rootDirectoryFlag == 0,  
    expFiles = dir('ProcessedData\*-Experiment.mat');
    if ~isempty(expFiles),
        expFile = expFiles(1).name;
        strPos = findstr(expFile,'-Experiment.mat');
        fileRootName = expFile(1:strPos-1);
    else%if ~isempty(expFiles),
        FITCFiles = dir('*-FITC*');
        if ~isempty(FITCFiles),
            FITCFile = FITCFiles(1).name;
            strPos = findstr(FITCFile,'-');
            fileRootName = FITCFile(1:strPos(1)-1);
        else%if ~isempty(FITCFile),
            guessFiles = dir('*-*');
            if ~isempty(guessFiles),
                guessFile = guessFiles(1).name;
                strPos = findstr(guessFile,'-');
                fileRootName = guessFile(1:strPos(1)-1);
            else% if ~isempty(guessFiles),
                guessFiles2 = dir('ProcessedData\*-*');
                guessFile2 = guessFiles2(1).name;
                strPos = findstr(guessFile2,'-');
                fileRootName = guessFile2(1:strPos(1)-1);
            end% if ~isempty(guessFiles),
        end%if ~isempty(FITCFile),
    end%if ~isempty(expFiles),
end%if rootDirectoryFlag == 0,



outputParameters.fileRootName = fileRootName;
outputParameters.rootDataFolder = rootDataFolder;

    