function outExp = VidaCleanUpFiles(inExp)

experiment = inExp;
deleteAfterCompletedFlags = inExp.deleteAfterCompletedFlags;

if deleteAfterCompletedFlags.deleteOffsetTif == 1,
    fprintf('Deleting Original Data Subfolder with -Offset.tif files\n');
    folderName = experiment.globalParameters.originalDataFolder;
    if exist(folderName,'dir'),
        rmdir(folderName,'s');
    end%if exist...
end%if delet%eAfterCompletedFlags.deleteOffsetTif == 1,
    
if deleteAfterCompletedFlags.deleteSubBlockFiles == 1,
    fprintf('Deleting Subblock folder and included files\n');
    folderName = fullfile(experiment.globalParameters.processedDataFolder,'subBlockFiles');
    if exist(folderName,'dir'),
        rmdir(folderName,'s');
    end%if exist...
end%if deleteAfterCompletedFlags.deleteSubBlockFiles == 1,

if deleteAfterCompletedFlags.deleteVascBlockChannelSubFiles == 1,
    fprintf('Deleting VascBlockChannelSubFiles folder and included files\n');
    folderName = fullfile(experiment.globalParameters.processedDataFolder,'vascBlockChannelSubFiles');
    if exist(folderName,'dir'),
        rmdir(folderName,'s');
    end%if exist...
end%if deleteAfterCompletedFlags.deleteVascBlockChannelSubFiles == 1,

if deleteAfterCompletedFlags.deleteNeunBlockChannelSubFiles == 1,
    fprintf('Deleting NeunBlockChannelSubFiles folder and included files\n');
    folderName = fullfile(experiment.globalParameters.processedDataFolder,'neunBlockChannelSubFiles');
    if exist(folderName,'dir'),
        rmdir(folderName,'s');
    end%if exist...
end%if deleteAfterCompletedFlags.deleteNeunBlockChannelSubFiles == 1,

if deleteAfterCompletedFlags.deleteCellSeg == 1,
    fprintf('Deleting CellSegFiles folder and included files\n');
    folderName = fullfile(experiment.globalParameters.processedDataFolder,'CellSegFiles');
    if exist(folderName,'dir'),
        rmdir(folderName,'s');
    end%if exist...
end%if deleteAfterCompletedFlags.deleteCellSeg == 1,

if deleteAfterCompletedFlags.deleteVascSegFiles == 1,
    fprintf('Deleting VascSegFiles folder and included files\n');
    folderName = fullfile(experiment.globalParameters.processedDataFolder,'VascSegFiles');
    if exist(folderName,'dir'),
        rmdir(folderName,'s');
    end%if exist...
end%if deleteAfterCompletedFlags.deleteVascSegFiles == 1,

if deleteAfterCompletedFlags.deleteCenterLineFiles == 1,
    fprintf('Deleting CenterLineFiles folder and included files\n');
    folderName = fullfile(experiment.globalParameters.processedDataFolder,'CenterLineFiles');
    if exist(folderName,'dir'),
        rmdir(folderName,'s');
    end%if exist...
end%if deleteAfterCompletedFlags.deleteCenterLineFiles == 1,

if deleteAfterCompletedFlags.deleteVascRadiiFiles == 1,
    fprintf('Deleting VascMaskOptimizaitonFiles folder and included files\n');
    folderName = fullfile(experiment.globalParameters.processedDataFolder,'VascRadiiFiles');
    if exist(folderName,'dir'),
        rmdir(folderName,'s');
    end%if exist...
end%if deleteAfterCompletedFlags.deleteVascRadiiFiles == 1,



outExp = experiment;

end

