

rootFolder = cd;
searchString = 'ImageStack-*';
myDir = dir(searchString);
numDir = size(myDir,1);
for dirIter = 1:numDir,
    disp([num2str(dirIter),' of ',num2str(numDir)]);
    fullFolderName = fullfile(rootFolder,myDir(dirIter).name,'ProcessedData','VascRadiusFiles');
    secondDir = dir(fullfile(fullFolderName,'VascBlockReconstructedMask*.mat'));
    numFiles = size(secondDir,1);
    for fileIter = 1:numFiles,
        disp(['Subblock : ',num2str(fileIter),' of ',num2str(numFiles)]);
        currentFileName = fullfile(fullFolderName,secondDir(fileIter).name);
        load(currentFileName,'vascBlockReconstructedMask');
        vascBlockRadiusMap = vascBlockReconstructedMask;
        newFileName = regexprep(currentFileName,'VascBlockReconstructedMask','VascBlockRadiusMap');
        save(newFileName,'vascBlockRadiusMap');
        delete(currentFileName);
    end%for fileIter = 1:numFiles,
    %------
    fullFolderName = fullfile(rootFolder,myDir(dirIter).name,'ProcessedData');
    crop1Pos = findstr(fullFolderName,'ImageStack-');
    crop1 = fullFolderName(crop1Pos(1)+11:end);
    crop2Pos = findstr(crop1,'Processed');
    fileIDString = crop1(1:crop2Pos-2);
    fullFileName = fullfile(fullFolderName,[fileIDString,'-VascReconstructedMask.mat']);
    if exist(fullFileName,'file')
        disp(['Restitched file']);
        currentFileName = fullFileName;
        load(currentFileName,'vascReconstructedMask');
        vascRadiusMap = vascReconstructedMask;
        newFileName = regexprep(currentFileName,'VascReconstructedMask','VascRadiusMap');
        save(newFileName,'vascRadiusMap');
        delete(currentFileName);
    end%
    %------
    
    
end%for dirIter = 1:numDir,for dirIter = 1:numDir,
    



