% % % cd('F:\Phil\AOH_Datasets\pbDB\pbDBVector\VectorProjectFolder')
% % % mypics = loadmovie;

frameDepth = 3;
centerFrame = 180;
topFrame = 0;
bottomFrame = 0;
showMaskFlag = 1;

figure(1)
myFrame = sum(double(mypics(:,:,centerFrame-frameDepth:centerFrame+frameDepth)),3);
imagesc(myFrame);
     

barrelCounter = 0;
myMask = false(size(mypics));

if exist('BarrelMaskDiv3.mat','file'),
    load('BarrelMaskDiv3.mat','myMask','barrelCounter');
end

while 1==1,
    scanningFlag = 1;
    while scanningFlag,
        myPress = waitforbuttonpress;
        if myPress == 0;%mouse press
            scanningFlag = 0;
        else%if myPress == 0;%mouse press
            switch(double(get(myPress,'CurrentCharacter')));
                case{28,30}%left or up
                    centerFrame = centerFrame - 1;
                case{29,31}%right or down
                    centerFrame = centerFrame + 1;
                case{43}%+
                    frameDepth = frameDepth + 1;
                case{45}%-
                    frameDepth = max(frameDepth-1,1);
                case{116}%t
                    topFrame = centerFrame;
                case{98}%b
                    bottomFrame = centerFrame;
                case{115}%s
                    showMaskFlag = ~showMaskFlag;
            end%switch
            myFrame = sum(double(mypics(:,:,centerFrame-frameDepth:centerFrame+frameDepth)),3);
            if showMaskFlag,
                myFrame = myFrame + (myMask(:,:,centerFrame)>0)*max(myFrame(:))*0.5;
            end%if showMaskFlag,
            imagesc(myFrame);
            myTitle = ['top = ',num2str(topFrame),...
                ';  center = ',num2str(centerFrame),...
                ';  bottom = ',num2str(bottomFrame),...
                ';  dz = ',num2str(frameDepth)];
                
            title(myTitle);
        end%if-else myPress == 0;
    end%while scanningFlag,
    %Grab a barrel
    bw = roipoly;
    if ~isempty(bw),
        myPrompt = {'top frame','bottom frame'}
        myTitle = 'z-extent';
        numLines = 1;
        defAns = {num2str(topFrame),num2str(bottomFrame)};
        answer = inputdlg(myPrompt,myTitle,numLines,defAns);
        if ~isempty(answer),
            topFrame = str2num(answer{1});
            bottomFrame = str2num(answer{2});
            barrelCounter = barrelCounter + 1;
            bw(bw>0) = barrelCounter;
            numFrames = bottomFrame - topFrame + 1;
            for frameIter = topFrame:bottomFrame,
                myMask(:,:,frameIter) = max(myMask(:,:,frameIter),bw);
            end%for frameIter = topFrame:bottomFrame,
            topFrame = 0; bottomFrame = 0;
            save('BarrelMaskDiv3.mat','myMask','barrelCounter');
        end%if ~isempty(answer),
    end%if ~isempty(roipoly),
    
    
end%while 1==1,



