halfSize = ceil([1373 1461 1865]/2);
fullMask = false(halfSize);


numBarrels = numel(barrels);
for barrelIter = 1:numBarrels,
    disp([barrelIter,numBarrels]);
    thisBarrel = barrels(barrelIter);
    myMask = false(halfSize);
    v = thisBarrel.volDisplay.vert/2;
    nv = size(v,1);
    for k = 1:nv-1;
        dd = v(k+1,:)-v(k,:);
        cc = v(k,:);
        for k = 1:ceil(max(abs(dd)));
            myMask(ceil(cc(3)),ceil(cc(2)),ceil(cc(1))) = 1;
            cc=cc+(dd/max(abs(dd)));
        end
    end

    zLevels = find(max(max(myMask,[],1),[],2)>0);
    myFrame = myMask(:,:,zLevels(1));
    myFrame = imfilter(myFrame,ones(5,5))>0;
    myFrame = imfill(myFrame,'holes');
    myFrame = imerode(myFrame,ones(5,5));
    for zIter = zLevels'
        myMask(:,:,zIter) = myFrame;
    end

    fullMask = max(fullMask,myMask);
end

maketiff(fullMask,'halfBarrelMask.tif');
