function [outputFilter] = VidaGenerateCellFilter(filterSize,modelsigma2)

% assume isotropic data
anisotropy=[1 1 1];
[x,y,z]=meshgrid(1:filterSize(2),1:filterSize(1),1:filterSize(3));
x = single(x);
y = single(y);
z = single(z);
x=anisotropy(1)*(x-(x(end)-x(1))/2);
y=anisotropy(2)*(y-(y(end)-y(1))/2);
z=anisotropy(3)*(z-(z(end)-z(1))/2);

vtmp=x.^2+y.^2+z.^2;
clear x y z;

outputFilter=single(exp(-vtmp/modelsigma2));
clear vtmp
