% Load an FV File.
% Make sure the circuitAnalysisParameters are as desired

myProject = [];
myProject.circuitAnalysisParameters = gds.circuitAnalysisParameters;
myProject.vectorizedStructure.maskSize = gds.maskSize;
myProject.vectorizedStructure.Vertices = gds.Vertices;
myProject.vectorizedStructure.Strands = gds.Strands;
    
    myProject = CalculateUnperturbedFlow002(myProject);
    
gds.Vertices = myProject.vectorizedStructure.Vertices;
gds.Strands = myProject.vectorizedStructure.Strands;
gds.circuitAnalysisParameters = myProject.circuitAnalysisParameters;
gds.clotAnalysisParameters = myProject.circuitAnalysisParameters;
%---
for strandIter = 1:numel(gds.Strands),
    cc = gds.Vertices.AllVerts(gds.Strands(strandIter).StartToEndIndices,:);
    yxzLim(:,1) = min(cc,[],1)';
    yxzLim(:,2) = max(cc,[],1)';
    gds.Strands(strandIter).YXZLimits = yxzLim;
    gds.Strands(strandIter).MedianRadius = median(gds.Vertices.AllRadii(gds.Strands(strandIter).InteriorVertices,:));
    gds.Strands(strandIter).MedianLabel = mode(gds.Vertices.AllLabels(gds.Strands(strandIter).InteriorVertices,:));
    gds.Strands(strandIter).MedianVoltage = median(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:));
    gds.Strands(strandIter).VoltageDrop = max(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:)) - ...
            min(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:));
end%for strandIter = 1:numel(gds.Strands),
disp('DONE');



