%%
'yuck'
'yuck'

pause
pause
pause
pause
pause
%%

cd('F:\Phil\AOH_VectorProjects\pbDB\FlowProject000001_Files')
load('F:\Phil\AOH_VectorProjects\pbDB\BarrelOutlines.mat')
load('F:\Phil\AOH_VectorProjects\pbDB\FlowProject000001_Files\FVFile_2011_06_13-162141.mat')


%%

maskSize = gds.maskSize;

numBarrels = numel(barrels);
minZ = inf;
maxZ = 0;
for barrelIter = 1:numBarrels,
    thisBarrel = barrels{barrelIter};
    minZ = min(minZ,min(thisBarrel(:,3))-1);
    maxZ = max(maxZ,max(thisBarrel(:,3))+1);    
end

z1 = 1;
z2 = z1 - minZ + maxZ;
subBlock = zeros(maskSize(1),maskSize(2),z2-z1+1,'uint8');

for barrelIter = 1:numBarrels,
    thisBarrel = barrels{barrelIter};
    thisInd = sub2ind(size(subBlock),thisBarrel(:,1),thisBarrel(:,2),thisBarrel(:,3)-minZ);
    subBlock(thisInd) = 1;
    minZ = min(minZ,min(thisBarrel(:,3))-1);
    maxZ = max(maxZ,max(thisBarrel(:,3))+1);    
end


barrelEdgeMask = subBlock.*0;
barrelInteriorMask = subBlock.*0;

for zIter = z1:3:z2-3,
    thisFrame = subBlock(:,:,zIter);
    closedFrame = imclose(thisFrame>0,ones(5,5));
    filledFrame = imfill(closedFrame,'holes');
    barrelEdgeMask(:,:,zIter) = closedFrame;
    barrelEdgeMask(:,:,zIter+1) = closedFrame;
    barrelEdgeMask(:,:,zIter+2) = closedFrame;   
    barrelInteriorMask(:,:,zIter) = filledFrame;
    barrelInteriorMask(:,:,zIter+1) = filledFrame;
    barrelInteriorMask(:,:,zIter+2) = filledFrame;   
end

%%
minRadius = 2
arterioleMask = barrelEdgeMask.*0;
allPlungingArterioleList = gds.allPlungingArterioleList;
numArterioles = numel(allPlungingArterioleList);
aRadiusList = [];
for aIter = 1:numArterioles,
    thisStrandID = allPlungingArterioleList(aIter);
    thisStrand = gds.Strands(thisStrandID);
    aRadiusList(aIter) = thisStrand.MedianRadius;
    allVerts = gds.Vertices.AllVerts(thisStrand.StartToEndIndices,:);
    subVerts = allVerts(and(allVerts(:,3)>minZ,allVerts(:,3)<maxZ),:);
    thisInd = sub2ind(size(subBlock),subVerts(:,1),subVerts(:,2),subVerts(:,3)-minZ);
    if aRadiusList(aIter) > minRadius,
        arterioleMask(thisInd) = 1;
    end%if aRadiusList(aIter) > minRadius,
end


%%
venuleMask = barrelEdgeMask.*0;
allPlungingVenuleList = gds.allPlungingVenuleList;
numVenules = numel(allPlungingVenuleList);
vRadiusList = [];
for aIter = 1:numVenules,
    thisStrandID = allPlungingVenuleList(aIter);
    thisStrand = gds.Strands(thisStrandID);
    vRadiusList(aIter) = thisStrand.MedianRadius;
    allVerts = gds.Vertices.AllVerts(thisStrand.StartToEndIndices,:);
    subVerts = allVerts(and(allVerts(:,3)>minZ,allVerts(:,3)<maxZ),:);
    thisInd = sub2ind(size(subBlock),subVerts(:,1),subVerts(:,2),subVerts(:,3)-minZ);
    if vRadiusList(aIter) > minRadius,
        venuleMask(thisInd) = 1;
    end%if vRadiusList(aIter) > minRadius,
end




%%
barrelInteriorFrame = max(barrelInteriorMask,[],3)>0;
barrelEdgeFrame = max(barrelEdgeMask,[],3);
arterioleFrame = max(arterioleMask,[],3);
venuleFrame = max(venuleMask,[],3);


%%
figure(1);imagesc(barrelEdgeFrame);
figure(2);imagesc(arterioleFrame);
figure(3);imagesc(venuleFrame);
RGB = zeros([size(barrelEdgeFrame),3]);
RGB(:,:,1) = arterioleFrame;
RGB(:,:,2) = barrelEdgeFrame;
RGB(:,:,3) = venuleFrame;
figure(4); imagesc(RGB);

%%

% % % 
% % % subB = barrelEdgeFrame(1:1100,601:end);
% % % subBI = barrelInteriorFrame(1:1100,601:end);
% % % subA = arterioleFrame(1:1100,601:end);
% % % subV = venuleFrame(1:1100,601:end);
% % % 
% % % subBI21 =imerode(subBI,circle2d(9));
% % % % subBI21 =imdilate(subBI,circle2d(15));
% % % 
% % % 
% % % 
% % % 
% % % % % fA = find(subA);
% % % % % fV = find(subV);
% % % % % 
% % % % % f1 = fV;
% % % % % 
% % % % % 
% % % % % q1 = subBI21(f1);
% % % % % myRatio = sum(q1)./numel(q1)
% % % % % baseRatio = sum(subBI21(:))./numel(subBI21)
% % % % % ratioRatio = baseRatio/myRatio
% % % 
% % % % arterioleMask2 = flipdim(arterioleMask,2);
% % % % arterioleMask2 = flipdim(arterioleMask2,1);
% % % venuleMask2 = flipdim(venuleMask,2);
% % % venuleMask2 = flipdim(venuleMask2,1);
% % % 
% % % fA = find(arterioleMask2);
% % % fV = find(venuleMask2);
% % % 
% % % f1 = fV;
% % % q1 = barrelEdgeMask(f1);
% % % myRatio = sum(q1)./numel(q1)
% % % baseRatio = sum(barrelEdgeMask(:))./numel(barrelEdgeMask)
% % % ratioRatio = baseRatio./myRatio




%%
x = [-60:5:60];
h1x = zeros(1,numel(x));
hAx = h1x;
hVx = h1x;

for q = -0,

bwFrame = bwdist(barrelEdgeFrame);
bwFrame = bwFrame.*(double(barrelInteriorFrame*2-1));
bwFrame = circshift(bwFrame,[0,q]);


h1 = hist(bwFrame(:),x);
h1(1) = 0;h1(end) = 0;
h1x = h1x+h1./sum(h1);
% figure(99);plot(x,h1./sum(h1),'k-');hold on
figure(91);plot(x,h1x,'k-');hold on

% % bwA = bwFrame(find(arterioleFrame));
% % bwV = bwFrame(find(venuleFrame));

bwA = [];bwV = [];
for kk = z1:z2,
% %     temp_bwA = bwFrame(find(arterioleMask(:,:,kk)));
% %     temp_bwV = bwFrame(find(venuleMask(:,:,kk)));

    temp_bwA = bwFrame(find(double(arterioleMask(:,:,kk)).*erodedFrame));
    temp_bwV = bwFrame(find(double(venuleMask(:,:,kk)).*erodedFrame));
    
    bwA = [bwA,temp_bwA'];
    bwV = [bwV,temp_bwV'];
end%for kk
    

hA = hist(bwA(:),x);
hA(1) = 0;hA(end) = 0;
hAx = hAx+hA./sum(hA);
% figure(99);plot(x,hA./sum(hA),'r-');
figure(91);plot(x,hAx,'r-');hold on

hV = hist(bwV(:),x);
hV(1) = 0;hV(end) = 0;
hVx = hVx+hV./sum(hV);
% figure(99);plot(x,hV./sum(hV),'b-');
figure(91);plot(x,hVx,'b-');hold on
hold off

% pause
end






