

vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorizedStructure.Strands;
arterioleTipList = vectorizedStructure.plungingArterioleTipList;
venuleTipList = vectorizedStructure.plungingVenuleTipList;


f1 = find(and(effectiveResistanceList>0.2e-7,sepList<400));
aList = aStrandList(f1);
vList = vStrandList(f1);

figure(12);hold on
for kk = 1:length(aList);
    ccy = [];
    ccx = [];
    ccy(1) = vectorizedStructure.strandMidYXZList(aList(kk),1);
    ccx(1) = vectorizedStructure.strandMidYXZList(aList(kk),2);
    ccy(2) = vectorizedStructure.strandMidYXZList(vList(kk),1);
    ccx(2) = vectorizedStructure.strandMidYXZList(vList(kk),2);
    figure(12);plot(ccy,ccx,'k-');hold on
end%forkk
for kk = 1:numArterioleTips,
    ccy = [];
    ccx = [];
    ccy(1) = vectorizedStructure.strandMidYXZList(arterioleTipList(kk),1);
    ccx(1) = vectorizedStructure.strandMidYXZList(arterioleTipList(kk),2);
    figure(12);plot(ccy,ccx,'r.');hold on
end
for kk = 1:numVenuleTips,
    ccy = [];
    ccx = [];
    ccy(1) = vectorizedStructure.strandMidYXZList(venuleTipList(kk),1);
    ccx(1) = vectorizedStructure.strandMidYXZList(venuleTipList(kk),2);
    figure(12);plot(ccy,ccx,'b.');hold on
end
figure(12);hold off


figure(13);hold off
for kk = 1:length(aList);
    ccy = [];
    ccx = [];
    ccy(1) = vectorizedStructure.strandMidYXZList(aList(kk),1);
    ccx(1) = vectorizedStructure.strandMidYXZList(aList(kk),2);
    figure(13);plot(ccy,ccx,'r.');hold on
end%forkk
figure(13);hold off


figure(14);hold off
for kk = 1:length(aList);
    ccy = [];
    ccx = [];
    ccy(1) = vectorizedStructure.strandMidYXZList(vList(kk),1);
    ccx(1) = vectorizedStructure.strandMidYXZList(vList(kk),2);
    figure(14);plot(ccy,ccx,'b.');hold on
end%forkk
figure(14);hold off

