
%Stage 1: Load a -flow-vectorProject

flowAnalysisParameters = [];



%%%Stage 2: Find the offshoots of plunging arterioles
flowProject.maskSize = vectorProject.vectorizedStructure.maskSize;
flowProject.Strands = vectorProject.vectorizedStructure.Strands;
flowProject.Vertices = vectorProject.vectorizedStructure.Vertices;
startList = vectorProject.vectorizedStructure.allPlungingVenuleList;
flowProject.baseStrandIDList = startList;
flowProject.maxBranchSearch = 10;
flowProject.stopVoltage = 99;%Hardcode;
flowProject.minimumFluxFraction = 1/(2^18);%Hardcode
disp('Calculating upstream paths...');
tic
fullFlowProject = CalculateUpstreamPathsFromVectorProject(flowProject);
toc

upstreamBranchList = fullFlowProject.upstreamBranchList;
lowestBranchOrderFromFullPlungingVenuleList = min(upstreamBranchList,[],2);

strands = vectorProject.vectorizedStructure.Strands;
numStrands = numel(strands);
for strandIter = 1:numStrands,
    strands(strandIter).lowestBranchOrderFromFullPlungingVenule = lowestBranchOrderFromFullPlungingVenuleList(strandIter);
end
vectorProject.vectorizedStructure.Strands = strands;

