%Load a vectorProject.
%Run the first code section.

%Then open RestrandifyVectorProject.m in StrandEditor folder
%run the code, inserting the second code section below in the
%required spot.


fep = vectorProject.vectorizedStructure.Vertices.FreeEndPoints;
fepcc = vectorProject.vectorizedStructure.Vertices.AllVerts(fep,:);

ccList = [];
numFEP = length(fepcc);
for kk = 1:numFEP;
    thisFEP = fepcc(kk,:);
    thisFEPRep = repmat(thisFEP,[numFEP,1]);
    thisDiff = thisFEPRep-fepcc;
    thisDist = sqrt(sum(thisDiff.^2,2));
    f1 = find(and(thisDist<4, thisDist>0));
    if length(f1)>0,
% %         disp(thisFEP);
% %         disp(fepcc(f1,:));
% %         disp(' ');
        q = cat(1,thisFEP,fepcc(f1,:));
%         disp(q);
        q2 = round(mean(q,1));
        disp(q2)
        ccList = [ccList;q2];
    end
end
 
addIndList = sub2ind(vectorProject.maskSize,ccList(:,1),ccList(:,2),ccList(:,3));
addRadiusList = addIndList.*0+1;

save filGap.mat addIndList addRadiusList

    
  

%%

numPoints = numel(radiusList);
numAdd = numel(addIndList);
p1 = numPoints+1;
p2 = numPoints+numAdd;
pixelList(p1:p2,:) = addIndList;
radiusList(p1:p2) = addRadiusList;
labelList(p1:p2) = 117;
confidenceList(p1:p2) = 1;
for pp = p1:p2,
    noteList{pp} = [];
end

    