%Load a flow-vectorProject file


subSampleSize = 10;
smallMaskSize = ceil(vectorProject.maskSize/subSampleSize);
smallMask = zeros(smallMaskSize);
[sy,sx,sz] = size(smallMask);
av = vectorProject.vectorizedStructure.Vertices.AllVerts;
av = av(1:10:end,:);
numVerts = size(av,1);
strandIndices = vectorProject.vectorizedStructure.Vertices.StrandIndices(:,1);
dc = av;
for zIter = 1:sz,
    for xIter = 1:sx,
        disp(xIter)
        for yIter = 1:sy,
            thisCoord = [yIter*subSampleSize,xIter*subSampleSize,zIter*subSampleSize];
            dc(:,1) = av(:,1)-thisCoord(1);
            dc(:,2) = av(:,2)-thisCoord(2);
            dc(:,3) = av(:,3)-thisCoord(3);
            distList = sum(dc.^2,2);
            [minVal,minPos] = min(distList);
            minPos = (minPos-1)*10 + 1;
            strandID = strandIndices(minPos(1));
            smallMask(yIter,xIter,zIter) = strandID;
        end%for yIter
    end%for xIter
end%for zIter

            
            










