%six possible directions the previous connection arrived from:
%                1 = due north
%northwest = 6          2 = northeast
%southwest = 5          3 = southeast
%                4 = due south





%%UNFINISHED





goN = [+1,0,0];
goE = [0,+1,0];
goS = [-1,0,0];
goW = [0,-1,0];
goU = [0,0,+1];
goD = [0,0,-1];

moveDirection = [goN;goE;goU;goS;goW;goD];

maxSize =10;
startCoords = [0,0];
coordList = [0,0];
activeNodeList = [2,3,4];
coordList(2,:) = startCoords + moveDirection(1,:);
coordList(3,:) = startCoords + moveDirection(2,:);
coordList(4,:) = startCoords + moveDirection(3,:);
seedFromList = [0;4;5;6];
GG = false(2*maxSize,2*maxSize,2*maxSize);
GG(1,2) = 1;GG(2,1) = 1;
GG(1,3) = 1;GG(3,1) = 1;
GG(1,4) = 1;GG(4,1) = 1;
nodeCounter = 4;

%%

for kk = 1:maxSize,
    disp(kk);
activeNode = activeNodeList(1);
seedFrom = seedFromList(activeNode);
currentCoords = coordList(activeNode,:);
sproutTo = mod([seedFrom+1,seedFrom+2],6)+1;

tentativeNodePos1 = currentCoords + moveDirection(sproutTo(1),:);
tentativeSeedDirection1 = mod(sproutTo(1)+2,6)+1;
tentativeNodePos2 = currentCoords + moveDirection(sproutTo(2),:);
tentativeSeedDirection2 = mod(sproutTo(2)+2,6)+1;

diffList1 = sqrt(sum((repmat(tentativeNodePos1,[nodeCounter,1]) - coordList).^2,2));    
diffList2 = sqrt(sum((repmat(tentativeNodePos2,[nodeCounter,1]) - coordList).^2,2));    

[min1,minPos1] = min(diffList1);
[min2,minPos2] = min(diffList2);

if min1 < 0.5,
    %coord already exists,
    if numConnections(minPos1) <3,
        %just make connection
        GG(activeNode,minPos1) = 1;
        GG(minPos1,activeNode) = 1;
    else
        
        
        
        
        
        
else%if min1<0.5
    %create node, and make connection
    nodeCounter = nodeCounter + 1;
    activeNodeList = [activeNodeList,nodeCounter];
    coordList(nodeCounter,:) = tentativeNodePos1;
    seedFromList(nodeCounter) = tentativeSeedDirection1;
    GG(activeNode,nodeCounter) = 1;
    GG(nodeCounter,activeNode) = 1;
end%if-else min1<0.5
%---
if min2 < 0.5,
    %coord already exists, just make connection
    GG(activeNode,minPos2) = 1;
    GG(minPos2,activeNode) = 1;
else%if min2<0.5
    %create node, and make connection
    nodeCounter = nodeCounter + 1;
    activeNodeList = [activeNodeList,nodeCounter];
    coordList(nodeCounter,:) = tentativeNodePos2;
    seedFromList(nodeCounter) = tentativeSeedDirection2;
    GG(activeNode,nodeCounter) = 1;
    GG(nodeCounter,activeNode) = 1;
end%if-else min2<0.5
activeNodeList = activeNodeList(2:end);

end%for kk
GG = GG(1:nodeCounter,1:nodeCounter);

%%
GGSize = size(GG);
GG2 = -1*GG;
for kk = 1:GGSize(1),
    GG2(kk,kk) = -1*sum(GG2(:,kk));
end

tic
disp('Finding eigenvectors');pause(0.1);
[eigenVectors,eigenValueMatrix] = eig(GG2);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;
figure(1);p1 = plot(coordList(:,1),coordList(:,2),'r.');

%%
floatingNode1ID = 1;

figure(2);hold off
for floatingNode2ID = 1:GGSize(1);
    % floatingNode2ID = 500
    runSum = 0;
    mSize = size(eigenVectors,1);
    for iIter = 2:mSize;
        eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
        eVectorBeta = eigenVectors(floatingNode2ID,iIter);
        eVal = eigenValues(iIter);
        cutoff = -1;
        if eVal > cutoff,
            runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
        end
    end%for iIter;
    effectiveResistance = runSum;
    sep = sqrt(sum((coordList(floatingNode2ID,:)-coordList(floatingNode1ID,:)).^2,2));
    figure(2);plot(sep,effectiveResistance,'c.');hold on
end%for floatingNode2ID = ...

