vectorProject = [];
baseFolder = 'F:\Phil\PsuedoCircuits';
vectorProject.note = '';
vectorProject.vectorProjectRootName = 'PsuedoCircuit02';
vectorProject.vectorProjectFolder = fullfile(baseFolder,vectorProject.vectorProjectRootName);
vectorProject.rootCodeFolder = 'F:\Phil\VIDA\VidaSuite';
    maskSize = [100 100 100];
vectorProject.maskSize = maskSize;
vectorProject.voxelSizeInMicrons = 1;



vectorProject.vectorizedStructure.maskSize = maskSize;
        tempVerts = repmat([10:1:90]',[1,3]);
        tempVerts(:,1) = 50;
        tempVerts(:,3) = 10;
    vertices = [];
    vertices.AllVerts = tempVerts;
        zerosList = zeros(size(tempVerts,1),1);
        numPoints = length(zerosList);
    vertices.AllRadii = zerosList+10;
    vertices.AllLabels = zerosList+111;
    vertices.AllConfidences = zerosList+1;
    vertices.AllNotes{numPoints,1} = '';
        sep = zerosList>0;
        sep(1) = 1;
        sep(end) = 1;
    vertices.StrandEndPoints = sep;
    vertices.JunctionPoints = zerosList;
    vertices.FreeEndPoints = sep;
        strandIndices = [];
        for pointIter = 1:numPoints,
            strandIndices{pointIter,1} = 1;
        end
    vertices.StrandIndices = strandIndices;
vectorProject.vectorizedStructure.Vertices = vertices;
    strands = [];
    strands(1).StartVertexIndex = 1;
    strands(1).EndVertexIndex = numPoints;
    strands(1).InteriorVertices = [2:numPoints-1];
    strands(1).StartToEndIndices = [1:numPoints];
    strands(1).StartVertexNeighborStrands = [];
    strands(1).EndVertexNeighborStrands = [];
    strands(1).Active = 1;
vectorProject.vectorizedStructure.Strands = strands;
    strandifyParameters = [];
    strandifyParameters.minSegmentLength = 5;
    strandifyParameters.maxHairLengthToEvaluateForRemovalInMicrons = 0;
    strandifyParameters.maxConnectingStrandLengthToEvaluateForRemovalInMicrons = 0;
    strandifyParameters.intensityRatioThresholdForHairRemoval = 3;
    strandifyParameters.intensityRatioThresholdForConnectingStrandRemoval = 3;
    strandifyParameters.outputTifFilesFlag = 1;
vectorProject.strandifyParameters = strandifyParameters;
    volumeFileNames = [];
    volumeFileNames.permutedVascGrayscale =  [vectorProject.vectorProjectRootName,'-permutedVascGrayscale.mat'];
vectorProject.volumeFileNames = volumeFileNames;

vectorProject.progressFlags = [];
vectorProject.cellCentroidAndLabelList = [1 1 1];
vectorProject.thresholdRelaxationParameters = [];
vectorProject.GapConnectionStruct = [];





permutedVascGrayscale = uint16(rand(maskSize)*100)+1;
cd(baseFolder)
mkdir(vectorProject.vectorProjectFolder);
cd(vectorProject.vectorProjectFolder);
mkdir('PermutedFilesFolder');
cd('PermutedFilesFolder');
save(volumeFileNames.permutedVascGrayscale,'permutedVascGrayscale')
vectorProjectFileName = [vectorProject.vectorProjectRootName,'-VectorProject.mat'];
cd(vectorProject.vectorProjectFolder)
save (vectorProjectFileName,'vectorProject');



