

vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;

allLabels = vertices.AllLabels;
strandIndices = vertices.StrandIndices;

allPlungingPointFlag = ismember(allLabels,[400:499]);
allStrandLabelList = [strands(:).MedianLabel];
allPlungingStrandList = find(ismember(allStrandLabelList,[400:499]));
allLabels(allPlungingPointFlag) = 115;

for strandIter = 1:numel(allPlungingStrandList);
    thisStrandID = allPlungingStrandList(strandIter);
    thisStrand = strands(thisStrandID);
    strands(thisStrandID).MedianLabel = 115;
end%for strandIter


allPlungingArterioleList = vectorizedStructure.allPlungingArterioleList;
allPlungingVenuleList = vectorizedStructure.allPlungingVenuleList;


allArteriolePoints = [];
for strandIter = 1:numel(allPlungingArterioleList)
    thisStrandID = allPlungingArterioleList(strandIter);
    thisStrand = strands(thisStrandID);
    allArteriolePoints = [allArteriolePoints,thisStrand.StartToEndIndices(2:end-1)];
    strands(thisStrandID).MedianLabel = 430;
end
allLabels(allArteriolePoints) = 430;


allVenulePoints = [];
for strandIter = 1:numel(allPlungingVenuleList)
    thisStrandID = allPlungingVenuleList(strandIter);
    thisStrand = strands(thisStrandID);
    allVenulePoints = [allVenulePoints,thisStrand.StartToEndIndices(2:end-1)];
    strands(thisStrandID).MedianLabel = 440;
end
allLabels(allVenulePoints) = 440;

vectorizedStructure.Strands = strands;
vectorizedStructure.Vertices.AllLabels = allLabels;
vectorProject.vectorizedStructure = vectorizedStructure;
