
numStrands = numel(gds.Strands);
z = [];
for k = 1:numStrands,
    z(k) = (gds.Strands(k).YXZLimits(3,1) + gds.Strands(k).YXZLimits(3,2))/2;
end

vMed = [gds.Strands.MedianVoltage];
convergenceList = [gds.Strands.convergenceValue];

z = z(subStrandList);
convergenceList = convergenceList(subStrandList);


q = [z',convergenceList'];
% q = [z',vMed'];

q2 = sortrows(q,1);
q3 = imfilter(q2,ones(1000,1),'replicate')/1000;
figure(111);plot(q3(:,1),q3(:,2),'r.');

x = [1:10:1200];
h = hist(z,x);
figure(112);plot(x,h);

cc = gds.cellCentroidAndLabelList;
ccz = cc(:,3);
nnz = cc(cc(:,4)==1,3);
hn = hist(nnz,x);
figure(113);plot(x,hc);