% % set = 'au'
% % 
% % oldVP = allProject.(set);
% % oldVS = oldVP.vectorizedStructure;
% % oldStrands = oldVS.Strands;
% % oldVS.origRadiiStrandCurrentList = [oldStrands(:).strandCurrent]';
% % oldVS.origRadiiStrandConductanceList = [oldStrands(:).strandConductance]';
% % oldVS.origRadiiStrandStartVoltageList = [oldStrands(:).StartVoltage]';
% % oldVS.origRadiiStrandEndVoltageList = [oldStrands(:).EndVoltage]';
% % 
% % oldVP.vectorizedStructure = oldVS;
% % newVP = CalculateUnperturbedFlow004_AdjustedRadii(oldVP);
% % 
% % allProject.(set) = newVP;

%%

set = 'db';
vs = allProject.(set).vectorizedStructure;
newCurrent = [vs.Strands(:).strandCurrent]';
oldCurrent = [vs.origRadiiStrandCurrentList];

oldMedianCurrent = median(abs(oldCurrent));
newMedianCurrent = median(abs(newCurrent));

oldNormCurrent = oldCurrent./oldMedianCurrent;
newNormCurrent = newCurrent./newMedianCurrent;

diffCurrent = newNormCurrent-oldNormCurrent;
figure(1);plot(oldNormCurrent,newNormCurrent,'r.');hold on;
figure(1);plot([-3000,3000],[-3000,3000],'b-');hold off

%%

set = 'db';
vs = allProject.(set).vectorizedStructure;
newVoltage = abs([vs.Strands(:).EndVoltage]' - [vs.Strands(:).StartVoltage]') ;
oldVoltage = abs(vs.origRadiiStrandEndVoltageList - vs.origRadiiStrandStartVoltageList);

oldMedianCurrent = median(abs(oldCurrent));
newMedianCurrent = median(abs(newCurrent));

oldNormCurrent = oldCurrent./oldMedianCurrent;
newNormCurrent = newCurrent./newMedianCurrent;

figure(1);plot(oldVoltage,newVoltage,'r.');hold on;
figure(1);plot([000,50],[000,50],'b-');hold off

hold off

%%


set = 'db';
vs = allProject.(set).vectorizedStructure;
newVoltage = abs([vs.Strands(:).EndVoltage]') ;
oldVoltage = abs(vs.origRadiiStrandEndVoltageList );

oldMedianCurrent = median(abs(oldCurrent));
newMedianCurrent = median(abs(newCurrent));

oldNormCurrent = oldCurrent./oldMedianCurrent;
newNormCurrent = newCurrent./newMedianCurrent;

figure(1);plot(oldVoltage,newVoltage,'r.');hold on;
figure(1);plot([100,50],[100,50],'b-');hold off

hold off

