

% % mypics = loadmovie;

xySubsample = 4.444;

[ySize,xSize,zSize] = size(mypics);
yPrime = round([1:xySubsample:ySize]);
xPrime = round([1:xySubsample:xSize]);

subPic = zeros(numel(yPrime),numel(xPrime),zSize,class(mypics));
filtSize = ceil(xySubsample);
myfilter = ones(filtSize,filtSize)./(filtSize.^2);

for zFrame = 1:zSize,
    disp(zFrame);
    myFrame = double(mypics(:,:,zFrame));
    filtFrame = imfilter(myFrame,myfilter);
    subFrame = filtFrame(yPrime,xPrime);
    subPic(:,:,zFrame) = subFrame;
end

maketiff(subPic,'subPic.tif');

