
pathList = gds.allPlungingArteriolePathList;
numPaths = numel(pathList);
for pathIter = 1:numPaths,
    thisPath = pathList{pathIter};
    midZ = gds.strandMidYXZList(thisPath,3)';
    pathRadii = gds.effectiveStrandRadiusList(thisPath);
    pathLength = gds.strandLengthList(thisPath);
    if numel(thisPath) >10,
        midZ = [0,midZ(1:end)]-0;
        diffZ = diff(midZ);
        myZ = linspace(0,1,numel(midZ));
        figure(1);plot(myZ,midZ./max(midZ),'r-');hold on
        q1 = midZ./max(midZ);
        q2 = q1./myZ;
        q3 = mean(q2(5:end));
        q4 = std(diff(q1(1:6)));
        q5 = std(diff(q1(6:end)));
        q6 = diff(diff(q1));
        q7 = mean(sign(q6));
        [q8,q8pos] = max(abs(q6));
        q9 = q6(q8pos);
        p = polyfit(myZ,q1,2)
    end
    aMaxZ(pathIter) = max(midZ);
    aMidZ(pathIter) = median(midZ);
    aMidZRatio(pathIter) = aMidZ(pathIter)/aMaxZ(pathIter);
    aNumPoints(pathIter) = numel(thisPath);
    aMeanDiff(pathIter) = mean(diffZ);
    aMaxDiff(pathIter) = max(diffZ);
    aDiameterRatio(pathIter) = max(pathLength)./min(pathRadii);
    pause
end
disp(' ');
pause

pathList = gds.allPlungingVenulePathList;
numPaths = numel(pathList);
for pathIter = 1:numPaths,
    thisPath = pathList{pathIter};
    midZ = gds.strandMidYXZList(thisPath,3)';
    
    pathRadii = gds.effectiveStrandRadiusList(thisPath);
    pathLength = gds.strandLengthList(thisPath);
    diffZ = diff(midZ);
    myZ = linspace(0,1,numel(midZ));
    if numel(thisPath) >10,
        midZ = [0,midZ(1:end)]-0;
        diffZ = diff(midZ);
        myZ = linspace(0,1,numel(midZ));
        figure(1);plot(myZ,midZ./max(midZ),'b-');hold on
        q1 = midZ./max(midZ);
        q2 = q1./myZ;
        q3 = mean(q2(5:end));
        q4 = std(diff(q1(1:6)));
        q5 = std(diff(q1(6:end)));
        q6 = diff(diff(q1));
        q7 = mean(sign(q6));
        [q8,q8pos] = max(abs(q6));
        q9 = q6(q8pos);
        p = polyfit(myZ,q1,2)

    end
    vMaxZ(pathIter) = max(midZ);
    vMidZ(pathIter) = median(midZ);
    vMidZRatio(pathIter) = vMidZ(pathIter)/vMaxZ(pathIter);

    vNumPoints(pathIter) = numel(thisPath);
    vMeanDiff(pathIter) = mean(diffZ);
    vMaxDiff(pathIter) = max(diffZ);
    vDiameterRatio(pathIter) = max(pathLength)./min(pathRadii);
    pause
end
hold off

figure(2);plot(aMeanDiff,aMaxDiff,'r.');hold on
figure(2);plot(vMeanDiff,vMaxDiff,'b.');hold off


figure(3);plot(aMeanDiff,aMidZRatio,'r.');hold on
figure(3);plot(vMeanDiff,vMidZRatio,'b.');hold off

figure(4);plot(aMeanDiff,aDiameterRatio,'r.');hold on
figure(4);plot(vMeanDiff,vDiameterRatio,'b.');hold off
disp(' ')
disp(' ')
disp(' ')


