
aList = gds.plungingArterioleTipList;
vList = gds.plungingVenuleTipList;
numA = numel(aList);
numV = numel(vList);
numTips = numA+numV;
tipList = [aList,vList];
aFlagList = [ones(1,numA),zeros(1,numV)];

startTreeDepth = 6;
searchDepth = 3;

for tipIter = 1:numTips,
    thisTipID = tipList(tipIter);
    startStrandID = thisTipID;
    dzList = [];
    for startTreeIter = 1:startTreeDepth,
        startStrandID;
%         disp([gds.strandMidYXZList(startStrandID),gds.effectiveStrandRadiusList(startStrandID)]);
        startStrand = gds.Strands(startStrandID);
        %find the lower Z end of this tip
        startZ = gds.Vertices.AllVerts(startStrand.StartVertexIndex,3);
        endZ = gds.Vertices.AllVerts(startStrand.EndVertexIndex,3);
        %---
        if startZ < endZ,
            deepZ = endZ;
            shallowZ = startZ;
            deepNeighborIDList = startStrand.EndVertexNeighborStrands;
        else
            deepZ = startZ;
            shallowZ = endZ;
            deepNeighborIDList = startStrand.StartVertexNeighborStrands;
        end
        deepNeighborIDList = deepNeighborIDList(deepNeighborIDList~=startStrandID);
        farEndNeighborIDList = deepNeighborIDList;
        nearAttachmentIDList = repmat(startStrandID,size(farEndNeighborIDList));
        %for the first search iteration, find and ignore the neighbor that is the
        %continuation of the plunging vessel
        zFactor = [];
        numNeighbors = numel(farEndNeighborIDList);
        rList = gds.effectiveStrandRadiusList(farEndNeighborIDList);
        for neighborIter = 1:numNeighbors
            thisStrandID = farEndNeighborIDList(neighborIter);
            thisStrand = gds.Strands(thisStrandID);
            startNeighbors = thisStrand.StartVertexNeighborStrands;
            if ismember(nearAttachmentIDList(neighborIter),startNeighbors),
                nearVertexID = thisStrand.StartVertexIndex;
                farVertexID = thisStrand.EndVertexIndex;
            else%if ismember..
                nearVertexID = thisStrand.EndVertexIndex;
                farVertexID = thisStrand.StartVertexIndex;
            end%if ismember..
            farZ = gds.Vertices.AllVerts(farVertexID,3);
            nearZ = gds.Vertices.AllVerts(nearVertexID,3);
            dz = farZ - nearZ; %positive if downward going
            strandLength = gds.strandLengthList(thisStrandID);
            zFactor(neighborIter) = dz./strandLength;
        end
        myMetric = zFactor.*rList';
        maxFlag = myMetric == max(myMetric);
        nextPlungingStrandID = farEndNeighborIDList(maxFlag);
        validNeighborIDList = farEndNeighborIDList(~maxFlag);
        validNearAttachmentIDList = nearAttachmentIDList(~maxFlag);
        midZList = gds.strandMidYXZList(validNeighborIDList,3)';
        for searchIter = 2:searchDepth,
            nextRoundNeighborIDList = [];
            nextRoundNearAttachmentIDList = [];
            numNeighbors = numel(validNeighborIDList);
            for neighborIter = 1:numNeighbors
                thisStrandID = validNeighborIDList(neighborIter);
                thisStrand = gds.Strands(thisStrandID);
                midZ = gds.strandMidYXZList(thisStrandID,3);
                midZList = [midZList,midZ];
                startNeighbors = thisStrand.StartVertexNeighborStrands;
                if ismember(validNearAttachmentIDList(neighborIter),startNeighbors),
                    nearVertexID = thisStrand.StartVertexIndex;
                    farVertexID = thisStrand.EndVertexIndex;
                    farNeighborList = thisStrand.EndVertexNeighborStrands;
                else%if ismember..
                    nearVertexID = thisStrand.EndVertexIndex;
                    farVertexID = thisStrand.StartVertexIndex;
                    farNeighborList = thisStrand.StartVertexNeighborStrands;
                end%if ismember..
                nextRoundNeighborIDList = [nextRoundNeighborIDList,farNeighborList];
                nextRoundNearAttachmentIDList = [nextRoundNearAttachmentIDList,repmat(thisStrandID,size(farNeighborList))];
            end%for neighborIter
            validNeighborIDList = nextRoundNeighborIDList;
            validNearAttachmentIDList = nextRoundNearAttachmentIDList;
        end%for searchIter;
        dzList(startTreeIter) = mean(midZList) - deepZ;
        dzList = sign(dzList);
% dzList(startTreeIter) = mean(midZ) - deepZ;
        
        startStrandID = nextPlungingStrandID;
    
        q(tipIter) = mean(dzList(3:end));
    end%for startTreeIter
    disp([aFlagList(tipIter) , mean(dzList(1:end))]);
    pause

end%for tipIter

                

        

        
        %calculate the 
        
    