

f1 = and(gds.Vertices.AllVerts(:,1)>200 , gds.Vertices.AllVerts(:,1)<1000);
f2 = and(gds.Vertices.AllVerts(:,2)>200 , gds.Vertices.AllVerts(:,2)<1000);
f3 = and(gds.Vertices.AllVerts(:,3)>100 , gds.Vertices.AllVerts(:,3)<700);
f4 = and(gds.Vertices.AllRadii >=0.75, gds.Vertices.AllRadii <=4);

f4(:) = 1;

ff = find(and(and(and(f1,f2),f3),f4));
ss = unique(gds.Vertices.StrandIndices(ff,:));
potentialMicroVesselIDList = ss(2:end);



rand('seed',333);
myList = ceil(rand(1,100) * numel(potentialMicroVesselIDList));

for kk = 1:length(potentialMicroVesselIDList),
    downList(kk) = min(gds.downstreamBranchList(potentialMicroVesselIDList(kk),:));
end


for kk = 1: 20,

    downChoice = mod(kk-1,4)+2;
    q = find(downList == downChoice);
    r = ceil(rand(1)*numel(q));
    selectedStrandID = potentialMicroVesselIDList(q(r));
    
    
    
memStruct = memgds(6);
gds.Strands = memStruct.Strands;
gds.Vertices.AllVoltages = memStruct.AllVoltages;
gds.clotAnalysisParameters = memStruct.clotAnalysisParameters;
gds.baseStrandIDList = memStruct.baseStrandIDList;
gds.currentSelectedBaseStrandIndex = memStruct.currentSelectedBaseStrandIndex;
gds.baseStrandCell = memStruct.baseStrandCell;
gds.downstreamBranchList = memStruct.downstreamBranchList;
gds.upstreamBranchList = memStruct.upstreamBranchList;
gds.selectedStrandData = memStruct.selectedStrandData;



gds.selectedStrandID = selectedStrandID;
gds.selectedStrandData.strandID = selectedStrandID;


clotAnalysisParameters = gds.clotAnalysisParameters;
if clotAnalysisParameters.clotStrandID(1) == 0,
    clotAnalysisParameters.clotStrandID = selectedStrandID;
else%if clotAnalysisParameters.clotStrandID(1) == 0,
    clotAnalysisParameters.clotStrandID = [clotAnalysisParameters.clotStrandID,selectedStrandID];
end%if clotAnalysisParameters.clotStrandID(1) == 0,





                        
  
                        
                        
                        
%----------
disp('Calculating Perturbed flow');
clotProject = [];
clotProject.circuitAnalysisParameters = clotAnalysisParameters;
clotProject.vectorizedStructure.maskSize = gds.maskSize;
clotProject.vectorizedStructure.Vertices = gds.Vertices;
clotProject.vectorizedStructure.Strands = gds.Strands;
    
    clotProject = CalculateFlowWithClotReducedHematocrit80(clotProject);
    
gds.Vertices = clotProject.vectorizedStructure.Vertices;
gds.Strands = clotProject.vectorizedStructure.Strands;
gds.clotAnalysisParameters = clotProject.circuitAnalysisParameters;
%---
for strandIter = 1:numel(gds.Strands),
    cc = gds.Vertices.AllVerts(gds.Strands(strandIter).StartToEndIndices,:);
    yxzLim(:,1) = min(cc,[],1)';
    yxzLim(:,2) = max(cc,[],1)';
    gds.Strands(strandIter).YXZLimits = yxzLim;
    gds.Strands(strandIter).MedianRadius = median(gds.Vertices.AllRadii(gds.Strands(strandIter).InteriorVertices,:));
    gds.Strands(strandIter).MedianLabel = mode(gds.Vertices.AllLabels(gds.Strands(strandIter).InteriorVertices,:));
    gds.Strands(strandIter).MedianVoltage = mode(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:));
    gds.Strands(strandIter).VoltageDrop = max(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:)) - ...
            min(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:));
end%for strandIter = 1:numel(gds.Strands),
disp('DONE');

gds.thresholdCurrentForStall = 2e7;
trackAlongVersusMem6DiffWithStalls

end%for kk