vectorProject = allProject.db;
vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
allVerts = vertices.AllVerts;
allRadii = vertices.AllRadii;
allLabels = vertices.AllLabels;
allPlungingArterioleList = vectorizedStructure.allPlungingArterioleList;
allPlungingArteriolePathList = vectorizedStructure.allPlungingArteriolePathList;
allPlungingVenuleList = vectorizedStructure.allPlungingVenuleList;
allPlungingVenulePathList = vectorizedStructure.allPlungingVenulePathList;
adjustedStrandRadiusList = vectorizedStructure.adjustedStrandRadiusList;

aStrandRadiusList = adjustedStrandRadiusList(allPlungingArterioleList);
vStrandRadiusList = adjustedStrandRadiusList(allPlungingVenuleList);
aStrandZList = vectorizedStructure.strandMidYXZList(allPlungingArterioleList,3);
vStrandZList = vectorizedStructure.strandMidYXZList(allPlungingVenuleList,3);

capStrandRadiusList = adjustedStrandRadiusList(~ismember([1:numel(strands)],[allPlungingVenuleList,allPlungingArterioleList]));


figure(1);plot(aStrandZList,aStrandRadiusList,'r.');
figure(2);plot(vStrandZList,vStrandRadiusList,'b.');
disp([median(aStrandRadiusList),median(vStrandRadiusList),median(capStrandRadiusList)])

% % for kk = 1:numel(vStrandRadiusList),
% %     thisRadius = vStrandRadiusList(kk);
% %     thisCoord = vectorizedStructure.strandMidYXZList(allPlungingVenuleList(kk),:);
% %     figure(3);pp = plot(thisCoord(1),thisCoord(2),'bo');hold on
% %     set(pp,'MarkerSize',thisRadius*3);
% % end
% % figure(3);hold off

qq(4,:) = [median(aStrandRadiusList),median(vStrandRadiusList),median(capStrandRadiusList)]








