cd('/Users/pst/Documents/Work/Data/2012_NozomiDataFromJCBFM')
load rawData mydata

myData = abs(mydata); 
clear mydata

f1 = myData(:,3)==0;
f1(:) = 1;

f2 = myData(:,2)<0.1;
ff = and(f1,f2);

subData = myData(~ff,:);
subData = myData;

tempRatio = subData(:,3)./subData(:,2);
subData = subData(tempRatio<10,:);




branchList = subData(:,1);
preV = subData(:,2);
postV = subData(:,3);
percentV = postV./preV;



clear medianPV meanPV stdPV
for kk = 1:9,
    thisPVList = percentV(find(branchList==kk));
    medianPV(kk) = median(thisPVList);
    meanPV(kk) = mean(thisPVList);
    stdPV(kk) = std(thisPVList)./sqrt(numel(thisPVList));
end
medianPV(10) = median(percentV(find(branchList>=10)));

    
figure(1);plot(medianPV,'k*');
figure(2);plot(meanPV,'b*');hold on
figure(2);plot(meanPV-stdPV,'r*');hold on
figure(2);plot(meanPV+stdPV,'r*');hold off

figure(3);plot(branchList,percentV,'r.');

%%
bValList = [1.5 3.5 5.5 8.5 12.5];
bList = branchList;
bList(branchList==1) = 1.5;
bList(branchList==2) = 1.5;
bList(branchList==3) = 3.5;
bList(branchList==4) = 3.5;
bList(branchList==5) = 5.5;
bList(branchList==6) = 5.5;
bList(branchList==7) = 8.5;
bList(branchList==8) = 8.5;
bList(branchList==9) = 8.5;
bList(branchList==10) = 8.5;
bList(branchList>10) = 12.5;


medianPV = [];
meanPV = []
stdPV = [];

for kk = 1:5,
    thisPVList = percentV(find(bList==bValList(kk)));
    thisPVList = thisPVList(~isnan(thisPVList));
    medianPV(kk) = median(thisPVList);
    meanPV(kk) = mean(thisPVList);
    stdPV(kk) = std(thisPVList)./sqrt(numel(thisPVList));
end

    
figure(12);plot(bValList,medianPV,'k*');hold on
figure(12);plot(bValList,meanPV,'b*');hold on
figure(12);plot(bValList,meanPV-stdPV,'r*');hold on
figure(12);plot(bValList,meanPV+stdPV,'r*');hold off

figure(13);p1 = plot(bList,percentV,'bo');hold on;
set(p1,'MarkerSize',6,'MarkerFaceColor','blue');
figure(13);p2 = plot(bValList,medianPV,'bd');hold on
set(p2,'MarkerSize',10,'MarkerFaceColor','blue');
set(gca,'YLim',[0 2]);
set(gca,'XLim',[0 15]);
figure(13);hold off




