vectorProject = allProject.db;
strands = vectorProject.vectorizedStructure.Strands;
% vertices = vectorProject.vectorizedStructure.Vertices;
% maskSize = vectorProject.vectorizedStructure.maskSize;
% rootName = vectorProject.vectorProjectRootName;
% findDash = findstr(rootName,'-');
% shortName = rootName(1:findDash(1)-1);
% strandMidYXZList = vectorProject.vectorizedStructure.strandMidYXZList;
strandLabelList = [strands(:).MedianLabel];
capFlagList = ~ismember(strandLabelList,[330:349,430:449]);


%%
%increase cap radii only by tenfold
vectorProject.vectorizedStructure.effectiveStrandRadiusList = vectorProject.vectorizedStructure.adjustedStrandRadiusList;
vectorProject.vectorizedStructure.effectiveStrandRadiusList(capFlagList) = vectorProject.vectorizedStructure.adjustedStrandRadiusList(capFlagList) * 3 ;
graphTitle = 'threefold radius capillary only';
vectorProject.circuitAnalysisParameters.minRadius = 0;
vectorProject.circuitAnalysisParameters.hematocrit = 0.45;
vectorProject = CalculateUnperturbedFlow003(vectorProject);
%%
tic
flowProject = vectorProject.vectorizedStructure;

flowProject.baseStrandIDList = flowProject.plungingArterioleTipList(11);%db11 good
flowProject.maxBranchSearch = 50;
flowProject.stopVoltage = 50.1;
flowProject.minimumFluxFraction = 1e-5;

flowProject = CalculateDownstreamPathsFromVectorProject(flowProject);
downstreamPathList = flowProject.downstreamPathList;
downstreamBranchList = flowProject.downstreamBranchList;
toc


dsl = find(downstreamBranchList<500);
ShowTheseStrands(vectorProject,dsl,3);


