

%cpMatrix:
%   cols1-3:coords, col4:endPointFlag, col5:junctionFlag, col6:activeFlag
%   col7:label


%Labels: 100=Unlabeled; 200=Temp ; 300=Surface ; 400=Plunging ; 500=Micro ;
%         10=Unlabeled ; 20=Temp ; 30=Supply ; 40=Draining ;  50=Connecting ;
%Therefore: SurfaceArtery=330; SurfaceVein = 340;

% selectLabelList = [330 430 630];
selectLabelList = [340 440 640];



maskSize = globalDataStruct.maskSize;
strands = globalDataStruct.strands;
cpMatrix = globalDataStruct.cpMatrix;
si = globalDataStruct.si;
ar = globalDataStruct.ar;
numStrands = size(strands,2);

myMask = false(maskSize);
tempMask = false(maskSize);

counter = 0;
% % % for strandIter = 1:numStrands,
% % %     strandID = strandIter;
% % %     thisStrand = strands(strandID);
% % %     stei = thisStrand.StartToEndIndices;
% % %     majorityLabel = median(cpMatrix(stei,7));
% % %     if ismember(majorityLabel,selectLabelList),
% % %         counter = counter+1;
% % %         disp(counter);
% % %        
% % %         radList = ar(stei);
% % %         medianRadius = median(radList);
% % %         thisCP = cpMatrix(stei,1:3);
% % %         cpIndexList = sub2ind(maskSize,thisCP(:,1),thisCP(:,2),thisCP(:,3));
% % %         tempMask(:) = 0;
% % %         tempMask(cpIndexList) = 1;
% % % % % %         tempMask = imfilter(tempMask,double(circle3d(medianRadius*2)));
% % %         myMask = or(myMask,tempMask);
% % %     end%if ismember(majorityLabel,selectLabelList),
% % % end%for strandIter = 1:numStrands,       
% % %     


for strandIter = 1:numStrands,
    strandID = strandIter;
    thisStrand = strands(strandID);
    stei = thisStrand.StartToEndIndices;
    majorityLabel = median(cpMatrix(stei,7));
    if ismember(majorityLabel,selectLabelList),
        counter = counter+1;
        disp(counter);
        for cpIter = 1:numel(stei)
            thisCP = cpMatrix(stei(cpIter),1:3);
            myMask(thisCP(1),thisCP(2),thisCP(3)) = 1;
        end%for cpIter = 1:numel(stei)
    end%if ismember(majorityLabel,selectLabelList),
end%for strandIter = 1:numStrands,       
    
MakeHalfSizeMasks
maketiff(halfMask,'halfMask.tif');

    
    
    
    