% function outProject = RestrandifyVectorProject(inputProject0)


%Label Structure
%100's Labels : Topology   : 100=Unlabeled, 200=Temporary, 300=Surface, 400=Plunging, 500=Connecting
%10's Labels  : Physiology :  10=Unlabeled,  20=Temporary,  30=Supply ,  40=Draining,  50=Microvessel
%1's Labels   : WhenAdded  :   1=Original ,   2=TR Added ,   3=Manual



centerlineRadiusStructure = [];
maskSize = vectorProject.maskSize;
AllVerts = vectorProject.vectorizedStructure.Vertices.AllVerts;
pixelList = sub2ind(maskSize,AllVerts(:,1),AllVerts(:,2),AllVerts(:,3));
radiusList = vectorProject.vectorizedStructure.Vertices.AllRadii;
labelList = vectorProject.vectorizedStructure.Vertices.AllLabels;
confidenceList = vectorProject.vectorizedStructure.Vertices.AllConfidences;
% % noteList = vectorProject.vectorizedStructure.Vertices.AllNotes;
%---



%if you have to add or remove any points; do it here


%-----
centerlineRadiusStructure.pixelList = pixelList;
centerlineRadiusStructure.maskSize = maskSize;
centerlineRadiusStructure.radiusList = radiusList;
centerlineRadiusStructure.labelList = labelList;
centerlineRadiusStructure.confidenceList = confidenceList;
% % centerlineRadiusStructure.noteList = noteList;
%-----
strandifyParameters = vectorProject.strandifyParameters;
strandifyParameters.voxelSizeInMicrons = vectorProject.voxelSizeInMicrons;
registeredVascGrayscaleFileOnlyName = vectorProject.volumeFileNames.permutedVascGrayscale;
strandifyExp.registeredVascGrayscaleFileName = [vectorProject.vectorProjectFolder,filesep,'PermutedFilesFolder',filesep,registeredVascGrayscaleFileOnlyName];
strandifyExp.strandifyParameters = strandifyParameters;
strandifyExp.centerlineRadiusStructure = centerlineRadiusStructure;
    strandifyExp = RestrandifyAndTransferLabels2(strandifyExp);
vectorizedStructure = strandifyExp.vectorizedStructure;

vectorProject.vectorizedStructure = vectorizedStructure;
%-----
disp([' ';' ';' ']);
disp(['Completed Restrandifying vectorProject : ',datestr(now)]);
disp([' ';' ';' ']);
%----


% outProject = vectorProject;
