function VectorProject2Mask

[fileName,pathName] = uigetfile({'*VectorProject*.mat'},'Select a VectorProject .mat file');
cd(pathName)
loadFileName = [fileName];
load(loadFileName);

maskSize = vectorProject.vectorizedStructure.maskSize;
AllVerts = vectorProject.vectorizedStructure.Vertices.AllVerts;
AllIndices = sub2ind(maskSize,AllVerts(:,1),AllVerts(:,2),AllVerts(:,3));
myMask = false(maskSize);
myMask(AllIndices) = 1;

maketiff(myMask,'CM.tif');

