

strands = globalDataStruct.strands;
cpMatrix = globalDataStruct.cpMatrix;
cpDistFromTarget = globalDataStruct.cpDistFromTarget;
ar = globalDataStruct.ar;
numStrands = size(strands,2);

halfDistance = 150;
stepSize = 5;
displayLimitA = [500 000 0];
displayLimitB = [600 2000 2000];

myR = [ones(1,halfDistance),1:-1/halfDistance:0];
myB = [0:1/halfDistance:1,ones(1,halfDistance)];
myG = [0:1/halfDistance:1,1:-1/halfDistance:0];
myG = min(myG,0.5);



distances = [-1:1000,Inf];
numDist = size(distances,2);

% numDist = 400;

figure(1);hold off
for kk = 2:stepSize:numDist;
    distanceRange1 = distances(kk-1);
    distanceRange2 = distances(kk);
    flag1 = cpDistFromTarget > distanceRange1;
    flag2 = cpDistFromTarget <= distanceRange2;
    flag3 = and(flag1,flag2);
    cc1 = cpMatrix(flag3,1);
    cc2 = cpMatrix(flag3,2);
    cc3 = cpMatrix(flag3,3);
    dd = min(kk-1,2*halfDistance);
    ccflag = cc1 > displayLimitA(1);
    ccflag = and(ccflag, cc2 > displayLimitA(2));
    ccflag = and(ccflag, cc3 > displayLimitA(3));
    ccflag = and(ccflag, cc1 < displayLimitB(1));
    ccflag = and(ccflag, cc2 < displayLimitB(2));
    ccflag = and(ccflag, cc3 < displayLimitB(3));
    cc1 = cc1(ccflag);
    cc2 = cc2(ccflag);
    cc3 = cc3(ccflag);
    p3 = plot3(cc1,cc2,-1*cc3,'r.');hold on
    axis equal
    myColor = [myR(dd),myG(dd),myB(dd)];
    set(p3,'MarkerEdgeColor',myColor)
    drawnow
end%for kk = ...
hold off









% % 
% % 
% % figure(1);
% % for k = 1:numStrands
% %    
% %     ss = strands(k);
% %     dd = ss.distanceFromStart;
% %     iv = ss.InteriorVertices;
% %     upstreamNeighbor = ss.upstreamNeighbor;
% %     EndVertexNeighborStrands = ss.EndVertexNeighborStrands;
% %     numIV = size(iv,2);
% %     if ismember(upstreamNeighbor,EndVertexNeighborStrands),
% %         iv = fliplr(iv);
% %     end%if ismember(upstreamNeighbor,EndVertexNeighborStrands),
% %     %---
% %     cc1 = cpMatrix(iv,1);
% %     cc2 = cpMatrix(iv,2);
% %     cc3 = cpMatrix(iv,3);
% %     myRad = ar(iv);
% %     maxRad = max(myRad);
% %     maxRad = max(1,maxRad);
% % 
% %     for ww = 1:numIV
% %         dd=dd+1;
% %         dd = max(1,min(2*halfDistance,dd));
% %         myColor = [myR(dd),myG(dd),myB(dd)];
% %         p3 = plot3(cc1(ww),cc2(ww),-1*cc3(ww),'ro');
% %         set(p3,'MarkerEdgeColor',myColor)
% %         set(p3,'MarkerSize',maxRad);
% %         hold on
% %     end%for ww= 1:numIV
% %     if mod(k,1000)==0,pause;end
% %     
% % end%for k
% % hold off    
% %     
% %     