function outExp = VidaStrandify(inExp)

experiment = inExp;
strandifyParameters = experiment.strandifyParameters;
minSegmentLength = strandifyParameters.minSegmentLength;
outputTifFilesFlag = strandifyParameters.outputTifFilesFlag;
centerlineRadiusStructure = experiment.globalParameters.centerlineRadiusStructure;
registeredVascGrayscaleFileName = experiment.globalParameters.registeredVascGrayscaleFileName;
voxelSizeInMicrons = inExp.globalParameters.voxelSizeInMicrons;
%-----
if ~isfield(centerlineRadiusStructure,'labelList');
    centerlineRadiusStructure.labelList = zeros(size(centerlineRadiusStructure.radiusList))+111;
end%if ~isfield(centerlineRadiusStructure,'labelList');
%%---
if ~isfield(centerlineRadiusStructure,'confidenceList');
    centerlineRadiusStructure.confidenceList = zeros(size(centerlineRadiusStructure.radiusList))+Inf;
end%if ~isfield(centerlineRadiusStructure,'confidenceList');
%%---
% % if ~isfield(centerlineRadiusStructure,'noteList');
% %     centerlineRadiusStructure.noteList = cell(size(centerlineRadiusStructure.radiusList));
% % end%if ~isfield(centerlineRadiusStructure,'noteList');
%%---


%-----
strandifyParameters.centerlineRadiusStructure = centerlineRadiusStructure;
strandifyParameters.minSegmentLength = minSegmentLength;
strandifyParameters.registeredVascGrayscaleFileName = registeredVascGrayscaleFileName;
strandifyParameters.voxelSizeInMicrons = voxelSizeInMicrons;

%-----
    vectorizedStructure = JustStrandifyCenterlineRadiusStructure2(centerlineRadiusStructure,strandifyParameters);
strandifyParameters.vectorizedStructure = vectorizedStructure;
%-----
if outputTifFilesFlag == 1,
    strandifyParameters = VidaGenerateStraightLineMasks2(strandifyParameters);%noteToSelf
end%if outputTifFilesFlag == 1,

outExp = inExp;
strandifyParameters = rmfield(strandifyParameters,'centerlineRadiusStructure');
outExp.strandifyParameters = strandifyParameters;



