function [blockranges]=VidaGridUpBlock(vsize,overlapsz,n1,n2,n3)
%modified by Phil Tsai on 09/19/07

% Divide each 2D slice in x1x2 plan in 1/(nxiblks)ths to get a blksize estimate
x1sz=fix(((n1-1)*overlapsz+vsize(1))/n1)+1;
x2sz=fix(((n2-1)*overlapsz+vsize(2))/n2)+1;
x3sz=fix(((n3-1)*overlapsz+vsize(3))/n3)+1;

raw1=linspace(1,vsize(1),n1+1);
raw2=linspace(1,vsize(2),n2+1);
raw3=linspace(1,vsize(3),n3+1);

shft=overlapsz/2;
rstacked1=[[raw1(1:end-1)];raw1(2:end)];
rstacked1(1,2:end)=rstacked1(1,2:end)-shft;
rstacked1(2,1:end-1)=rstacked1(2,1:end-1)+shft;

rstacked2=[[raw2(1:end-1)];raw2(2:end)];
rstacked2(1,2:end)=rstacked2(1,2:end)-shft;
rstacked2(2,1:end-1)=rstacked2(2,1:end-1)+shft;

rstacked3=[[raw3(1:end-1)];raw3(2:end)];
rstacked3(1,2:end)=rstacked3(1,2:end)-shft;
rstacked3(2,1:end-1)=rstacked3(2,1:end-1)+shft;

st1=round(rstacked1);
st2=round(rstacked2);
st3=round(rstacked3);

bcount=1;
for k=1:size(st3,2)
  for j=1:size(st2,2)
    for i=1:size(st1,2)
      blockgrid.x1min=st1(1,i);
      blockgrid.x1max=st1(2,i);
      blockgrid.x2min=st2(1,j);
      blockgrid.x2max=st2(2,j);
      blockgrid.x3min=st3(1,k);
      blockgrid.x3max=st3(2,k);
      blockranges{bcount}=blockgrid;
      bcount=bcount+1;
    end
  end
end


