

vectorProjectFolder = vectorProject.vectorProjectFolder;
volumeFileNames = vectorProject.volumeFileNames;
permutedVascGrayscaleFileName = volumeFileNames.permutedVascGrayscale;
vectorProjectRootName = vectorProject.vectorProjectRootName;

targetBlockSize = 400;
overlapSize = 100;
bigBlockSize = vectorProject.maskSize;


numCharInRootFolderName = numel(vectorProjectFolder);

%Divy up the big data block into smaller overlapping blocks
%Determine Blocking Limits
blockingParameters = [];
blockingParameters.fullDataSize = bigBlockSize;
blockingParameters.targetBlockSize = targetBlockSize;
blockingParameters.overlapSize = overlapSize;
blockingParameters.fittingStyle = 'tight';
    blockingParameters = DetermineBlockingLimits(blockingParameters);
blockList = blockingParameters.blockList;
numBlocks = numel(blockList);
%-----
%-----
vascGrayscaleBlockFolder = fullfile(vectorProjectFolder,'VascGrayscaleBlockFolder');
if ~exist(vascGrayscaleBlockFolder,'dir'),
    mkdir(vectorProjectFolder,'VascGrayscaleBlockFolder');
end
blockingParameters.fullDataFileName = fullfile(vectorProjectFolder,fullfile('PermutedFilesFolder',permutedVascGrayscaleFileName));
blockingParameters.fullDataVariableName = 'permutedVascGrayscale';
blockingParameters.fullDataStorageType = 'mask';
blockingParameters.blockStorageType = 'mask';
blockingParameters.blockFolder = vascGrayscaleBlockFolder;
blockingParameters.blockFileNameRoot = [vectorProjectRootName,'-permutedVascGrayscale'];
blockingParameters.blockVariableName = 'permutedVascGrayscaleBlock';
blockingParameters.blockNameZeroPad = 5;
        outputBlockingParameters = SubBlockData(blockingParameters);
for blockIter = 1:numBlocks,
    blockName = outputBlockingParameters.blockList(blockIter).blockFileName;
    outputBlockingParameters.blockList(blockIter).blockFileName = blockName(numCharInRootFolderName+2:end);
end%for blockIter = 1:numBlocks,
vascGrayscaleBlockList = outputBlockingParameters.blockList;
%-----
%-----
   
    