path2vidaProcessingDir = '/home/pblinder/Desktop/FLATTEN_CORTEX/CX06_pbEH';
rootName = 'CX06_pbEH';
ptr2latestSEfile = '/home/pblinder/Desktop/FLATTEN_CORTEX/CX06_pbEH/VectorProjectFolder/SE2-2012_07_06-14_21_23-Mod-StrandEdit2-CX06_pbEH.mat';


%load the vida project
load(fullfile(path2vidaProcessingDir,sprintf('%s-VidaProject.mat',rootName)))

%load the pre-threshold relaxation vectorizedStructure
load(fullfile(path2vidaProcessingDir,sprintf('%s-PreThresholdVectorizedStructure.mat',rootName)))


% roll back vidaProject vectorized structure to pre-threshold relaxation
vidaProject.globalParameters.vectorizedStructure = vectorizedStructure;

%update progress flags
vidaProject.multiThreadProgress.thresholdRelaxingFlag = 0;
vidaProject.multiThreadProgress.restrandifyingFlag = 0;


%load the vectorProject
vectorProjectFileName = fullfile(path2vidaProcessingDir,sprintf('VectorProjectFolder%s%s-VectorProject.mat',filesep,rootName));
load(vectorProjectFileName)


%% add bridging strands and revectorize (the final result of TR is appended to the vectorProject
%update vectorizedStructrue on VectorProject
vectorProject.vectorizedStructure = vectorizedStructure;

vectorProject = VidaAddTRBridges(vectorProject);
vectorProject.progressFlags.addTRBridgesCompleted = 1;
saveSize = (getfield(whos('vectorProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
save(vectorProjectFileName,'vectorProject',scs);



%% load latest SE file and transfer labels and manual corrections
load(ptr2latestSEfile)
