%% QF02 stitching GCS for amira TR results

close all;clear all;

fnames{1} = 'amira-QF02-intermediate1-GCS.mat';
fnames{2} = 'amira-QF02-intermediate2-GCS.mat';
fnames{3} = 'amira-QF02-intermediate3-GCS.mat';
fnames{4} = 'amira-QF02-intermediate4-GCS.mat';
ncomplete = [1,445;446,593;594,1107;1108,1238];

for iFNAME = 1:4
    load(fnames{iFNAME},'BridgeStrands','GapConfidences','connectionsbyrelaxation','-mat');
    BridgeStrands_collected(ncomplete(iFNAME,1):ncomplete(iFNAME,2)) = BridgeStrands(ncomplete(iFNAME,1):ncomplete(iFNAME,2));
    GapConfidences_collected(ncomplete(iFNAME,1):ncomplete(iFNAME,2)) = GapConfidences(ncomplete(iFNAME,1):ncomplete(iFNAME,2));
    connectionsbyrelaxation_collected(ncomplete(iFNAME,1):ncomplete(iFNAME,2)) = connectionsbyrelaxation(ncomplete(iFNAME,1):ncomplete(iFNAME,2));
end

load(fnames{iFNAME},'-mat');
BridgeStrands = BridgeStrands_collected;
GapConfidences = GapConfidences_collected;
connectionsbyrelaxation = connectionsbyrelaxation_collected;

save tmp2
