function [Strands,Vertices] = FilterFragmentStrands(Strands,Vertices)

minFragSize = 10; % minimum number of centerline points in fragment

nStrands = numel(Strands);
for iSTRAND = 1:nStrands   % loop over all strands
    StartFree = isempty(Strands(iSTRAND).StartVertexNeighborStrands);
    EndFree = isempty(Strands(iSTRAND).EndVertexNeighborStrands);
    nVerts = numel(Strands(iSTRAND).StartToEndIndices);
% %     nVerts = numel(Strands(iSTRAND).InteriorVertices)+2;
    if StartFree && EndFree && (nVerts <= minFragSize)
        Strands(iSTRAND).Active = false; % remove strand by flagging as inactive
    end
end

