function BridgeConnectionType = GetBridgeConnectionType(Vertices,VS,VE)

if Vertices.FreeEndPoints(VS) & Vertices.FreeEndPoints(VE)
    BridgeConnectionType = 'EndPointToEndPoint';
else
    if ~Vertices.AllStrandEndPoints(VS) | ~Vertices.AllStrandEndPoints(VE)
        BridgeConnectionType = 'EndPointToMidPoint';
    else
        BridgeConnectionType = 'EndPointToJunctionPoint';
    end
end
