function [VS,VE] = GetClosestVSVEIndices(BridgingStrand,Vertices,Strands)

VSxyz = BridgingStrand(1,:);
VExyz = BridgingStrand(end,:);

VSdists = sqrt(sum((Vertices.AllVerts - repmat(VSxyz,size(Vertices.AllVerts,1),1)).^2,2));
[VSd] = min(VSdists);
VSINDs = find(VSdists == VSd);
if numel(VSINDs)==1
    VS = VSINDs;
else
    VS = PreferJunctionPoint(VSINDs,Vertices,Strands);
end

VEdists = sqrt(sum((Vertices.AllVerts - repmat(VExyz,size(Vertices.AllVerts,1),1)).^2,2));
[VEd] = min(VEdists);

VEINDs = find(VEdists == VEd);
if numel(VEINDs)==1
    VE = VEINDs;
else
    VE = PreferJunctionPoint(VEINDs,Vertices,Strands);
end
