function done = MakeTifFromMat(matfnamein,tiffnameout)

done = 0;

% Build .tif image (for streaming) from .mat file
try
    load(matfnamein,'tiledStack','-mat');
    tSprops = whos('tiledStack');
    imwrite(tiledStack(:,:,1),tiffnameout,'tif','writemode','overwrite');
    for z = 2:tSprops.size(3)
        imwrite(tiledStack(:,:,z),tiffnameout,'tif','writemode','append');
    end
catch
    try
        load(matfnamein,'centerLineMask','-mat');
        tSprops = whos('centerLineMask');
        imwrite(uint8(255*centerLineMask(:,:,1)),tiffnameout,'tif','writemode','overwrite');
        for z = 2:tSprops.size(3)
            imwrite(uint8(255*centerLineMask(:,:,z)),tiffnameout,'tif','writemode','append');
        end
    catch
        load(matfnamein,'VascMask','-mat');
        tSprops = whos('VascMask');
        imwrite(uint8(255*VascMask(:,:,1)),tiffnameout,'tif','writemode','overwrite');
        for z = 2:tSprops.size(3)
            imwrite(uint8(255*VascMask(:,:,z)),tiffnameout,'tif','writemode','append');
        end
    end
end

done = 1;
