function V = PreferJunctionPoint(VINDs,Vertices,Strands)

try
    % disp('make sure to pick the V in VINDs that corresponds to a strand-indexed junction/endpoint if possible');
    AreJunctions = Vertices.JunctionPoints(VINDs)>0;
    if ~any(AreJunctions)
        V = VINDs(end); % take the last entry in the list if
    else
        V = VINDs(AreJunctions);
        V = V(end); % take the first entry in the list if multiple junctions
    end
catch
    disp('cant get junction point')
    keyboard;
end
