function h2Lines = jk_amira2mat_displayLabeledStrands(strandSet)

%Copyright 2008 P.Blinder, J.Kaufhold

% This file is part of ThresholdRelaxationAlgorithmV0.1
% 
%     ThresholdRelaxationAlgorithmV0.1 is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     ThresholdRelaxationAlgorithmV0.1 is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with ThresholdRelaxationAlgorithmV0.1.  If not, see <http://www.gnu.org/licenses/>.

%figure('color','w','name','Labeled vasculature')
hold on
nLines = numel(strandSet.strandSetInfo);
h2Lines = zeros(nLines,1);
baseColor = [1 1 1];
%baseColor = [0 0 0];
% arteryColor = [.9 .1 .1];
% veinColor = [.1 .1 .9];
% unidColor = [.75 .75 .75];%[.1 .9 .1];

for ki = 1 : nLines
    h2Lines(ki) =   plot3(strandSet.strandData(strandSet.strandSetInfo(ki).ptr2coord,3)+1,...
        strandSet.strandData(strandSet.strandSetInfo(ki).ptr2coord,2)+1,...
        strandSet.strandData(strandSet.strandSetInfo(ki).ptr2coord,4)+1,'UserData',ki,...
        'Color',baseColor,'linewidth',2);
    plot3(strandSet.strandData(strandSet.strandSetInfo(ki).ptr2coord(1),3)+1,strandSet.strandData(strandSet.strandSetInfo(ki).ptr2coord(1),2)+1,strandSet.strandData(strandSet.strandSetInfo(ki).ptr2coord(1),4)+1,'ko');
    plot3(strandSet.strandData(strandSet.strandSetInfo(ki).ptr2coord(end),3)+1,strandSet.strandData(strandSet.strandSetInfo(ki).ptr2coord(end),2)+1,strandSet.strandData(strandSet.strandSetInfo(ki).ptr2coord(end),4)+1,'ko');
end % cycling line indices
% Pn(1)={'Color'};
% Pv=num2cell(repmat(arteryColor,numel(strandSet.arteryStrandIds),1),2);
% set(h2Lines(strandSet.arteryStrandIds),'LineWidth',1.5,...
%     Pn,Pv,'ButtonDownFcn','get(gco,''UserData'')');
% 
% Pv=num2cell(repmat(veinColor,numel(strandSet.veinStrandIds),1),2);
% set(h2Lines(strandSet.veinStrandIds),'LineWidth',3,...
%     Pn,Pv,'ButtonDownFcn','get(gco,''UserData'')');
% 
% if isfield(strandSet,'unidStrandIds')
%     Pv=num2cell(repmat(unidColor,numel(strandSet.unidStrandIds),1),2);
%     set(h2Lines(strandSet.unidStrandIds),'LineWidth',1.5,...
%         Pn,Pv,'ButtonDownFcn','get(gco,''UserData'')');
% end

view(3)