% zero edges (or add a layer of 0s to edges and adjust indexing later)
centerLineMask(:,:,1) = 0;
centerLineMask(:,:,end) = 0;
centerLineMask(:,1,:) = 0;
centerLineMask(:,end,:) = 0;
centerLineMask(1,:,:) = 0;
centerLineMask(end,:,:) = 0;

% find nonzero centerline point indices
centerlinePts = find(centerLineMask);
maskSize = size(centerLineMask);
clear CenterlineMask

%% Get the Strands and Vertices mutually compatibly indexed datastructure
[Strands,Vertices,AMCenterlines] =VectorizeBinaryCenterlineMask(centerlinePts,maskSize);