
rootFolder = 'O:\AOH\pbCO\VidaSuiteProcessing';
rootName = 'pbCO';
firstZ = 1; 
lastZ = 25;
startC = 2;
stopC = 5;
startR = 2;
stopR = 5;
myThresh = 1000;

placeCounter = 0;
for c = startC:stopC
    for r = startR:stopR
        placeCounter = placeCounter+1;
        for k = firstZ:lastZ-1
            za = k;
            zb = k+1;
            CRstr = ['-C',num2str(c,'%02d'),'-R',num2str(r,'%02d')];

% % %             %for mat files
            fileName1 = [rootFolder,'\ImageStack-',rootName,'-Z',num2str(za,'%02d'),...
                CRstr,'\ProcessedData\VascSegFiles\',rootName,'-Z',num2str(za,'%02d'),...
                CRstr,'-Stacked-FITC-RawMask.mat'];
            fileName2 = [rootFolder,'\ImageStack-',rootName,'-Z',num2str(zb,'%02d'),...
                CRstr,'\ProcessedData\VascSegFiles\',rootName,'-Z',num2str(zb,'%02d'),...
                CRstr,'-Stacked-FITC-RawMask.mat'];
            load(fileName1);
            vascBlockRawMask = struct2mask(vascBlockRawMask);
            f1 = vascBlockRawMask(21:221,21:221,:);
            z1 = squeeze(sum(f1,1));
            % figure(1);plot(z1)
            figure(11);imagesc(squeeze(sum(f1,1)));
            %---
            load(fileName2);
            vascBlockRawMask = struct2mask(vascBlockRawMask);
            f2 = vascBlockRawMask(21:221,21:221,:);
            z2 = squeeze(sum(f2,1));
            % figure(2);plot(z2);
            figure(12);imagesc(squeeze(sum(f2,1)));

% % %             for tif files
% % % %                         fileName1 = [rootFolder,'\',rootName,'-Z',num2str(za,'%02d'),CRstr,'-Ch3.tif'];
% % % %                         fileName2 = [rootFolder,'\',rootName,'-Z',num2str(zb,'%02d'),CRstr,'-Ch3.tif'];
% % % %                         q1 = loadmovie(fileName1);
% % % %                         q2 = loadmovie(fileName2);
% % % %                         f1 = q1(21:221,21:221,:)>myThresh;
% % % %                         f2 = q2(21:221,21:221,:)>myThresh;
% % % %                         z1 = squeeze(sum(f1,1));
% % % %                         z2 = squeeze(sum(f2,1));
% %             figure(11);imagesc(squeeze(sum(f1,1)));
% %             figure(12);imagesc(squeeze(sum(f2,1)));


            w1 = z1(:,41:end);
            w2 = z2(:,41:end);
            w1n = w1-mean(w1(:));
            w2n = w2-mean(w2(:));


            shiftVal = [0:size(w1,2)];
            for q = 1:length(shiftVal);
                w2s = circshift(w2n,[0,shiftVal(q)]);
                corrVal(q) = sum(sum((w2s.*w1n)));
            end
            figure(99);plot(corrVal)
            pause(0.1)
            [maxVal,maxPos] = max(corrVal);
            offset(placeCounter,k) = maxPos;

        end%for k
    end%for r
end %for c

figure(101);plot(rand(size(offset'))+offset','.')
cutOffset = offset(:,firstZ:lastZ-1);
zRange = [firstZ+1:lastZ];
variableZBlockStepSize = median(cutOffset,1);
mystd = std(cutOffset,1);
figure(102);plot(zRange,variableZBlockStepSize,'b-');
hold on
plot(zRange,variableZBlockStepSize-mystd,'r-');
plot(zRange,variableZBlockStepSize+mystd,'r-');
hold off

figure(103);plot(offset' + rand(size(offset')),'r.');


