function outputLine = MaxLineDistanceToBlack(inputLine)

outputLine = repmat(uint8(0),size(inputLine));
diffLine = diff(inputLine);
f1 = find(diffLine==1);
f2 = find(diffLine==-1);
for segmentIter = 1:length(f1),
    s1 = f1(segmentIter);
    s2 = f2(segmentIter);
    for pixelIter = s1:s2
        pixelValue = max(s2-pixelIter+1,pixelIter-s1+1);
        outputLine(pixelIter) = pixelValue;    
    end
end
