function mat2tif(varargin)
nin = nargin;
if nin == 1,
    inputFileName = varargin{1};
else
    [fileName,pathName] = uigetfile('Select a mat file','*.mat');
    inputFileName = fullfile(pathName,fileName);
end

outputTifFileName = strrep(inputFileName,'.mat','.tif');
mydata = load(inputFileName);
myfields = fieldnames(mydata);
mydata = mydata.(myfields{1});
maketiff(mydata,outputTifFileName);


return
        