function UpgradeExperimentFile(varargin);


nin = nargin;
if nin > 0,
    experimentFileName = varargin{1};
    [pathName,fileRoot,fileExt] = fileparts(experimentFileName);
    fileName = [fileRoot,fileExt];
else
    [fileName,pathName] = uigetfile('*-Experiment.mat','Choose an experiment file to upgrade');
    experimentFileName = fullfile(pathName,fileName);
end
%-----
disp('Checking for necessary upgrades to experiment file');
tempStruct = load (experimentFileName);
if isfield(tempStruct,'experiment'),experiment = tempStruct.experiment;end
clear tempStruct

upgradedFlag = 0;
%----------
rootDataFolder = experiment.globalParameters.rootDataFolder ;
fileRootName = experiment.globalParameters.fileRootName;
rootCodeFolder = experiment.codeFolders.rootCodeFolder;
%----------
% % % backupFileName = fullfile(pathName,[fileRootName,'-ExperimentBackup-',datestr(now,'mmddyy_HHMMSS'),'.mat']);
% % % save (backupFileName,'experiment');
%----------
rootDataFolder = experiment.globalParameters.rootDataFolder ;
fileRootName = experiment.globalParameters.fileRootName;
rootCodeFolder = experiment.codeFolders.rootCodeFolder;
%----------
upgradeDateString = ['upgraded',datestr(now,'mmddyy_HHMMSS')];
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------

% % % %-----Added 05/04/09
% % % if ~isfield(experiment.vascSegParameters.vascEnhancedBinarizeParameters,'maxDilationCycles'),
% % %     experiment.vascSegParameters.vascEnhancedBinarizeParameters.maxDilationCycles = 10; 
% % %     upgradedFlag = 1; 
% % %     disp('experiment.vascSegParameters.vascEnhancedBinarizeParameters.maxDilationCycles = 10; added')
% % % end


%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------

if upgradedFlag == 1,
    saveSize = (getfield(whos('experiment'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(experimentFileName,'experiment',scs);
    disp(['Experiment File Upgrade Completed : ',datestr(now)]);
else
    disp('No upgrades necessary at this time');
end






