function newFileName = VidaSuiteUpdateFileNames(tempMainFolderName,oldFileName)
%convert file names for vida suite mask - needed when moving location of processed folders 
%Pablo - 11/Jun/2009

%determine if file separator matches current platform
if isempty(strfind(filesep,oldFileName))
        convertToCurrentPlatform = 1;
else
        convertToCurrentPlatform = 0;
end
    
%if required, convert  to current platform path naming style 
if convertToCurrentPlatform
    if  ~isempty(strfind(oldFileName,'\'))
       oldFileName =  regexprep(oldFileName,'\',filesep); %win to lin
    else
        oldFileName =  regexprep(oldFileName,'/',filesep); %win to lin;
    end
end %converting to platform naming

[oldPathStr,name,ext] = fileparts(oldFileName);
newFileName = fullfile(tempMainFolderName,[name,ext]);
    
    
