function outExp = VidaSkipChannelSub(inExp)
%-----
processedDataFolder = inExp.globalParameters.processedDataFolder;
%-----
channelSubtractionSequence = inExp.channelSubParameters.channelSubtractionSequence;
%-----
disp('You have opted to skip Channel Subtraction');
numSequences = size(channelSubtractionSequence,1);
for sequenceIter = 1:numSequences,
    disp(['Renaming Files, sequence ',num2str(sequenceIter),' of ',num2str(numSequences),': ',datestr(now,'mm/dd/yy HH:MM:SS')]);
    %pull out the strings for the files to be analyzed in this sequence
    mainFileString = channelSubtractionSequence{sequenceIter,1};
    outputFileString = channelSubtractionSequence{sequenceIter,3};
    mainFileQueryString = [mainFileString,'-*'];
    originalFileQuery = dir(fullfile(processedDataFolder,mainFileQueryString));
    numFiles = size(originalFileQuery,1);
    for fileIter = 1:numFiles,
        disp(['File',num2str(fileIter),' of ',num2str(numFiles),': ',datestr(now)]);
        fullOriginalFileName = fullfile(processedDataFolder,originalFileQuery(1).name);
        ouputFileName = regexprep(originalFileQuery(1).name,mainFileString,outputFileString);
        fullOutputFileName = fullfile(processedDataFolder,ouputFileName);
            dosCommand = ['move "',fullOriginalFileName,'" "',fullOutputFileName,'"'];
            dos(dosCommand); 
            % % % movefile(fullOriginalFileName,fullOutputFileName);s
    end%for fileIter = 1:numFiles,
end%for sequenceIter = 1:numSequences,

outExp = inExp;
outExp.channelSubParameters.subtractionFactorList = 0;
outExp.channelSubParameters.outputFileNameList = {'Skipped'};
%-----
nullCompletionDate = '01-Jan-1900 00:00:00';
outExp.completionDates.channelSubCompletionDate = nullCompletionDate;
outExp.progressFlags.channelSubCompleted = 1;
%-----
return






