

% % cd('F:\Phil\AOH_Datasets\pbDB\pbDBVector\VectorProjectFolder')
% % myMask = loadmovie('PhilBarrelMask.tif');
% % currentMask = loadmovie('pbDB-LargestSubgraph-QCurrentSizeMaskDiv3.tif');


maskChoice = 22;
edgeMask = (imdilate(myMask==maskChoice,ones(3,3,3))-(myMask>0))>0;
bwMask = zeros(size(edgeMask))+Inf;
dilatedMask = imdilate(myMask==maskChoice,ones(3,3,3));


for k = 1:size(edgeMask,3);
    myFrame = edgeMask(:,:,k);
    if max(myFrame(:))>0,
        filtFrame = imfilter(double(myFrame),ones(3,3))>6;
        myFrame(filtFrame) = 0;
        edgeMask(:,:,k) = myFrame;
    end%if max(myFrame(:))>0,

end

    

for k = 1:size(edgeMask,3);
    myFrame = edgeMask(:,:,k);
    if max(myFrame(:))>0,
        bwFrame = bwdist(myFrame);
        bwMask(:,:,k) = min(bwFrame,bwMask(:,:,k));
    end
end


bwMask(dilatedMask>0) = -1*bwMask(dilatedMask>0);



for k = 1:size(edgeMask,3);
    myFrame = edgeMask(:,:,k);
    if max(myFrame(:))>0,
        bwFrame = bwdist(myFrame);
        bwMask(:,:,k) = min(bwFrame,bwMask(:,:,k));
    end
end


% % bwMask = flipdim(bwMask,1);




origDistList = -40:30;
iVal = zeros(size(origDistList));
numPixels = zeros(size(origDistList));

for frameIter = 160:190,
    distList = origDistList;
    bwFrame = int16(bwMask(:,:,frameIter));
    iFrame = currentMask(:,:,frameIter);

    
    bwFrame = min(300,bwFrame);
% %     distList = min(bwFrame(:)) : max(bwFrame(:));


    maxDist = max(bwFrame(:));
    for k = 1:numel(distList),
        q = find(bwFrame==distList(k));
        numPixels(k) = numPixels(k) + numel(q);
        iVal(k) = iVal(k) + sum(iFrame(q));
    end%for k = 1:numel(distList),
    w = iVal./numPixels;
    figure(1);plot(distList(1:end-1),numPixels(1:end-1)./numPixels(41),'b-');hold on
    figure(1);plot(distList(1:end-1),iVal(1:end-1)./iVal(41),'r-');hold off
% % %      figure(1);plot(distList(1:end-1),numPixels(1:end-1)./max(numPixels(1:end-1)),'b-');hold on
% % %     figure(1);plot(distList(1:end-1),iVal(1:end-1)./max(iVal(1:end-1)),'r-');hold off
    figure(2);logpic(bwFrame);
    figure(3);plot(distList(1:end-1),w(1:end-1),'r.')
%     pause
end%for frameIter = 150:200,


