% % mypics = loadmovie;

divFactor = 3;
L = bwlabeln(mypics);
numBarrels = max(L(:));
maskSize = size(mypics);


for barrelIter = 1:numBarrels,
    thisMask = L==barrelIter;
    [by,bx,bz] = ind2sub(maskSize,find(thisMask));
    minZ = min(bz);
    maxZ = max(bz);
    pointList = [];
    for zIter = minZ:maxZ,
        thisFrame = thisMask(:,:,zIter);
        frameL = bwlabel(thisFrame);
        myprop = regionprops(frameL,'Extrema');
        pointList = [pointList;[fliplr(myprop.Extrema),repmat(zIter,[8,1])]];
    end
    barrels{barrelIter} = pointList*divFactor;
end
        
    
    
    
    
