function outputParameters=VidaMergeCellCentroids(inputParameters)

fileRootName = inputParameters.fileRootName;
intermediateResultsFolder = inputParameters.intermediateResultsFolder;
cellCentroidFilesFolder = inputParameters.cellCentroidFilesFolder;
lastRerunStartDateNum = inputParameters.lastRerunStartDateNum;
%-----
cclist=inputParameters.cellCentroidList;
mergedist=inputParameters.cellCentroidMergeDistance;

disp(['merging centroids too near to each other : ',datestr(now)]);
mergedCellCentroidFileName = fullfile(cellCentroidFilesFolder,['MergedCellCentroids.mat']);
%-----
overwriteFlag = 0;
fileExistsFlag = 0;
if exist(mergedCellCentroidFileName,'file'),
    fileExistsFlag = 1;
    fileProps = dir(mergedCellCentroidFileName);
    fileDateNum = datenum(fileProps.date);
    if fileDateNum < lastRerunStartDateNum,
        overwriteFlag = 1;
    end%if fileDateNum < lastRerunStartDateNum,
end%if exist(currentCentroidBlockFileName,'file'),
%---
if and(fileExistsFlag==1,overwriteFlag==0),
    disp('...previously computed');
    load(mergedCellCentroidFileName,'mergedcclist');
else%if and(fileExistsFlag==1,overwriteFlag==0),
    mergedcclist = VidaMergeCellCentroidsCore(cclist,mergedist);
end%if-else and(fileExistsFlag==1,overwriteFlag==0),  
    saveSize = (getfield(whos('mergedcclist'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(mergedCellCentroidFileName,'mergedcclist',scs);

outputParameters = inputParameters;
outputParameters.mergedCellCentroidList=mergedcclist;

return


