function [inbounds] = boundscheck(selectedBB,absolutebounds)

%Copyright 2008 J.Kaufhold

% This file is part of ThresholdRelaxationAlgorithmV0.1
% 
%     ThresholdRelaxationAlgorithmV0.1 is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     ThresholdRelaxationAlgorithmV0.1 is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with ThresholdRelaxationAlgorithmV0.1.  If not, see <http://www.gnu.org/licenses/>.

selectedBB = double(selectedBB);
absolutebounds = double(absolutebounds);

inbounds = selectedBB; % preallocate
inbounds(1:2:5) = max(inbounds(1:2:5),absolutebounds(1:3));
inbounds(2:2:6) = min(inbounds(2:2:6),absolutebounds(4:6));
