function volBB = getstrandBB2(allstrandpts,margin)

%Copyright 2008 J.Kaufhold

% This file is part of ThresholdRelaxationAlgorithmV0.1
% 
%     ThresholdRelaxationAlgorithmV0.1 is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     ThresholdRelaxationAlgorithmV0.1 is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with ThresholdRelaxationAlgorithmV0.1.  If not, see <http://www.gnu.org/licenses/>.

% get bounding box minima
BBminx2=min(allstrandpts(:,2))-margin;
BBminx1=min(allstrandpts(:,1))-margin;
BBminx3=min(allstrandpts(:,3))-margin;
% get bounding box ranges
BBmaxx2=max(allstrandpts(:,2))+margin;
BBmaxx1=max(allstrandpts(:,1))+margin;
BBmaxx3=max(allstrandpts(:,3))+margin;

volBB = [BBminx1 BBmaxx1 BBminx2 BBmaxx2 BBminx3 BBmaxx3];
