function vectorProject = ConvertToCellStorage(vectorProject)
disp('Converting To Cell Storage...');
StrandIndices = full(vectorProject.vectorizedStructure.Vertices.StrandIndices);
numPoints = size(StrandIndices,1);
cellStrandIndices = {};
cellStrandIndices{numPoints} = [];
% % NotePointerList = vectorProject.vectorizedStructure.Vertices.NotePointers;
% % NoteList = vectorProject.vectorizedStructure.Vertices.NoteList;
tic
% % AllNotes{numPoints} = '';
for pointIter = 1:numPoints,
    currentStrandIndices = StrandIndices(pointIter,:);
    nonZeroStrandIndices = currentStrandIndices(currentStrandIndices~=0);
    cellStrandIndices{pointIter} = nonZeroStrandIndices;
    %---
% %     if NotePointerList(pointIter)>0,
% %         AllNotes{pointIter} = NoteList{NotePointerList(pointIter)};
% %     end%if-else NotePointerList(pointIter)==0,
end%for pointIter = 1:numPoints,


toc
vectorProject.vectorizedStructure.Vertices.StrandIndices = cellStrandIndices;
% % vectorProject.vectorizedStructure.Vertices.AllNotes = AllNotes;
% % vectorProject.vectorizedStructure.Vertices.NotePointers = [];
% % vectorProject.vectorizedStructure.Vertices.NoteList = {};
