function mygaussian = gaussian_1d(circle_size1,gaussian_size1);
%function mygaussian = gaussian_1d(circle_size1,gaussian_size1);
%   the gaussian size is the distance from the peak to the 1/e point(0.367)
%   for a gaussian_size = 10, you get a gaussian with:
%       FWHM = 16.6
%       Stdev = 7.07
        myhalf = floor(circle_size1/2);
        x = [-myhalf:myhalf];
        mycircle = x;
        mygaussian = exp(-1*mycircle.^2/gaussian_size1.^2);
return
        