


numStrands = numel(gds.Strands);
for strandIter = 1:numStrands,
    strandID = strandIter;
    thisStrand = gds.Strands(strandID);
    iv = thisStrand.InteriorVertices;
    av = gds.Vertices.AllVerts(iv,:);
    numPoints = numel(iv);
    pointSep = zeros(100,1);
    for pointIter = 1:numPoints-1;
        pointDist = av(pointIter,:) - av(pointIter+1,:);
        pointSep(pointIter) = sqrt(sum(pointDist.^2));
    end%for pointIter
    strandLengthList(strandID) = sum(pointSep)+1;
    strandNumPointsList(strandID) = numPoints;
end%for strandIter
    