
hematocrit = 0.45;
radiusPower = 4;

D = [0.1:0.1:20];
alpha = 4./(1+exp(-0.593*(D-6.74)));    
viscosity = 1 + ((exp(hematocrit*alpha)-1) .* (110*exp(-1.424*D) + 3 - 3.45*exp(-0.035*D)) ./ (exp(0.45*alpha)-1));
strandLength = 100;
conductance = (D./2).^radiusPower ./ (viscosity.*strandLength);



figure(311);plot(D,alpha,'r-');xlabel('Diameter');ylabel('alpha');
figure(312);plot(D,viscosity,'g-');xlabel('Diameter');ylabel('viscosity');
figure(313);semilogy(D,1./conductance,'b-');xlabel('Diameter');ylabel('resistance');



