function sidebysideRGB;

[fileName1,pathName1] = uigetfile('*.tif');
[fileName2,pathName2] = uigetfile('*.tif');

cd(pathName1);
mypics1 = loadmovie(fileName1);
cd(pathName2);
mypics2 = loadmovie(fileName2);

[y1,x1,z1,d1] = size(mypics1);
[y2,x2,z2,d2] = size(mypics2);
yout = max(y1,y2);
xout = x1+x2;
zout = max(z1,z2);
dout = max(d1,d2);

outMatrix = zeros(yout,xout,zout,dout);
outMatrix(:,1:x1,:,:) = mypics1;
outMatrix(:,x1+1:xout,:,:) = mypics2;
outMatrix(:,x1,:,:) = max(outMatrix(:));

if dout == 1,
    maketiff(outMatrix,'SideBySide.tif');
else
    maketiffrgb(outMatrix,'SideBySideRGB.tif');
end