cd('F:\Phil\ForFromPeople\2009 - AwakeStacksFromPat\052909')
load('F:\Phil\ForFromPeople\2009 - AwakeStacksFromPat\052909\awakeHist.mat')
z1Toz5 = [z1,z2,z3,z4,z5];
x = [0:0.5:15];
hAwake = hist(z1Toz5,x)./numel(z1Toz5);
figure(1);bar(x,hAwake);
figure(2);bar(x,hAwake);
figure(3);bar(x,hAwake);
figure(4);bar(x,hAwake);



D = [0.1:0.1:15];

    conductanceMultiplier = 1e9;
    radiusPower = 4;%Hardcode
    hematocrit = 0.45;%Hardcode
        alpha = 4./(1+exp(-0.593*(D-6.74)));    
        viscosity = 1 + ((exp(hematocrit*alpha)-1) .* (110*exp(-1.424*D) + 3 - 3.45*exp(-0.035*D)) ./ (exp(0.45*alpha)-1));
        strandLength = 100;
        strandConductanceList = conductanceMultiplier * (D/2).^radiusPower ./ (viscosity.*strandLength);
        conductanceFormula = 'D = (thisStrandRadius+radiusAddition)*2 ; strandConductance = conductanceMultiplier*((D/2)^rp)/(v*strandLength)  ;  1 + ((exp(hematocrit*alpha)-1) .* (110*exp(-1.424*D) + 3 - 3.45*exp(-0.035*D)) ./ (exp(0.45*alpha)-1)) ;  alpha = 4./(1+exp(-0.593*(D-6.74)))  ;    D = thisStrandRadius*2';
 
figure(1);hold on
figure(1);plot(D,log(strandConductanceList)/100,'r-');hold off
set(gca,'YLim',[0 0.3],'XLim',[0,15]);
xlabel('Vessel Diameter');ylabel('In Vivo Distribution , log(Vessel Conductance)')




figure(2);hold on
figure(2);plot(D,(strandConductanceList)/1e10,'r-');hold off
set(gca,'YLim',[0 0.3],'XLim',[0,15]);
xlabel('Vessel Diameter');ylabel('In Vivo Distribution , Vessel Conductance')

strandResistanceList = 1./strandConductanceList;

figure(3);hold on
figure(3);plot(D,(0.5e7*strandResistanceList),'r-');hold off
set(gca,'YLim',[0 0.3],'XLim',[0,15]);
xlabel('Vessel Diameter');ylabel('In Vivo Distribution , Vessel Resistance')

% % figure(4);hold on
% % figure(4);plot(D,log(1e8*strandResistanceList),'r-');hold off
% % % set(gca,'YLim',[0 0.3],'XLim',[0,15]);
% % xlabel('Vessel Diameter');ylabel('In Vivo Distribution , log(Vessel Resistance)')
