
numStrands = numel(strands);
strandZList = vs.strandMidYXZList(:,3);
shallowStrandFlag = (strandZList <150);
paFlag = zeros(numStrands,1);
pvFlag = zeros(numStrands,1);
paFlag(vs.allPlungingArterioleList) = 1;
pvFlag(vs.allPlungingVenuleList) = 1;



% strandCurrentList = [vs.Strands(:).strandCurrent];
strandCurrentList = vs.strandCurrentList;
strandRadiusList = vs.effectiveStrandRadiusList;


allCurrentList = strandCurrentList(shallowStrandFlag);
allRadiusList = strandRadiusList(shallowStrandFlag);



paCurrentList = strandCurrentList(and(paFlag,shallowStrandFlag));
pvCurrentList = strandCurrentList(and(pvFlag,shallowStrandFlag));
paRadiusList = strandRadiusList(and(paFlag,shallowStrandFlag));
pvRadiusList = strandRadiusList(and(pvFlag,shallowStrandFlag));


figure(2);loglog(allRadiusList*2,(allCurrentList/1e8),'k.');hold on
figure(2);loglog(pvRadiusList*2,(pvCurrentList/1e8),'b.');hold on
figure(2);loglog(paRadiusList*2,(paCurrentList/1e8),'r.');hold off






