%First, cd to the appropriate folder and load a vectorProject

addRadius = 1

ar = vectorProject.vectorizedStructure.Vertices.AllRadii;
vectorProject.vectorizedStructure.Vertices.AllRadii = ar+addRadius;
rootName = vectorProject.vectorProjectRootName;

firstDashPos = findstr(rootName,'-');
if isempty(firstDashPos),
    firstDashPos = numel(rootName)+1;
end%if isempty

firstDashPos = firstDashPos(1);
baseRoot = rootName(1:firstDashPos-1);
addRoot = rootName(firstDashPos:end);


if addRadius >0,
    newName = [baseRoot,'-adjRadiusPlus',num2str(addRadius),addRoot];
else    
    newName = [baseRoot,'-adjRadiusMinus',num2str(addRadius),addRoot];
end
newName = regexprep(newName,'\.','p');
vectorProject.vectorProjectRootName = newName;
vectorProjectName = [newName,'-VectorProject.mat'];
save(vectorProjectName,'vectorProject');



