%%
'yuck'
'yuck'

pause
pause
pause
pause
pause
%%

% cd('F:\Phil\AOH_VectorProjects\pbAV\VectorProjectFolder\FlowProject000001')
% load('F:\Phil\AOH_VectorProjects\pbAV\VectorProjectFolder\FlowProject000001\FVFile_2011_06_13-140934.mat')
% load('F:\Phil\AOH_VectorProjects\pbAV\VectorProjectFolder\BarrelMaskDiv3.mat')
% 
% clear barrelCounter

vectorProject = allProject.db;
vs = vectorProject.vectorizedStructure;
maskSize = vs.maskSize;
numStrands = numel(vs.Strands);


strandVoltageList = [vs.Strands(:).MedianVoltage]';
strandZList = [vs.strandMidYXZList(:,3)];

zSortData = [strandZList, strandVoltageList];
zSortData = sortrows(zSortData,1);


figure(1);plot(strandZList,strandVoltageList,'r.');


filtSize = 1000,
meanZ = zeros(numStrands-filtSize,1);
meanV = zeros(numStrands-filtSize,1);
stdV = zeros(numStrands-filtSize,1);

for kk = 1:numStrands-filtSize,
    meanZ(kk) = mean(zSortData(kk:kk+filtSize,1));
    meanV(kk) = mean(zSortData(kk:kk+filtSize,2));
    stdV(kk) = std(zSortData(kk:kk+filtSize,2));
end

figure(2);plot(meanZ,meanV,'g-'); hold on
figure(2);plot(meanZ,stdV,'r-');hold off

%%
allZList = vs.Vertices.AllVerts(:,3);
z = [0:10:1500];
hz = hist(allZList,z);
figure(3);plot(z,hz,'k-');


%%

strandCurrentList = [strands(:).strandCurrent];
strandVoltageList = [strands(:).MedianVoltage];

figure(4);plot(strandVoltageList,log(abs(strandCurrentList)),'r.');
figure(5);plot(strandZList,log(abs(strandCurrentList)),'r.');




%%
%Calculate distance from artery to vein versus depth
vs = vectorProject.vectorizedStructure;
maskSize = vs.maskSize;
numStrands = numel(vs.Strands);
strands = vs.Strands;

allPlungingArterioleList = vs.allPlungingArterioleList;
allPlungingVenuleList = vs.allPlungingVenuleList;

numPA = numel(allPlungingArterioleList);


for paIter = 1:numPA,
    thisPAID = allPlungingArterioleList(paIter);
    thisPA = strands(thisPAID);
    startZ(paIter) = thisPA.YXZLimits(3,2);
    sumDist = 0;
    goFlag = 1;
    thisStrandID = thisPAID;
    thisStrand = thisPA;
    usedStrandList = [];
    while goFlag,
        usedStrandList = [usedStrandList,thisStrandID];
        sumDist = sumDist + numel(thisStrand.StartToEndIndices);
        nextStrandList = [thisStrand.StartVertexNeighborStrands,thisStrand.EndVertexNeighborStrands];
        nextStrandList = nextStrandList(~ismember(nextStrandList,allPlungingArterioleList));
        nextStrandList = nextStrandList(~ismember(nextStrandList,thisStrandID));
        nextStrandList = nextStrandList(~ismember(nextStrandList,usedStrandList));
        if isempty(nextStrandList),break;end
        nextStrandVoltages = [strands(nextStrandList).MedianVoltage];
        [vMin,vMinPos] = min(nextStrandVoltages);
        nextStrandID = nextStrandList(vMinPos);
        thisStrandID = nextStrandID;
        thisStrand = strands(thisStrandID);
        if ismember(thisStrandID,allPlungingVenuleList),
            goFlag = 0;
        end%if ismember
    end%while goFlag
    avDist(paIter) = sumDist;
    stopZ(paIter) = thisStrand.YXZLimits(3,2);
end%for paIter...


figure(1);plot(startZ,avDist,'r.')
figure(2);plot(stopZ,avDist,'r.')









