
oldProject = avOld;
newProject = avNew;


%%
maskSize = newProject.maskSize;
numFrames = maskSize(1);
numAve = 25;

for frameIter = 1:numFrames-numAve;
    k1 = frameIter;
    k2 = frameIter+numAve;
    ccOld = oldProject.vectorizedStructure.Vertices.AllVerts;
    ccNew = newProject.vectorizedStructure.Vertices.AllVerts;
    f1Old = and(ccOld(:,1)>=k1,ccOld(:,1)<=k2);
    f1New = and(ccNew(:,1)>=k1,ccNew(:,1)<=k2);
    figure(1); pOld = plot(ccOld(f1Old,2),-1*ccOld(f1Old,3),'r.');hold on;
    set(pOld,'MarkerSize',2);
    figure(1); plot([0,maskSize(2)],[0,-1*maskSize(3)],'w.');
    figure(1); pNew = plot(ccNew(f1New,2),-1*ccNew(f1New,3),'g.');hold off;
    set(pOld,'MarkerSize',1);
    title(['Frames ',num2str(k1),' to ',num2str(k2)]);
    pause
end
    



%%

coord = [338,-352];
frame = 111;

f1 = and(ccOld(:,1)>=frame,ccOld(:,1)<=frame+numAve);
f2 = (ccOld(:,2)==coord(1));
f3 = (ccOld(:,3)==abs(coord(2)));
ff = find(and(f1,and(f2,f3)));
vertID = ff(1)
strandID = oldProject.vectorizedStructure.Vertices.StrandIndices(vertID,1)

%%
vertexIndex = 221804;
coord = oldProject.vectorizedStructure.Vertices.AllVerts(vertexIndex,:)
boxSize = 50;
y1 = coord(1)-boxSize; y2 = coord(1)+boxSize;
x1 = coord(2)-boxSize; x2 = coord(2)+boxSize;
z1 = coord(3)-boxSize; z2 = coord(3)+boxSize;

f1 = and(ccOld(:,1)>=y1,ccOld(:,1)<=y2);
f2 = and(ccOld(:,2)>=x1,ccOld(:,2)<=x2);
f3 = and(ccOld(:,3)>=z1,ccOld(:,3)<=z2);
ff = find(and(f1,and(f2,f3)));
subCC = ccOld(ff,:);
figure(2);plot3([y1,y2],[x1,x2],[-z1,-z2],'w.');hold on;
figure(2);plot3(subCC(:,1),subCC(:,2),-1*subCC(:,3),'g.');hold off
