

numStrands = numel(gds.Strands);
meanYXZList = zeros(numStrands,3);
for strandIter = 1:numStrands,
    thisStrand = gds.Strands(strandIter);
    YXZLimits = thisStrand.YXZLimits;
    meanYXZ = mean(YXZLimits,2);
    meanYXZList(strandIter,:) = meanYXZ';
end
    
    
baseStrandIDList = gds.baseStrandIDList;
numBases = numel(baseStrandIDList);
meanDiameterList = [];
for baseIter = 1:numBases,
    thisBaseStrandID = baseStrandIDList(baseIter);
    thisBaseStrand = gds.Strands(baseIter);
    baseY = meanYXZList(thisBaseStrandID,1);
    baseX = meanYXZList(thisBaseStrandID,2);
    baseZ = meanYXZList(thisBaseStrandID,3);
    dy = meanYXZList(:,1)-baseY;
    dx = meanYXZList(:,2)-baseX;
    dr = sqrt(dy.^2 + dx.^2);

    r1 = 50;
    r2 = 100;
    
    f1 = find(and(dr>r1, dr<r2));
    dsbl = gds.downstreamBranchList(:,baseIter);
    subBranchList = dsbl(f1);
    subBranchList = subBranchList(subBranchList~=inf);
    meanBranchList(baseIter) = mean(subBranchList);
end%for baseIter = 1:numBases,
w = meanBranchList(~isnan(meanBranchList));
mean(w) 
    
   
    
    
    dsbl = gds.downstreamBranchList(:,baseIter);
    for branchIter = 1:10,
        f1 = find(dsbl==branchIter);
        f2 = [];
        for kk = 1:numel(f1);
            thisStrandID = f1(kk);
            dsbl2 = gds.downstreamBranchList(thisStrandID,:);
            if min(dsbl2) == branchIter,
                f2 = [f2,thisStrandID];
            end%if min(dsbl2) == branchIter),
        end%for kk = 1:numel(f1);
        meanY = meanYXZList(f2,1);
        meanX = meanYXZList(f2,2);
        meanZ = meanYXZList(f2,3);
        dr = sqrt((meanY-baseY).^2 + (meanX-baseX).^2);
        
maxZ = 1000;
dr = dr(meanZ<maxZ);
        


        
        meanDiameterList(baseIter,branchIter) = 2*mean(dr);
    end%for branchIter = 1:10,
end%for baseIter = 1:numBases;
        
        
for branchIter = 1:10,
    subList = meanDiameterList(:,branchIter);
    subList2 = subList(~isnan(subList));
    meanD(branchIter) = mean(subList2);
end
disp(meanD);

        











