% % fileTag = 'BasicSet';

% % fileTag = 'cutoff_3p5_75_fromBasic';

% % fileTag = 'cutoff_2p25_70_fromBasic';

% % fileTag = 'cutoff_2p5_70_fromBasic'

fileTag = 'cutoff_2p95_60_fromBasic'


mypics = loadmovie(['bwMask2_',fileTag,'.tif']);
mypics = mypics - 50;


% % mybarrels = loadmovie('philBarrelMask.tif');
% % mybarrels = max(mybarrels,[],3);


myColorSpace = GenerateColorSpace(40);
myColorSpace = myColorSpace([1:7,9,11,14:16],:);

z1 = 140;
z2 = 220;
numColors = 10;

numSets = max(mypics(:));
numRounds = floor(numSets/numColors);
numLeftOver = mod(numSets,numColors);

for qq = 0:numRounds-1,
    % % redFrame = zeros(size(mypics(:,:,1)),'uint8');
    % % greenFrame = zeros(size(mypics(:,:,1)),'uint8');
    % % blueFrame = zeros(size(mypics(:,:,1)),'uint8');
    redFrame = uint8(mybarrels/4);
    greenFrame = uint8(mybarrels/4);
    blueFrame = uint8(mybarrels/4);
    for kk = 1:numColors,
       myTrace = mypics==kk*numRounds - qq;
       myFrame = uint8(max(myTrace(:,:,z1:z2),[],3));
       myColorVector = myColorSpace(kk,:);
       redFrame = redFrame + uint8(double(myFrame).*myColorVector(1)*255);
       greenFrame = greenFrame + uint8(double(myFrame).*myColorVector(2)*255);
       blueFrame = blueFrame + uint8(double(myFrame).*myColorVector(3)*255);
    end


    myRGB = zeros(size(mypics(:,:,1:3)),'uint8');
    myRGB(:,:,1) = redFrame;
    myRGB(:,:,2) = greenFrame;
    myRGB(:,:,3) = blueFrame;
    f = figure; imagesc(myRGB);
    fileName = ['subRGB',num2str(qq+1,'%02d'),'_',fileTag,'_',num2str(z1),'-',num2str(z2),'.tif'];
    imwrite(uint8(myRGB),fileName,'tiff','Compression','none');

end


redFrame = uint8(mybarrels/4);
greenFrame = uint8(mybarrels/4);
blueFrame = uint8(mybarrels/4);
for kk = 1:numLeftOver,
   myTrace = mypics== (kk+numRounds*numColors);
   myFrame = uint8(max(myTrace(:,:,z1:z2),[],3));
   myColorVector = myColorSpace(kk,:);
   redFrame = redFrame + uint8(double(myFrame).*myColorVector(1)*255);
   greenFrame = greenFrame + uint8(double(myFrame).*myColorVector(2)*255);
   blueFrame = blueFrame + uint8(double(myFrame).*myColorVector(3)*255);
end


myRGB = zeros(size(mypics(:,:,1:3)),'uint8');
myRGB(:,:,1) = redFrame;
myRGB(:,:,2) = greenFrame;
myRGB(:,:,3) = blueFrame;
f = figure; imagesc(myRGB);

    fileName = ['subRGB',num2str(qq+2,'%02d'),'_',fileTag,'_',num2str(z1),'-',num2str(z2),'.tif'];
imwrite(uint8(myRGB),fileName,'tiff','Compression','none');


% % % 
% % %     
% % %  for kk = 1:length(myColorSpace),
% % %         figure(4);p1 = plot(kk,kk,'ro');
% % %         set(p1,'Color',myColorSpace(kk,:));
% % %         set(p1,'MarkerFaceColor',myColorSpace(kk,:));
% % %         hold on
% % %  end  
% % % 
% % %     
% % %  
% % %      redFrame = uint8(mybarrels/4);
% % %     greenFrame = uint8(mybarrels/4);
% % %     blueFrame = uint8(mybarrels/4);
% % %     for kk = 1:40,
% % %        myFrame = mybarrels;
% % %        myFrame(:) = 0;
% % %        myFrame(kk*5: kk*5+5,:) = 1;
% % %        myColorVector = myColorSpace(kk,:);
% % %       redFrame = redFrame + uint8(double(myFrame).*myColorVector(1)*255);
% % %        greenFrame = greenFrame + uint8(double(myFrame).*myColorVector(2)*255);
% % %        blueFrame = blueFrame + uint8(double(myFrame).*myColorVector(3)*255);
% % %     end
% % %     
% % %     
% % %         myRGB = zeros(size(mypics(:,:,1:3)),'uint8');
% % %     myRGB(:,:,1) = redFrame;
% % %     myRGB(:,:,2) = greenFrame;
% % %     myRGB(:,:,3) = blueFrame;
% % % 
% % %     figure;imagesc(myRGB);
% % %     
% % %     
% % %     
% % %     