%%
'yuck'
'yuck'

pause
pause
pause
pause
pause
%%

% cd('F:\Phil\AOH_VectorProjects\pbAV\VectorProjectFolder\FlowProject000001')
% load('F:\Phil\AOH_VectorProjects\pbAV\VectorProjectFolder\FlowProject000001\FVFile_2011_06_13-140934.mat')
% load('F:\Phil\AOH_VectorProjects\pbAV\VectorProjectFolder\BarrelMaskDiv3.mat')
% 
% clear barrelCounter

vectorProject = allProject.db;
vs = vectorProject.vectorizedStructure;
maskSize = vs.maskSize;
numStrands = numel(vs.Strands);


strandVoltageList = [vs.Strands(:).MedianVoltage]';
strandZList = [vs.strandMidYXZList(:,3)];

zSortData = [strandZList, strandVoltageList];
zSortData = sortrows(zSortData,1);


figure(1);plot(strandZList,strandVoltageList,'r.');


filtSize = 1000,
meanZ = zeros(numStrands-filtSize,1);
meanV = zeros(numStrands-filtSize,1);
stdV = zeros(numStrands-filtSize,1);

for kk = 1:numStrands-filtSize,
    meanZ(kk) = mean(zSortData(kk:kk+filtSize,1));
    meanV(kk) = mean(zSortData(kk:kk+filtSize,2));
    stdV(kk) = std(zSortData(kk:kk+filtSize,2));
end

figure(2);plot(meanZ,meanV,'g-'); hold on
figure(2);plot(meanZ,stdV,'r-');hold off

%%
allZList = vs.Vertices.AllVerts(:,3);
z = [0:10:1500];
hz = hist(allZList,z);
figure(3);plot(z,hz,'k-');


%%

strandCurrentList = [strands(:).strandCurrent];
strandVoltageList = [strands(:).MedianVoltage];
strandVoltageDropList = abs([strands(:).VoltageDrop]);

figure(4);plot(strandVoltageList,log(abs(strandCurrentList)),'r.');
figure(5);plot(strandZList,log(abs(strandCurrentList)),'r.');
figure(6);plot(strandZList,strandVoltageDropList,'m.');



%%
%Calculate distance from artery to vein versus depth
vs = vectorProject.vectorizedStructure;
maskSize = vs.maskSize;
numStrands = numel(vs.Strands);
strands = vs.Strands;

allPlungingArterioleList = vs.allPlungingArterioleList;
allPlungingVenuleList = vs.allPlungingVenuleList;

numPA = numel(allPlungingArterioleList);
outletIDList = [];

for paIter = 1:numPA,
    thisPAID = allPlungingArterioleList(paIter);
    thisPA = strands(thisPAID);
    startZ(paIter) = thisPA.YXZLimits(3,2);
    sumDist = 0;
    goFlag = 1;
    thisStrandID = thisPAID;
    thisStrand = thisPA;
    usedStrandList = [];
    firstFlag = 1;
    while goFlag,
        usedStrandList = [usedStrandList,thisStrandID];
        sumDist = sumDist + numel(thisStrand.StartToEndIndices);
        nextStrandList = [thisStrand.StartVertexNeighborStrands,thisStrand.EndVertexNeighborStrands];
        nextStrandList = nextStrandList(~ismember(nextStrandList,allPlungingArterioleList));
        nextStrandList = nextStrandList(~ismember(nextStrandList,thisStrandID));
        nextStrandList = nextStrandList(~ismember(nextStrandList,usedStrandList));
        if isempty(nextStrandList),break;end
        nextStrandVoltages = [strands(nextStrandList).MedianVoltage];
        [vMin,vMinPos] = min(nextStrandVoltages);
        nextStrandID = nextStrandList(vMinPos);
        thisStrandID = nextStrandID;
        thisStrand = strands(thisStrandID);
        if firstFlag, outletIDList = [outletIDList,nextStrandID]; firstFlag = 0; end
        if ismember(thisStrandID,allPlungingVenuleList),
            goFlag = 0;
        end%if ismember
    end%while goFlag
    avDist(paIter) = sumDist;
    stopZ(paIter) = thisStrand.YXZLimits(3,2);
end%for paIter...


figure(1);plot(startZ,avDist,'r.')
figure(2);plot(stopZ,avDist,'r.')




%%
outletZList = [];
for kk = 1:numel(outletIDList),
    thisOutlet = strands(outletIDList(kk));
    outletZList(kk) = thisOutlet.YXZLimits(3,2);
end
outletCurrentList = abs([strands(outletIDList).strandCurrent]);

figure(6);plot(outletZList,(outletCurrentList),'g.');


%%
z1 = 1000;
z2 = 1020;
Vertices = vs.Vertices;
si = vs.Vertices.StrandIndices;
allVerts = Vertices.AllVerts;
% % allVertStrandList = si(:,1);
% % allVertCurrentList = log(abs([strands(allVertStrandList).strandCurrent]));


f1 = find(and(Vertices.AllVerts(:,3)>z1 ,Vertices.AllVerts(:,3)<z2));
sliceVertIDList = f1;
f2 = si(f1,1);
f2 =full(f2);
f3 = find(ismember(f2,allPlungingArterioleList));
paVertIDList = f1(f3);
f4 = find(ismember(f2,allPlungingVenuleList));
pvVertIDList = f1(f4);
sliceVertCurrentList = log(abs([strands(f2).strandCurrent]));
f5 = find(sliceVertCurrentList<14);
lowCurrentVertIDList = f1(f5);


sliceVertdVList = (abs([strands(f2).VoltageDrop]));
sliceVertLengthList = vs.strandLengthList(f2);

sliceVertdVList = sliceVertdVList./sliceVertLengthList';


f6 = find(sliceVertdVList<0.0001);
lowdVVertIDList = f1(f6);



cc1 = allVerts(sliceVertIDList,1);
cc2 = allVerts(sliceVertIDList,2);
cc3 = allVerts(sliceVertIDList,3);
figure(1);plot3(cc1,cc2,cc3,'w.');hold on

cc1 = allVerts(paVertIDList,1);
cc2 = allVerts(paVertIDList,2);
cc3 = allVerts(paVertIDList,3);
figure(1);plot3(cc1,cc2,cc3,'r.');hold on

cc1 = allVerts(pvVertIDList,1);
cc2 = allVerts(pvVertIDList,2);
cc3 = allVerts(pvVertIDList,3);
figure(1);plot3(cc1,cc2,cc3,'b.');

% % cc1 = allVerts(lowCurrentVertIDList,1);
% % cc2 = allVerts(lowCurrentVertIDList,2);
% % cc3 = allVerts(lowCurrentVertIDList,3);
% % figure(1);plot3(cc1,cc2,cc3,'g.');

cc1 = allVerts(lowdVVertIDList,1);
cc2 = allVerts(lowdVVertIDList,2);
cc3 = allVerts(lowdVVertIDList,3);
figure(1);plot3(cc1,cc2,cc3,'g.');


%Calculate distances
qA = allVerts(paVertIDList,1:2);
qS = allVerts(sliceVertIDList,1:2);
qV = allVerts(pvVertIDList,1:2);
qdV = allVerts(lowdVVertIDList,1:2);

sliceDistToA = zeros(length(qS),1)+inf;
for kk = 1:length(qA),
    qq=[];
    qq(:,1) = qS(:,1)-qA(kk,1);
    qq(:,2) = qS(:,2)-qA(kk,2);
    qDist = sqrt(sum(qq.^2,2));
    sliceDistToA = min(sliceDistToA,qDist);
end

lowdVDistToA = zeros(length(qdV),1)+inf;
for kk = 1:length(qA),
    qq=[];
    qq(:,1) = qdV(:,1)-qA(kk,1);
    qq(:,2) = qdV(:,2)-qA(kk,2);
    qDist = sqrt(sum(qq.^2,2));
    lowdVDistToA = min(lowdVDistToA,qDist);
end



sliceDistToV = zeros(length(qS),1)+inf;
for kk = 1:length(qV),
    qq=[];
    qq(:,1) = qS(:,1)-qV(kk,1);
    qq(:,2) = qS(:,2)-qV(kk,2);
    qDist = sqrt(sum(qq.^2,2));
    sliceDistToV = min(sliceDistToV,qDist);
end

lowdVDistToV = zeros(length(qdV),1)+inf;
for kk = 1:length(qV),
    qq=[];
    qq(:,1) = qdV(:,1)-qV(kk,1);
    qq(:,2) = qdV(:,2)-qV(kk,2);
    qDist = sqrt(sum(qq.^2,2));
    lowdVDistToV = min(lowdVDistToV,qDist);
end



xx = [0:25:1000];
hA0 = hist(sliceDistToA,xx);
hA = hist(lowdVDistToA,xx);
hA0 = hA0./max(hA0);
hA = hA./max(hA);

hV0 = hist(sliceDistToV,xx);
hV = hist(lowdVDistToV,xx);
hV0 = hV0./max(hV0);
hV = hV./max(hV);

figure(11);plot(xx,hA0,'k-');hold on
figure(11);plot(xx,hA,'g-');hold off

figure(12);plot(xx,hV0,'k-');hold on
figure(12);plot(xx,hV,'g-');hold off

