tipWidthList = [];
lengthList = [];
setName = {'db','co','av','au'};
for kk = 1:3,
    vectorProject = allProject.(setName{kk});
    papl = vectorProject.vectorizedStructure.allPlungingArteriolePathList;
    numPA = numel(papl);
    strands = vectorProject.vectorizedStructure.Strands;
    strandMidYXZ = vectorProject.vectorizedStructure.strandMidYXZList;
    allVerts = vectorProject.vectorizedStructure.Vertices.AllVerts;
    for paIter = 1:numPA,
        thisPA = papl{paIter};
        topStrandID = thisPA(1);
        topStrand = strands(topStrandID);
        topStrandPoints = topStrand.StartToEndIndices;
        bottomStrandID = thisPA(end);
        bottomStrand = strands(bottomStrandID);
        bottomStrandPoints = bottomStrand.StartToEndIndices;
        topZ = min(allVerts(topStrandPoints,3));
        bottomZ = max(allVerts(bottomStrandPoints,3));
        paLength = bottomZ-topZ;
        paTipWidth = topStrand.MedianRadius;
        lengthList = [lengthList,paLength];
        tipWidthList = [tipWidthList,paTipWidth];
    end    
end

figure(1);plot(tipWidthList,lengthList,'r.');
xlabel('PA tip radius [um]');
ylabel('PA depth [um]');

