hematocrit = 0.45;
conductanceMultiplier = 1;
radiusPower = 4;

radiusList = [3.82 8.76 10.78]/2
radiusList = [7.64 13.13 40]/2

D = radiusList.*2;
strandLength = 50;


%HARDCODE
alpha = 4./(1+exp(-0.593*(D-6.74)));    
viscosity = 1 + ((exp(hematocrit*alpha)-1) .* (110*exp(-1.424*D) + 3 - 3.45*exp(-0.035*D)) ./ (exp(0.45*alpha)-1));
strandConductanceList = conductanceMultiplier .* (D./2).^radiusPower ./ (viscosity.*strandLength);
resistanceList = 1./strandConductanceList;


figure(1);plot(radiusList,resistanceList);
