cd('F:\Phil\AOH_VectorProjects\pbAU\VectorProjectFolder\FlowProject000001_Files')

strands = gds.Strands;
sc = [strands(:).strandCurrent];
zList = gds.strandMidYXZList(:,3)';
sr = [strands(:).MedianRadius];
f1 = sr<2;
f2 = zList >450;
f3 = zList <550;
ff = and(and(f1,f2),f3);
subSR = sr(ff);
subSC = sc(ff);
subList = find(ff);
figure(1);plot(subSC,'r.');

subSC = abs(subSC);


medFlow = median(subSC)*2


f11 = find(subSC>medFlow);
f12 = find(subSC<medFlow);
highList = subList(f11);
lowList = subList(f12);


%%

highFrame = zeros(gds.maskSize(1),gds.maskSize(2));


for kk = 1:numel(highList),
    thisStrand = strands(highList(kk));
    iv = thisStrand.InteriorVertices;
    yList = gds.Vertices.AllVerts(iv,1);
    xList = gds.Vertices.AllVerts(iv,2);
    for qq = 1:length(yList);
        highFrame(yList(qq),xList(qq)) = 1;
    end
end

    
lowFrame = zeros(gds.maskSize(1),gds.maskSize(2));


for kk = 1:numel(lowList),
    thisStrand = strands(lowList(kk));
    iv = thisStrand.InteriorVertices;
    yList = gds.Vertices.AllVerts(iv,1);
    xList = gds.Vertices.AllVerts(iv,2);
    for qq = 1:length(yList);
        lowFrame(yList(qq),xList(qq)) = 1;
    end
end
    
lowFrame = imfilter(lowFrame,double(circle3d(11)));
highFrame = imfilter(highFrame,double(circle3d(11)));

lowFrame = lowFrame./max(lowFrame(:));
highFrame = highFrame./max(highFrame(:));



    
RGB = zeros(gds.maskSize(1),gds.maskSize(2),3);
RGB(:,:,1) = highFrame;
RGB(:,:,2) = lowFrame;
RGB(:,:,3) = barrelMaskOutlineFrame;
see(RGB)











