

mypics = loadmovie;


filterSize = 50;%Hardcode
cutoffFraction = 0.5;
maxCutoffNumStd = 3;



filterCutoff = ceil(filterSize*filterSize*cutoffFraction);
disp(['Hardcode: filterSize',num2str(filterSize)]);
disp(['Hardcode: cutoffFraction',num2str(cutoffFraction)]);
disp(['Hardcode: maxCutoffNumStd',num2str(maxCutoffNumStd)]);

[ySize,xSize,zSize] = size(mypics);
maxDisp = 2000;
correctedPics = mypics;
for zIter = 1:zSize,
    myFrame = mypics(:,:,zIter);
    medFrame = ordfilt2(myFrame,filterCutoff,true(filterSize,filterSize),'symmetric');
    testFrame = double(myFrame)-double(medFrame);
    negHalf = testFrame(testFrame<0);
    myStd = std(negHalf)*sqrt(2)
    medianOfMedian = median(medFrame(:))
    maxMedianValue = medianOfMedian + maxCutoffNumStd * myStd;
    medFrame(medFrame>maxMedianValue) = medianOfMedian;
    finalFrame = myFrame-(medFrame-myStd);
    figure(1);imagesc(min(myFrame,maxDisp))
    figure(2);imagesc(min(medFrame,maxDisp))
    figure(3);imagesc(min(finalFrame,maxDisp))
    correctedPics(:,:,zIter) = finalFrame;
end

maketiff(correctedPics,'correctedPics.tif');



