oldVS = oldAU.vectorizedStructure;
newVS = newAU.vectorizedStructure;

maskSize = oldAU.maskSize;
oldAV = oldVS.Vertices.AllVerts;
newAV = newVS.Vertices.AllVerts;
oldInd = sub2ind(maskSize,oldAV(:,1),oldAV(:,2),oldAV(:,3));
newInd = sub2ind(maskSize,newAV(:,1),newAV(:,2),newAV(:,3));


overlapFlag = ismember(oldInd,newInd);
lostInd = oldInd(overlapFlag==0);

overlapFlag2 = ismember(newInd,oldInd);
addedInd = newInd(overlapFlag2==0);

[lc1,lc2,lc3] = ind2sub(maskSize,lostInd);
[ac1,ac2,ac3] = ind2sub(maskSize,addedInd);
lostCC = [lc1,lc2,lc3];
addedCC = [ac1,ac2,ac3];


figure(1);pl = plot3(lc1,lc2,lc3,'ro');hold on
figure(1);pa = plot3(ac1,ac2,ac3,'go');hold off



