
maskSize = size(permutedNeunGrayscale);
downSampleFactor = 3;
subMaskSize = ceil(maskSize/3);
subMask = zeros(subMaskSize,'uint8');
for kk = 1:maskSize(3)/3;
    thisZ = round(kk*3);
    thisSlab = permutedNeunGrayscale(:,:,thisZ:thisZ+downSampleFactor-1);
    thisFrame = mean(thisSlab,3);
    filtFrame = imfilter(thisFrame,ones(3,3));
    subFrame = thisFrame(1:3:end,1:3:end)/8;
    subMask(:,:,kk) = subFrame;
end
    
maketiff(subMask,'subMask.tif');
