load('F:\Phil\VectorProjects\NozomiArterioleData.mat','nozomiArterioleData')
% load('F:\Phil\VectorProjects\NguyenVenuleData.mat','nguyenVenuleData')
load('F:\Phil\ForFromPeople\Nozomi\venuleBranchPrePostNguyen.mat');
nguyenVenuleData = branchPrePost; clear branchPrePost

nad = nozomiArterioleData;
nvd = nguyenVenuleData;

nad(:,4) = abs(nad(:,3))./abs(nad(:,2))
nvd(:,4) = abs(nvd(:,3))./abs(nvd(:,2))

nad = nad((nad(:,4)<10),:);

figure(1);plot(nad(:,1),nad(:,4),'b.');
figure(11);plot(nvd(:,1),nvd(:,4),'b.');


nad(nad(:,1)>10,1) = 11;

binDataList = [];
binMedianList = [];
for binIter = 1:5,
    switch binIter
        case 1
            branchList = [1 2];
        case 2
            branchList = [3 4];
        case 3
            branchList = [5 6];
        case 4
            branchList = [7 8 9 10];
        case 5 
            branchList = [11 12 13 14];
    end%switch
    myX = mean(branchList)
    f = find(ismember(nad(:,1),branchList));
    myMedian = median(nad(f,4));
    binData = nad(f,4);
    binMedianList(binIter,:) = [myX,myMedian];
    binDataList = [binDataList;[repmat(myX,size(binData)),binData]];
    
end

figure(2);p2 = plot(binDataList(:,1),binDataList(:,2),'go');
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 15]);
set(p2,'MarkerSize',3,'MarkerFaceColor','green');
title('Nozomi Arteriole Data');

figure(3);p3 = plot(binMedianList(:,1),binMedianList(:,2),'gd')
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
set(p3,'MarkerSize',6,'MarkerFaceColor','green');
title('Nozomi Arteriole Median');

%---
%%

binDataList = [];
binMedianList = [];
for binIter = 1:6,
    switch binIter
        case 1
            branchList = [1];
        case 2
            branchList = [2];
        case 3
            branchList = [3];
        case 4
            branchList = [4];
        case 5 
            branchList = [5:7];
        case 6 
            branchList = [8:15];
            
    end%switch
    myX = mean(branchList)
    f = find(ismember(nvd(:,1),branchList));
    myMedian = median(nvd(f,4));
    binData = nvd(f,4);
    binMedianList(binIter,:) = [myX,myMedian];
    binDataList = [binDataList;[repmat(myX,size(binData)),binData]];
    
end

figure(12);p12 = plot(binDataList(:,1),binDataList(:,2),'go');
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
set(p12,'MarkerSize',3,'MarkerFaceColor','green');
title('Nguyen Venule Data');

figure(13);p13 = plot(binMedianList(:,1),binMedianList(:,2),'gd')
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
set(p13,'MarkerSize',6,'MarkerFaceColor','green');
title('Nguyen Venule Median');

figure(203);p203 = plot(binMedianList(:,1),binMedianList(:,2),'gd');
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
set(p203,'MarkerSize',6,'MarkerFaceColor','green');
title('Nguyen Venule Median');




%%


binDataList = [];
binMedianList = [];
for binIter = 1:15,
    branchList = binIter;
    myX = mean(branchList);
    f = find(ismember(nvd(:,1),branchList));
    myMedian = median(nvd(f,4));
    binData = nvd(f,4);
    binMedianList(binIter,:) = [myX,myMedian];
    binDataList = [binDataList;[repmat(myX,size(binData)),binData]];
    
end

figure(12);p12 = plot(binDataList(:,1),binDataList(:,2),'go');
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
set(p12,'MarkerSize',3,'MarkerFaceColor','green');
title('Nguyen Venule Data');

figure(13);p13 = plot(binMedianList(:,1),binMedianList(:,2),'gd');
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
set(p13,'MarkerSize',6,'MarkerFaceColor','green');
title('Nguyen Venule Median');

figure(203);p203 = plot(binMedianList(:,1),binMedianList(:,2),'gd');
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
set(p203,'MarkerSize',6,'MarkerFaceColor','green');
title('Nguyen Venule Median');


%%

% load('F:\Phil\VectorProjects\clotResult010c.mat','clotResultStruct')
% load('F:\Phil\VectorProjects\clotResult011.mat','clotResultStruct')


% allRatioList = clotResultStruct.megaAllRatioList;
allRatioList = clotResultStruct.megaRatioList;

maxNumToShow = 100;
rand('seed',777);

myMedian = [];
for kk = 1:15,
    myList = allRatioList{kk};
    myList = myList(~isnan(myList));
    myMedian(kk) = median(myList);
    if numel(myList)>maxNumToShow,
        myRand =rand(1,numel(myList));
        myFlag = myRand < (maxNumToShow/numel(myList));
        myList = myList(myFlag);
    end%if..
    myBranch = myList.*0+kk;
    figure(112);p1 = plot(myBranch,myList,'ro');hold on
    set(p1,'MarkerSize',3);%'MarkerFaceColor','red'
    figure(113);p2 = plot(myBranch,myMedian(kk),'rd');hold on;
    set(p2,'MarkerSize',6,'MarkerFaceColor','green');
end
figure(112);hold off
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
title('AOH Arteriole Occlusion');
    
figure(113);hold off
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
title('AOH Arteriole Occlusion');

hold on



    
%%
% load('F:\Phil\VectorProjects\venuleClotResult001a.mat');
% load('F:\Phil\VectorProjects\clotVenuleResult001-500_500.mat')
load('F:\Phil\VectorProjects\clotVenuleResult001-500_600.mat')
% load('F:\Phil\VectorProjects\clotVenuleResult001-500_600plusSurfZ.mat')

allRatioList = clotResultStruct.megaRatioList;

maxNumToShow = 100;
rand('seed',777);


myMedian = [];
for kk = 1:15,
    myList = allRatioList{kk};
    myList = myList(~isnan(myList));
    myMedian(kk) = median(myList);
    if numel(myList)>maxNumToShow,
        myRand =rand(1,numel(myList));
        myFlag = myRand < (maxNumToShow/numel(myList));
        myList = myList(myFlag);
    end%if..
    myBranch = myList.*0+kk;
    figure(102);p1 = plot(myBranch,myList,'bo');hold on
    set(p1,'MarkerSize',3,'MarkerFaceColor','blue');
    figure(103);p2 = plot(myBranch,myMedian(kk),'bd');hold on;
    set(p2,'MarkerSize',6,'MarkerFaceColor','blue');
    figure(203);hold on;p3 = plot(myBranch,myMedian(kk),'bd');hold on;
    set(p3,'MarkerSize',6,'MarkerFaceColor','blue');
end

figure(102);hold off
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
title('AOH Venule Occlusion');
    
figure(103);hold off
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
title('AOH Venule Occlusion');
    
figure(203);hold off
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
title('AOH Venule Occlusion');
    





