


allAASepMin = [];
allAVSepMin = [];
allVASepMin = [];
allVVSepMin = [];

%%
thisZ = 590;
bufferSize = 100;
binSize = 25;    

allSubMinDList = [];

for setIDNum = 1:4;
% setIDNum = 1

switch setIDNum,
    case 1, load('F:\Phil\ForFromPeople\Joyce\dataStructforIOS\CX06-dataStruct.mat');thisZ = 514;
    case 2, load('F:\Phil\ForFromPeople\Joyce\dataStructforIOS\CX08-dataStruct.mat');thisZ = 515;
    case 3, load('F:\Phil\ForFromPeople\Joyce\dataStructforIOS\CX12-dataStruct.mat');thisZ = 570;
    case 4, load('F:\Phil\ForFromPeople\Joyce\dataStructforIOS\CX13-dataStruct.mat');thisZ = 426;
end



maskSize = dataStruct.maskSize;
allPlungingArterioleCoordList = dataStruct.paCoords;
allPlungingVenuleCoordList = dataStruct.pvCoords;
dilatedBarrelMask = dataStruct.dilatedBarrelMask;


%Find the points that lie in the Z-plane
%--
zFlagA = allPlungingArterioleCoordList(:,3)==thisZ;
subArterioleCoordList = allPlungingArterioleCoordList(zFlagA,:);
numSubArterioles = size(subArterioleCoordList,1);
%---
zFlagV = allPlungingVenuleCoordList(:,3)==thisZ;
subVenuleCoordList = allPlungingVenuleCoordList(zFlagV,:);
numSubVenules = size(subVenuleCoordList,1);
%---


%Mask with the dilatedBarrelMask
myFrame = zeros(maskSize(1),maskSize(2));
myInd = sub2ind(size(myFrame),subArterioleCoordList(:,1),subArterioleCoordList(:,2));
myFrame(myInd) = 1;
myFrame = myFrame.*dilatedBarrelMask;
myInd = find(myFrame);
[tcl1,tcl2] = ind2sub(size(myFrame),myInd);
subArterioleCoordList = [tcl1,tcl2];



%Mask with the dilatedBarrelMask
myFrame = zeros(maskSize(1),maskSize(2));
myInd = sub2ind(size(myFrame),subVenuleCoordList(:,1),subVenuleCoordList(:,2));
myFrame(myInd) = 1;
myFrame = myFrame.*dilatedBarrelMask;
myInd = find(myFrame);
[tcl1,tcl2] = ind2sub(size(myFrame),myInd);
subVenuleCoordList = [tcl1,tcl2];


numSubArterioles = size(subArterioleCoordList,1);
numSubVenules = size(subVenuleCoordList,1);


minSep = 5;
keepGoingFlag = 1;
while keepGoingFlag == 1,
    keepGoingFlag = 0;
    for aIter = 1:numSubArterioles
        thisACoord = subArterioleCoordList(aIter,:);
        aaDiff1 = subArterioleCoordList(:,1)-thisACoord(1);
        aaDiff2 = subArterioleCoordList(:,2)-thisACoord(2);
        aaSep = sqrt(aaDiff1.^2+aaDiff2.^2);
        ff = find(and(aaSep<minSep,aaSep>0));
        if ~isempty(ff)%found points too close together
            oldSum = 0;
            flaggedList = zeros(numSubArterioles,1);
            ffo = find(and(aaSep<minSep,aaSep>0));
            flaggedList(aIter) = 1;
            flaggedList(ffo) = 1;
            innerLoopKeepGoingFlag = 1;
            while innerLoopKeepGoingFlag == 1,
                for kk = 1:numel(ffo),
                    thisACoord = subArterioleCoordList(ffo(kk),:);
                    aaDiff1 = subArterioleCoordList(:,1)-thisACoord(1);
                    aaDiff2 = subArterioleCoordList(:,2)-thisACoord(2);
                    aaSep = sqrt(aaDiff1.^2+aaDiff2.^2);
                    ff = find(and(aaSep<minSep,aaSep>0));
                    flaggedList(ff) = 1;
                end
                newSum = sum(flaggedList);
                if newSum==oldSum,
                    innerLoopKeepGoingFlag = 0;
                end    
                oldSum = newSum;
                ffo = find(flaggedList);
%                 pause
            end% while innerLoopKeepGoingFlag == 1,
            disp('loopDone');
            ff = find(flaggedList);
            flaggedList(ff(1)) = 0;
            subArterioleCoordList = subArterioleCoordList(flaggedList==0,:);
            numSubArterioles = size(subArterioleCoordList,1);
            keepGoingFlag = 1;
            break%break out of aIter loop
        end%if ~isempty(ff)
    end%for aIter
end%while keepGoingFlag = 0;


keepGoingFlag = 1;
while keepGoingFlag == 1,
    keepGoingFlag = 0;
    for vIter = 1:numSubVenules
        thisACoord = subVenuleCoordList(vIter,:);
        vvDiff1 = subVenuleCoordList(:,1)-thisACoord(1);
        vvDiff2 = subVenuleCoordList(:,2)-thisACoord(2);
        vvSep = sqrt(vvDiff1.^2+vvDiff2.^2);
        ff = find(and(vvSep<minSep,vvSep>0));
        if ~isempty(ff)%found points too close together
            oldSum = 0;
            flaggedList = zeros(numSubVenules,1);
            ffo = find(and(vvSep<minSep,vvSep>0));
            flaggedList(vIter) = 1;
            flaggedList(ffo) = 1;
            innerLoopKeepGoingFlag = 1;
            while innerLoopKeepGoingFlag == 1,
                for kk = 1:numel(ffo),
                    thisACoord = subVenuleCoordList(ffo(kk),:);
                    vvDiff1 = subVenuleCoordList(:,1)-thisACoord(1);
                    vvDiff2 = subVenuleCoordList(:,2)-thisACoord(2);
                    vvSep = sqrt(vvDiff1.^2+vvDiff2.^2);
                    ff = find(and(vvSep<minSep,vvSep>0));
                    flaggedList(ff) = 1;
                end
                newSum = sum(flaggedList);
                if newSum==oldSum,
                    innerLoopKeepGoingFlag = 0;
                end    
                oldSum = newSum;
                ffo = find(flaggedList);
%                 pause
            end% while innerLoopKeepGoingFlag == 1,
            disp('loopDone');
            ff = find(flaggedList);
            flaggedList(ff(1)) = 0;
            subVenuleCoordList = subVenuleCoordList(flaggedList==0,:);
            numSubVenules = size(subVenuleCoordList,1);
            keepGoingFlag = 1;
            break%break out of vIter loop
        end%if ~isempty(ff)
    end%for vIter
end%while keepGoingFlag = 0;



maxY = maskSize(1)-bufferSize;
maxX = maskSize(2)-bufferSize;
sA = subArterioleCoordList;
sV = subVenuleCoordList;
insideAFlag = and(and(and(sA(:,1)<maxY,sA(:,1)>bufferSize),sA(:,2)>bufferSize),sA(:,2)<maxX);
insideVFlag = and(and(and(sV(:,1)<maxY,sV(:,1)>bufferSize),sV(:,2)>bufferSize),sV(:,2)<maxX);

insideSubArterioleCoordList = subArterioleCoordList(insideAFlag,:);
numInsideSubArterioles = size(insideSubArterioleCoordList,1);
insideSubVenuleCoordList = subVenuleCoordList(insideVFlag,:);
numInsideSubVenules = size(insideSubVenuleCoordList,1);



aaSepMin = [];
avSepMin = [];
for aIter = 1:numInsideSubArterioles
    thisACoord = insideSubArterioleCoordList(aIter,:);
    aaDiff1 = subArterioleCoordList(:,1)-thisACoord(1);
    aaDiff2 = subArterioleCoordList(:,2)-thisACoord(2);
    avDiff1 = subVenuleCoordList(:,1)-thisACoord(1);
    avDiff2 = subVenuleCoordList(:,2)-thisACoord(2);
    aaSep = sqrt(aaDiff1.^2+aaDiff2.^2);
    avSep = sqrt(avDiff1.^2+avDiff2.^2);
    aaSep = aaSep(aaSep>0);
    aaSepMin(aIter) = min(aaSep);
    avSepMin(aIter) = min(avSep);
end%for aIter;

vaSepMin = [];
vvSepMin = [];
for vIter = 1:numInsideSubVenules
    thisVCoord = insideSubVenuleCoordList(vIter,:);
    vaDiff1 = subArterioleCoordList(:,1)-thisVCoord(1);
    vaDiff2 = subArterioleCoordList(:,2)-thisVCoord(2);
    vvDiff1 = subVenuleCoordList(:,1)-thisVCoord(1);
    vvDiff2 = subVenuleCoordList(:,2)-thisVCoord(2);
    vaSep = sqrt(vaDiff1.^2+vaDiff2.^2);
    vvSep = sqrt(vvDiff1.^2+vvDiff2.^2);
    vaSep = vaSep(vaSep>minSep);
    vvSep = vvSep(vvSep>minSep);
    vaSepMin(vIter) = min(vaSep);
    vvSepMin(vIter) = min(vvSep);
    
%     if min(vvSep)<10, pause; end
    
end%for aIter;

%%
blankMask = zeros(maskSize(1),maskSize(2));
for vIter = 1:numSubVenules
    blankMask(subVenuleCoordList(vIter,1),subVenuleCoordList(vIter,2)) = 1;
end

skipSize = 1;
maskArea = prod(size(blankMask));
[yi,xi] = ind2sub(size(blankMask),[1:skipSize:maskArea]);

minDList = [1:skipSize:maskArea]*inf;
for vIter = 1:numSubVenules,
    vy = subVenuleCoordList(vIter,1);
    vx = subVenuleCoordList(vIter,2);
    dd = sqrt((yi-vy).^2 + (xi-vx).^2);
    minDList = min(minDList,dd);
end

minDMat = reshape(minDList,size(blankMask));
minDMat = minDMat.*dilatedBarrelMask;

subMinDList = minDMat(minDMat(:)>0);
disp(' ');
disp(mean(subMinDList));
disp(sum(dilatedBarrelMask(:)));
disp(' ');


allSubMinDList = [allSubMinDList;subMinDList];

end%for setIDNum...
