load('F:\Phil\VectorProjects\NozomiArterioleData.mat','nozomiArterioleData')
% load('F:\Phil\VectorProjects\NguyenVenuleData.mat','nguyenVenuleData')
load('F:\Phil\ForFromPeople\Nozomi\venuleBranchPrePostNguyen.mat');
nguyenVenuleData = branchPrePost; clear branchPrePost

nad = nozomiArterioleData;
nvd = nguyenVenuleData;

nad(:,4) = abs(nad(:,3))./abs(nad(:,2))
nvd(:,4) = abs(nvd(:,3))./abs(nvd(:,2))

nad = nad((nad(:,4)<10),:);

figure(1);plot(nad(:,1),nad(:,4),'b.');
figure(11);plot(nvd(:,1),nvd(:,4),'b.');


nad(nad(:,1)>10,1) = 12.5;

binDataList = [];
binMedianList = [];
binCounter = 0;
for binIter = [1:10,12.5]
    binCounter = binCounter+1;
    branchList = binIter;
    myX = mean(branchList);
    f = find(ismember(nad(:,1),branchList));
    myMedian = median(nad(f,4));
    binData = nad(f,4);
    binMedianList(binCounter,:) = [myX,myMedian];
    binDataList = [binDataList;[repmat(myX,size(binData)),binData]];
    
end



figure(2);p2 = plot(binDataList(:,1),binDataList(:,2),'go');
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 15]);
set(p2,'MarkerSize',3,'MarkerFaceColor','green');
title('Nozomi Arteriole Data');

figure(113);p3 = plot(binMedianList(:,1),binMedianList(:,2),'gd')
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
set(p3,'MarkerSize',6,'MarkerFaceColor','green');
title('Nozomi Arteriole Median');

%---

% p = polyfit(binDataList(:,1),binDataList(:,2),5);
p = polyfit(binMedianList(:,1),binMedianList(:,2),4);
y = polyval(p,binMedianList(:,1));
figure(2);hold on; plot(binMedianList(:,1),y,'r-');
figure(3);hold on; plot(binMedianList(:,1),y,'r-');
figure(2);hold off
figure(3);hold off;


% % % % % %%
% % % % % bestErr = inf;
% % % % % sA = -0.5;
% % % % % sxo = 6.5;
% % % % % sh = 1;
% % % % % besty = zeros(1,11);
% % % % % %%
% % % % % 
% % % % % range = 0.005;
% % % % % rangeList = linspace(-range,range,7);
% % % % % 
% % % % % rangeList = rangeList+rand(size(rangeList))*range/30 - (range/15);
% % % % % 
% % % % % aRange = sA + sA*rangeList;
% % % % % xRange = sxo + sxo*rangeList;
% % % % % hRange = sh + sh*rangeList;
% % % % % 
% % % % % 
% % % % % for aIter = 1:7,
% % % % %     for xIter = 1:7,
% % % % %         for hIter = 1:7,
% % % % %             A = aRange(aIter);
% % % % %             xo = xRange(xIter);
% % % % %             h = hRange(hIter);
% % % % % x = [1:10,12.5];
% % % % % xp = A*(x-xo);
% % % % % y = h./(1+exp(xp));
% % % % % myErr = sum((y'-binMedianList(:,2)).^2);
% % % % % if myErr<bestErr,
% % % % %     bestErr = myErr
% % % % %     sA = A;sxo = xo; sh = h;
% % % % %     besty = y;
% % % % % end%if myErr<bestErr
% % % % % figure(3);hold off; plot(x,y,'b-');hold on
% % % % %     figure(3);hold on;plot(x,besty,'r-');hold off
% % % % %     figure(3);hold on;p3 = plot(binMedianList(:,1),binMedianList(:,2),'gd'); hold off
% % % % % 
% % % % % 
% % % % %         end
% % % % %     end
% % % % % end
% % % % % 
% % % % % % % firstFitX = x;
% % % % % % % firstFitY = besty;
% % % % % 
% % % % % 
% % % % % %%
% % % % % bestErr = inf;
% % % % % sA = -0.5;
% % % % % sxo = 6.5;
% % % % % sh = 1;
% % % % % besty = zeros(1,13);
% % % % % %%
% % % % % binMedianListSupp(:,1) = [0;binMedianList(1:end-1,2);12.5;20];
% % % % % binMedianListSupp(:,2) = [0;binMedianList(:,2);1];
% % % % % 
% % % % % range = 0.005;
% % % % % rangeList = linspace(-range,range,7);
% % % % % 
% % % % % rangeList = rangeList+rand(size(rangeList))*range/30 - (range/15);
% % % % % 
% % % % % aRange = sA + sA*rangeList;
% % % % % xRange = sxo + sxo*rangeList;
% % % % % hRange = sh + sh*rangeList;
% % % % % 
% % % % % 
% % % % % for aIter = 1:7,
% % % % %     for xIter = 1:7,
% % % % %         for hIter = 1:7,
% % % % %             A = aRange(aIter);
% % % % %             xo = xRange(xIter);
% % % % %             h = hRange(hIter);
% % % % % x = [0:10,12.5,20];
% % % % % xp = A*(x-xo);
% % % % % y = h./(1+exp(xp));
% % % % % myErr = sum((y'-binMedianListSupp(:,2)).^2);
% % % % % if myErr<bestErr,
% % % % %     bestErr = myErr
% % % % %     sA = A;sxo = xo; sh = h;
% % % % %     besty = y;
% % % % % end%if myErr<bestErr
% % % % % figure(3);hold off; plot(x,y,'b-');hold on
% % % % %     figure(3);hold on;plot(x,besty,'r-');hold off
% % % % %     figure(3);hold on;p3 = plot(binMedianList(:,1),binMedianList(:,2),'gd'); hold off
% % % % % 
% % % % % 
% % % % %         end
% % % % %     end
% % % % % end
% % % % % 
% % % % % secondFitX = x;
% % % % % secondFitY = besty;
%%
%%
bestErr = inf;
sA = -0.5;
sxo = 6.5;
sh = 1;
besty = zeros(1,11);
%%

range = 0.5;
rangeList = linspace(-range,range,7);

rangeList = rangeList+rand(size(rangeList))*range/30 - (range/15);

aRange = sA + sA*rangeList;
xRange = sxo + sxo*rangeList;
hRange = sh + sh*rangeList;


for aIter = 1:7,
    for xIter = 1:7,
        for hIter = 1:7,
            A = aRange(aIter);
            xo = xRange(xIter);
            h = hRange(hIter);
            h = 1;
x = [1:10,12.5];
xp = A*(x-xo);
y = h./(1+exp(xp));
myErr = sum((y'-binMedianList(:,2)).^2);
if myErr<bestErr,
    bestErr = myErr
    sA = A;sxo = xo; sh = h;
    besty = y;
end%if myErr<bestErr
figure(3);hold off; plot(x,y,'b-');hold on
    figure(3);hold on;plot(x,besty,'r-');hold off
    figure(3);hold on;p3 = plot(binMedianList(:,1),binMedianList(:,2),'gd'); hold off


        end
    end
end
thirdFitX = x;
thirdFitY = besty;

thirdFitX2 = [0:15];
  xp = sA*(thirdFitX2-sxo);
thirdFitY2 = 1./(1+exp(xp));

%%
x = [-20:0.01:20];
figure(99);plot(1./(1+exp(x)),'g-');

%%
for setIter = [1:5,7,11]
    switch setIter
        case 1
            load('F:\Phil\VectorProjects\orig_CRS.mat');
            plotStr = 'k-';
        case 2
            load('F:\Phil\VectorProjects\origMinus1_CRS.mat');
            plotStr = 'r-';
        case 3
            load('F:\Phil\VectorProjects\origMinus0p5_CRS.mat');
            plotStr = 'm-';
        case 4
            load('F:\Phil\VectorProjects\origMinus0p25_CRS.mat');
            plotStr = 'y-';
        case 5
            load('F:\Phil\VectorProjects\origPlus0p25_CRS.mat');
            plotStr = 'g-';
        case 6
            load('F:\Phil\VectorProjects\origPlus0p5_CRS.mat');
            plotStr = 'c-';
        case 7
            load('F:\Phil\VectorProjects\origPlus1_CRS.mat');
            plotStr = 'b-';
    end% switch setIter

    allRatioList = clotResultStruct.megaRatioList;

% % %     myMedian = [];
% % %     for kk = 1:15,
% % %         myList = allRatioList{kk};s
% % %         myList = myList(~isnan(myList));
% % %         myMedian(kk) = median(myList);
% % %     end

    numEntryList = [];
    errList = [];
    myMedianList = [];
    plotMedianList = [];
    
    for kk = 1:15,
        megaRatio = clotResultStruct.megaRatioList{kk};
        megaRatio = megaRatio(~isnan(megaRatio));
        plotMedianList(kk) = median(megaRatio);
    end%
    
    for kk = 1:10,
        subData = nad(find(nad(:,1)==kk),4);
        megaRatio = clotResultStruct.megaRatioList{kk};
        megaRatio = megaRatio(~isnan(megaRatio));
        myMedianList(kk) = median(megaRatio);
        diffList = subData - myMedianList(kk);
        numInList = numel(diffList);
        errList(kk) = sqrt(sum(diffList.^2)/numInList);
        numEntryList(kk) = numel(subData);
    end%for kk
    
        subData = nad(find(nad(:,1)>10),4);
        megaRatio = clotResultStruct.megaRatioList{11:15};
        megaRatio = megaRatio(~isnan(megaRatio));
        myMedianList(11) = median(megaRatio);
        diffList = subData - myMedianList(11);
        numInList = numel(diffList);
        errList(11) = sqrt(sum(diffList.^2)/numInList);
        numEntryList(11) = numel(subData);
    
    
    normNumEntry = numEntryList./sum(numEntryList);
    fullErr = sum(errList.*normNumEntry)
    
        

    figure(113);p2 = plot(plotMedianList,plotStr);hold on;
% %     mySigmoid = thirdFitY2(2:end);
% %     myErr = sqrt(sum((mySigmoid-myMedian).^2));
% 

    figure(113);hold off
    ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
    set(gca,'YLim',[0 2],'XLim',[0, 16]);
    title('AOH Arteriole Occlusion');
    hold on


end% for setIter



figure(113);plot(thirdFitX2,thirdFitY2,'k-.');

%%



%%



%%

%VENULES

%%
binDataList = [];
binMedianList = [];
for binIter = 1:15,
    branchList = binIter;
            
    myX = mean(branchList)
    f = find(ismember(nvd(:,1),branchList));
    myMedian = median(nvd(f,4));
    binData = nvd(f,4);
    binMedianList(binIter,:) = [myX,myMedian];
    binDataList = [binDataList;[repmat(myX,size(binData)),binData]];
    
end

figure(12);p12 = plot(binDataList(:,1),binDataList(:,2),'go');
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
set(p12,'MarkerSize',3,'MarkerFaceColor','green');
title('Nguyen Venule Data');hold on

figure(12);p13 = plot(binMedianList(:,1),binMedianList(:,2),'gd')
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
set(p13,'MarkerSize',6,'MarkerFaceColor','green','MarkerEdgeColor','black');
title('Nguyen Venule Median');

figure(213);p213 = plot(binMedianList(:,1),binMedianList(:,2),'gd');
ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
set(gca,'YLim',[0 2],'XLim',[0, 16]);
set(p213,'MarkerSize',6,'MarkerFaceColor','green');
title('Nguyen Venule Median'); hold on

%%
bestErr = inf;
sA = -0.5;
sxo = 6.5;
sh = 1;
besty = zeros(1,15);
%%

range = 0.02125;
rangeList = linspace(-range,range,7);

rangeList = rangeList+rand(size(rangeList))*range/30 - (range/15);

aRange = sA + sA*rangeList;
xRange = sxo + sxo*rangeList;
hRange = sh + sh*rangeList;


for aIter = 1:7,
    for xIter = 1:7,
        for hIter = 1:7,
            A = aRange(aIter);
            xo = xRange(xIter);
            h = hRange(hIter);
            h = 1;
x = [1:15];
xp = A*(x-xo);
y = h./(1+exp(xp));
myErr = sum((y'-binMedianList(:,2)).^2);
if myErr<bestErr,
    bestErr = myErr
    sA = A;sxo = xo; sh = h;
    besty = y;
end%if myErr<bestErr
figure(3);hold off; plot(x,y,'b-');hold on
    figure(3);hold on;plot(x,besty,'r-');hold off
    figure(3);hold on;p3 = plot(binMedianList(:,1),binMedianList(:,2),'gd'); hold off


        end
    end
end
thirdFitX = x;
thirdFitY = besty;

thirdFitX2 = [0:15];
  xp = sA*(thirdFitX2-sxo);
thirdFitY2 = 1./(1+exp(xp));



%%


%%
for setIter = [1:5,7]
    switch setIter
        case 1
            load('F:\Phil\VectorProjects\venuleClot_orig_CRS.mat');
            plotStr = 'k-';
        case 2
            load('F:\Phil\VectorProjects\venuleClot_origMinus1_CRS.mat');
            plotStr = 'r-';
        case 3
            load('F:\Phil\VectorProjects\venuleClot_origMinus0p5_CRS.mat');
            plotStr = 'm-';
        case 4
            load('F:\Phil\VectorProjects\venuleClot_origPlus0p5_CRS.mat');
            plotStr = 'c-';
        case 5
            load('F:\Phil\VectorProjects\venuleClot_origPlus1p0_CRS.mat');
            plotStr = 'b-';
        case 6
            load('F:\Phil\VectorProjects\venuleClot_origPlus1p5_CRS.mat');
            plotStr = 'k-';
        case 7
            load('F:\Phil\VectorProjects\venuleClot_origPlus0p25_CRS.mat');
            plotStr = 'g-';
        case 8
            load('F:\Phil\VectorProjects\venuleClot_origMinus1p5_CRS.mat');
            plotStr = 'k-';
        case 9
            load('F:\Phil\VectorProjects\venuleClot_origMinus2_CRS.mat');
            plotStr = 'k-';
        case 10
            load('F:\Phil\VectorProjects\venuleClot_origHalf_CRS.mat');
            plotStr = 'k-';
        case 11
            load('F:\Phil\VectorProjects\venuleClot_origPlus0p1_CRS.mat');
            plotStr = 'y-';
    end% switch setIter

    allRatioList = clotResultStruct.megaRatioList;

% % %     myMedian = [];
% % %     for kk = 1:15,
% % %         myList = allRatioList{kk};s
% % %         myList = myList(~isnan(myList));
% % %         myMedian(kk) = median(myList);
% % %     end

    numEntryList = [];
    errList = [];
    myMedianList = [];
    plotMedianList = [];
    
    for kk = 1:15,
        megaRatio = clotResultStruct.megaRatioList{kk};
        megaRatio = megaRatio(~isnan(megaRatio));
        plotMedianList(kk) = median(megaRatio);
    end%
    
    for kk = 1:10,
        subData = nad(find(nad(:,1)==kk),4);
        megaRatio = clotResultStruct.megaRatioList{kk};
        megaRatio = megaRatio(~isnan(megaRatio));
        myMedianList(kk) = median(megaRatio);
        diffList = subData - myMedianList(kk);
        numInList = numel(diffList);
        errList(kk) = sqrt(sum(diffList.^2)/numInList);
        numEntryList(kk) = numel(subData);
    end%for kk
    
        subData = nad(find(nad(:,1)>10),4);
        megaRatio = clotResultStruct.megaRatioList{11:15};
        megaRatio = megaRatio(~isnan(megaRatio));
        myMedianList(11) = median(megaRatio);
        diffList = subData - myMedianList(11);
        numInList = numel(diffList);
        errList(11) = sqrt(sum(diffList.^2)/numInList);
        numEntryList(11) = numel(subData);
    
    
    normNumEntry = numEntryList./sum(numEntryList);
    fullErr = sum(errList.*normNumEntry)
    
        

    figure(213);p2 = plot(plotMedianList,plotStr);hold on;
% %     mySigmoid = thirdFitY2(2:end);
% %     myErr = sqrt(sum((mySigmoid-myMedian).^2));
% 

    figure(213);hold off
    ylabel('Fraction of baseline flow');xlabel('Downstream Edge');
    set(gca,'YLim',[0 2],'XLim',[0, 16]);
    title('AOH Venule Occlusion');
    hold on


end% for setIter



figure(213);plot(thirdFitX2,thirdFitY2,'k-.');


