allBranchRadius = zeros(1,15);
d = dir('pbDB-Clot*.mat');
numFiles = numel(d);

for fileIter = 1:numFiles,
    load(d(fileIter).name);
    vs = allProject.db.vectorizedStructure;
    adj = vs.adjustedStrandRadiusList;

    dsl = min(downstreamBranchList,[],2);

    branchRadius = zeros(1,15);
    for branchIter = 1:15,
        indList = find(dsl==branchIter);    
        branchRadius(branchIter) = median(adj(indList));
    end%for branchIter = 1:15,

    allBranchRadius = allBranchRadius + branchRadius;

end%for fileIter
