function outputProject = VidaSetupVidaProjectFile(inputProject)
    vidaProject = inputProject;
    setupParameters = vidaProject.setupParameters;
    %-----
    vidaProjectRootDataFolder = inputProject.vidaProjectRootFolder;
    vidaProjectRootName = inputProject.vidaProjectRootName;
%     useGuiFlag = inputProject.useGuiFlag;
%     useTifStorageFlag = inputProject.useTifStorageFlag;
%     skipAutoUpgradeFlag = inputProject.skipAutoUpgradeFlag;
    defaultOverwriteFilesStateFlag = setupParameters.defaultOverwriteFilesStateFlag;
    rootCodeFolder = inputProject.rootCodeFolder;
    %----------
%     vidaProject.setupParameters.useGuiFlag = useGuiFlag;
%     vidaProject.setupParameters.useTifStorageFlag = useTifStorageFlag;
%     vidaProject.setupParameters.skipAutoUpgradeFlag =
%     skipAutoUpgradeFlag;
    %---
    vidaProject.codeFolders.rootCodeFolder = rootCodeFolder;
    vidaProject.codeFolders.generalFunctionsFolder = fullfile(rootCodeFolder,'GeneralFunctionsFolder');
    vidaProject.codeFolders.parameterSetsFolder = fullfile(rootCodeFolder,'ParameterSetsFolder');
    vidaProject.codeFolders.guiFunctionsFolder = fullfile(rootCodeFolder,'GuiFunctionsFolder');
    vidaProject.codeFolders.setupFunctionsFolder = fullfile(rootCodeFolder,'SetupFunctionsFolder');
% % %     vidaProject.codeFolders.multiThreadFunctionsFolder = fullfile(rootCodeFolder,'MultiThreadFunctionsFolder');
    vidaProject.codeFolders.vidaProcessFlowFunctionsFolder = fullfile(rootCodeFolder,'VidaProcessFlowFunctionsFolder');
    vidaProject.codeFolders.skipStageFunctionsFolder = fullfile(rootCodeFolder,'SkipStageFunctionsFolder');
    vidaProject.codeFolders.preProcessingFunctionsFolder = fullfile(rootCodeFolder,'PreProcessingFunctionsFolder');
    vidaProject.codeFolders.channelSubFunctionsFolder = fullfile(rootCodeFolder,'ChannelSubFunctionsFolder');
    vidaProject.codeFolders.tilingFunctionsFolder = fullfile(rootCodeFolder,'TilingFunctionsFolder');
    vidaProject.codeFolders.subBlockFunctionsFolder = fullfile(rootCodeFolder,'SubBlockFunctionsFolder');
    vidaProject.codeFolders.cellSegFunctionsFolder = fullfile(rootCodeFolder,'CellSegFunctionsFolder');
% % %     vidaProject.codeFolders.vascBlockChannelSubFunctionsFolder = fullfile(rootCodeFolder,'VascBlockChannelSubFunctionsFolder');
    vidaProject.codeFolders.vascSegFunctionsFolder = fullfile(rootCodeFolder,'VascSegFunctionsFolder');
    vidaProject.codeFolders.cellCentroidFunctionsFolder = fullfile(rootCodeFolder,'CellCentroidFunctionsFolder');
% % %     vidaProject.codeFolders.neunBlockChannelSubFunctionsFolder = fullfile(rootCodeFolder,'NeunBlockChannelSubFunctionsFolder');
    vidaProject.codeFolders.neunQuantifyFunctionsFolder = fullfile(rootCodeFolder,'NeunQuantifyFunctionsFolder');
    vidaProject.codeFolders.neuronClassifyFunctionsFolder = fullfile(rootCodeFolder,'NeuronClassifyFunctionsFolder');
    vidaProject.codeFolders.vascRadiiFunctionsFolder = fullfile(rootCodeFolder,'VascRadiiFunctionsFolder');
    vidaProject.codeFolders.centerlineFunctionsFolder = fullfile(rootCodeFolder,'CenterlineFunctionsFolder');
% % %     vidaProject.codeFolders.flattenCortexFunctionsFolder = fullfile(rootCodeFolder,'FlattenCortexFunctionsFolder');
% % %     vidaProject.codeFolders.sideProjectMasksFunctionsFolder = fullfile(rootCodeFolder,'SideProjectMasksFunctionsFolder');
% % %     vidaProject.codeFolders.analyzeMasksFunctionsFolder = fullfile(rootCodeFolder,'AnalyzeMasksFunctionsFolder');
    vidaProject.codeFolders.registrationFunctionsFolder = fullfile(rootCodeFolder,'RegistrationFunctionsFolder');
    vidaProject.codeFolders.strandifyFunctionsFolder = fullfile(rootCodeFolder,'StrandifyFunctionsFolder');
    vidaProject.codeFolders.GapConnectionFunctionsFolder = fullfile(rootCodeFolder,'GapConnectionFunctionsFolder');
    vidaProject.codeFolders.QuickTestFunctionFolders = fullfile(rootCodeFolder,'QuickTestFunctionsFolder');
    revisedCodeFolders = vidaProject.codeFolders; %temp storage of local code directory (in case prior vidaProject from different machine is used)
    %---
    vidaProject.globalParameters.numChannels = 3;
    
% % % %     vidaProject.progressFlags.initialized = 1;
% % % %     vidaProject.progressFlags.overwriteOldFiles = defaultOverwriteFilesStateFlag;
% % % %     vidaProject.progressFlags.preProcessingCompleted = 0;
% % % %     vidaProject.progressFlags.subBlockCompleted = 0;
% % % %     vidaProject.progressFlags.cellSegCompleted = 0;
% % % %     vidaProject.progressFlags.vascBlockChannelSubCompleted = 0;
% % % %     vidaProject.progressFlags.vascSegCompleted = 0;
% % % %     vidaProject.progressFlags.centerlineCompleted = 0;
% % % %     vidaProject.progressFlags.cellCentroidCompleted = 0;
% % % %     vidaProject.progressFlags.neunBlockChannelSubCompleted = 0;
% % % %     vidaProject.progressFlags.neunQuantifyCompleted = 0;
% % % %     vidaProject.progressFlags.neuronClassifyCompleted = 0;
% % % %     vidaProject.progressFlags.vascRadiiCompleted = 0;
    %---
    vidaProjectFileName = fullfile(vidaProjectRootDataFolder,[vidaProjectRootName,'-VidaProject.mat']);
    %-----
    outputProject = vidaProject;
    outputProject.setupParameters.revisedCodeFolders = revisedCodeFolders;
    outputProject.vidaProjectFileName = vidaProjectFileName;
end
