% function outProject = ConvertSEtoSE2(inputDataStruct)

% % [fileName,pathName] = uigetfile({'SE**.mat'},'Select a StrandEdit .mat file');
% % cd(pathName)
% % loadFileName = [fileName];
% % load(loadFileName);
% % 

%load the SE File
load('F:\Phil\AOH_Datasets\pbAU_Trials\pbAUVector2\VectorProjectFolder\SE2010_11_03-15_48_29-Mod-SetPointB02-StrandEdit-pbAUFull.mat');
%load the associated vidaProject file
load('F:\Phil\AOH_Datasets\pbAU_Trials\pbAUVector2\pbAU-VidaProject.mat');
vectorProjectFolder = 'F:\Phil\AOH_Datasets\pbAU_Trials\pbAUVector2\VectorProjectFolder';
grayscaleFileName = 'pbAU-permutedVascGrayscale.mat';
inputDataStruct = globalDataStruct;
globalDataStruct = [];
permuteSequence = [1 2 3],%Hardcode



tempMaskSize = inputDataStruct.maskSize;
maskSize = [tempMaskSize(permuteSequence(1)),tempMaskSize(permuteSequence(2)),tempMaskSize(permuteSequence(3))];
clear tempMaskSize
voxelSizeInMicrons = vidaProject.globalParameters.voxelSizeInMicrons;
strandifyParameters = vidaProject.experimentTemplate.strandifyParameters;




origVectorProject.note = 'Permuted Coord. System';
origVectorProject.permuteSequence = permuteSequence;
origVectorProject.vectorProjectFolder = vectorProjectFolder;
origVectorProject.maskSize = maskSize;
origVectorProject.voxelSizeInMicrons = voxelSizeInMicrons;
origVectorProject.vectorProjectRootName = vidaProject.vidaProjectRootName;
origVectorProject.rootCodeFolder = vidaProject.rootCodeFolder;
origVectorProject.volumeFileNames.permutedVascGrayscale = grayscaleFileName;
origVectorProject.strandifyParameters = strandifyParameters;
origVectorProject.thresholdRelaxationParameters = [];
origVectorProject.cellCentroidAndLabelList = vidaProject.globalParameters.registeredCellCentroidAndLabelList;
origVectorProject.GapConnectionStruct = vidaProject.globalParameters.GapConnectionStruct;
%-----
%-----
origVectorProject.progressFlags.permuteCoordCompleted = 1;
origVectorProject.progressFlags.thresholdRelaxationCompleted = 1;
origVectorProject.progressFlags.addTRBridgesCompleted = 1;
%-----








% origVectorProject = inputDataStruct.origVectorProject;
fileRootName = inputDataStruct.fileRootName;
loadFileName = inputDataStruct.loadFileName;
tempCP = inputDataStruct.cpMatrix;
cpMatrix = tempCP;
cpMatrix(:,1) = tempCP(:,permuteSequence(1));
cpMatrix(:,2) = tempCP(:,permuteSequence(2));
cpMatrix(:,3) = tempCP(:,permuteSequence(3));
clear tempCP
strands = inputDataStruct.strands;
allVerts = cpMatrix(:,1:3);
allRadii = inputDataStruct.ar;
allLabels = cpMatrix(:,7);
allConfidences = zeros(size(allRadii))+Inf;
allNotes = cell(size(allRadii));
tempJP = inputDataStruct.jp;
tempJP(:,3) = tempJP(:,3) * -1;
junctionPoints = [tempJP(permuteSequence(1)),tempJP(permuteSequence(2)),-1*tempJP(permuteSequence(3))];
tempFEP = inputDataStruct.fep;
tempFEP(:,3) = tempFEP(:,3) * -1;
freeEndPoints = [tempFEP(permuteSequence(1)),tempFEP(permuteSequence(2)),-1*tempFEP(permuteSequence(3))];
tempRP = inputDataStruct.rp;
tempRP(:,3) = tempRP(:,3) * -1;
rawPoints = [tempRP(permuteSequence(1)),tempRP(permuteSequence(2)),-1*tempRP(permuteSequence(3))];
freeEndPoints = inputDataStruct.fep;
strandIndices = inputDataStruct.si;
cutFrames = [1,maskSize(1);1,maskSize(2);1,maskSize(3)];%cut frames (cutFrames)
grayThresh = inputDataStruct.grayThresh;
maxIntensity = inputDataStruct.maxIntensity;



globalDataStruct.origVectorProject = origVectorProject;
globalDataStruct.maskSize = maskSize;
globalDataStruct.fileRootName = fileRootName;
globalDataStruct.originalFileName = [fileRootName,'-VectorProject.mat'];
globalDataStruct.loadFileName = loadFileName;
globalDataStruct.grayscaleFileName = grayscaleFileName;
globalDataStruct.cpMatrix = cpMatrix;
globalDataStruct.strands = strands;
globalDataStruct.allVerts = allVerts;
globalDataStruct.allRadii = allRadii;
globalDataStruct.allLabels = allLabels;
globalDataStruct.allConfidences = allConfidences;
globalDataStruct.allNotes = allNotes;
globalDataStruct.junctionPoints = junctionPoints;
globalDataStruct.freeEndPoints = freeEndPoints;
globalDataStruct.strandIndices = strandIndices;
globalDataStruct.cutFrames = cutFrames;        
globalDataStruct.rawPoints = rawPoints;
globalDataStruct.grayThresh = grayThresh;
globalDataStruct.maxIntensity = maxIntensity;
    

    %-----
    globalDataStruct.displayOption = 1;
    globalDataStruct.selectedDots = [0,0,0];
    globalDataStruct.affiliatedDots = [0,0,0];
    %-----
    blank = [];
    selectionParameters = blank;
    selectionParameters.selectStrandFlag = 1;
    selectionParameters.selectPoint1Flag = 0;
    selectionParameters.selectPoint2Flag = 0;
    selectionParameters.selectedCPList = [1];
    selectionParameters.affiliatedCPList = [];
    selectionParameters.selectedPoints12 = [0 0];
    selectionParameters.selectedRadius = 0;
    globalDataStruct.selectionParameters = selectionParameters;
    globalDataStruct.currentPointer = 1;
    globalDataStruct.refreshRawDataDisplayFlag = 0;
    globalDataStruct.loadDataSetFlag = 0;
    globalDataStruct.exitFlag = 0;
    globalDataStruct.decimateBy = 3;
    globalDataStruct.nextDirection = +1;
    globalDataStruct.limitBoxSize = [50 50 50];
    globalDataStruct.addPointCoord = [1 1 1];
    globalDataStruct.numBranches = 0;
    globalDataStruct.branchStruct = [];
    globalDataStruct.radiusMultiplier = 3;
    globalDataStruct.logScaleFlag = 0;
    globalDataStruct.sqrtScaleFlag = 1;
    globalDataStruct.showCenterlineFlag = 1;
    globalDataStruct.showTargetFlag = 1;
    globalDataStruct.raw3DFlag = 0;
    globalDataStruct.projectionExtent = 100;%plus/minus
    globalDataStruct.projectionDepth = 10;%plus/minus
    globalDataStruct.validClick = 0;
    globalDataStruct.autoBoxFlag = 0;
    globalDataStruct.autoTrackFlag = 0;
    globalDataStruct.markLimitsStruct = [];
    globalDataStruct.highlightZeroRadiusFlag = 0;
    globalDataStruct.strandStatsFlag = 0;
    %-----
    %Define colorPanels
    %ColorPalette
    colorParameters = blank;
    colorParameters.colorList = 'kmrbgcy';
    colorParameters.symbolList = '.*oxds^';
    %---
    colorParameters.unlabeledSymbol.color = 0;
    colorParameters.unlabeledSymbol.symbol = 1;
    colorParameters.unlabeledSymbol.visible = 1;
    %---
    colorParameters.tempSymbol.color = 0;
    colorParameters.tempSymbol.symbol = 2;
    colorParameters.tempSymbol.visible = 1;
    %---
    colorParameters.surface.color = 0;
    colorParameters.surface.symbol = 3;
    colorParameters.surface.visible = 1;
    %---
    colorParameters.plunging.color = 0;
    colorParameters.plunging.symbol = 4;
    colorParameters.plunging.visible = 1;
    %---
    colorParameters.micro.color = 0;
    colorParameters.micro.symbol = 5;
    colorParameters.micro.visible = 1;
    %---
    colorParameters.extraSymbol1.color = 0;
    colorParameters.extraSymbol1.symbol = 6;
    colorParameters.extraSymbol1.visible = 1;
    %---
    colorParameters.extraSymbol2.color = 0;
    colorParameters.extraSymbol2.symbol = 7;
    colorParameters.extraSymbol2.visible = 1;
    %---
    %---
    colorParameters.unlabeledColor.color = 1;
    colorParameters.unlabeledColor.symbol = 0;
    colorParameters.unlabeledColor.visible = 1;
    %---
    colorParameters.tempColor.color = 2;
    colorParameters.tempColor.symbol = 0;
    colorParameters.tempColor.visible = 1;
    %---
    colorParameters.supply.color = 3;
    colorParameters.supply.symbol = 0;
    colorParameters.supply.visible = 1;
    %---
    colorParameters.draining.color = 4;
    colorParameters.draining.symbol = 0;
    colorParameters.draining.visible = 1;
    %---
    colorParameters.connecting.color = 5;
    colorParameters.connecting.symbol = 0;
    colorParameters.connecting.visible = 1;
    %---
    colorParameters.extraColor1.color = 6;
    colorParameters.extraColor1.symbol = 0;
    colorParameters.extraColor1.visible = 1;
    %---
    colorParameters.extraColor2.color = 7;
    colorParameters.extraColor2.symbol = 0;
    colorParameters.extraColor2.visible = 1;
    %-----
    globalDataStruct.colorParameters = colorParameters;
    globalDataStruct.selectionParameters = selectionParameters;    
    
    
fileRootName = globalDataStruct.fileRootName;
dateString = datestr(now,'yyyy_mm_dd-HH_MM_SS');
[pathName,fileName,ext] = fileparts(fileRootName);
saveFileName = fullfile(pathName,['SE2-',dateString,'-Mod','-StrandEdit2-',fileName,ext]);
pause(0.1);
save(saveFileName,'globalDataStruct');
  


