function fbnk3Di=VidaCreate3DLinSegFiltBank(fltsz,ppu,ntriangs)

deltaTheta = -0.02;     %small spin angle for removing symmetric cut issues

% path(path,'C:\Documents and Settings\kaufholdj\Desktop\MatlabContributedToolboxes\SphereTriangulate');
% path(path,'C:\Documents and Settings\John Kaufhold\Desktop\MatlabContributedToolboxes\SphereTriangulate');

% figure(1);hold on;
% p = 20; % precision
% t = 0:1/(p-1):1;
% [th,ph] = meshgrid( t*pi,t*2*pi );
% x = cos(th);
% y = sin(th).*cos(ph);
% z = sin(th).*sin(ph);
% surf(x,y,z, z.*0);
% % some pretty rendering options
% shading interp; lighting gouraud;
% camlight infinite; axis square; axis off;
% axis equal;
% rotate3d;

% [v2]=sphere_tri('ico',2,[],0);
% vv=v2.vertices;
% vf=v2.faces;
% plot3(vv2(:,1),vv2(:,2),vv2(:,3),'r.');

[v1]=sphere_tri('ico',ntriangs,[],0);
vv=v1.vertices;
vf=v1.faces;
% plot3(vv(:,1),vv(:,2),vv(:,3),'r.');

% spin each vertex by a small angle to remove symmetric cut issue
dth=deltaTheta;
homcoords=[vv';repmat(1,[1,size(vv,1)])];
rotmat1=[1 0 0 0;0 cos(dth) sin(dth) 0;0 -sin(dth) cos(dth) 0;0 0 0 1];
rotmat2=[cos(dth) sin(dth) 0 0;-sin(dth) cos(dth) 0 0;0 0 1 0;0 0 0 1];
atmp=rotmat2*(rotmat1*homcoords);
newv=[atmp(1:3,:)./repmat(atmp(4,:),3,1)]';
% plot3(newv(:,1),newv(:,2),newv(:,3),'b.');

oangs=newv(find(newv(:,3)>0),:);



cind=[fltsz+1,fltsz+1,fltsz+1];

% %  figure(1);hold on;
% %  figure(2);hold on;
for i=1:size(oangs,1)
  x1 = fltsz*[oangs(i,1):-(oangs(i,1))*(1/(ppu*fltsz-1)):-oangs(i,1)];
  x2 = fltsz*[oangs(i,2):-(oangs(i,2))*(1/(ppu*fltsz-1)):-oangs(i,2)];
  x3 = fltsz*[oangs(i,3):-(oangs(i,3))*(1/(ppu*fltsz-1)):-oangs(i,3)];
  faxisptsi{i}=[x1;x2;x3]';
%   plot3(x1,x2,x3,'b-');
%hold on
%   pause(.02);
end
%hold off


% % mymatrix = zeros(fltsz*2+1,fltsz*2+1,fltsz*2+1);
% % for q = 1:length(vv);
% %     x = round(linspace(0,fltsz*vv(q,1),ppu*fltsz+1))+fltsz+1;
% %     y = round(linspace(0,fltsz*vv(q,2),ppu*fltsz+1))+fltsz+1;
% %     z = round(linspace(0,fltsz*vv(q,3),ppu*fltsz+1))+fltsz+1;
% %     for qq = 1:length(x);
% %         mymatrix(x(qq),y(qq),z(qq)) = 1;
% %     end
% % end
% % imagesc(mymatrix(:,:,fltsz+1));
% % 



for i=1:length(faxisptsi)
  % figure(3);clf;
  fltbnki=zeros(2*fltsz+1,2*fltsz+1,2*fltsz+1);
  onpts=round(faxisptsi{i}+repmat(cind,size(faxisptsi{i},1),1));
  for j=1:size(onpts,1)
    fltbnki(onpts(j,1),onpts(j,2),onpts(j,3))=1;
  end
  fbnk3Di{i}=fltbnki/sum(fltbnki(:));

  for k=1:size(fbnk3Di{i},3)
    % imagesc(fbnk3Di{i}(:,:,k));
    % pause(.05);
  end
  % pause(.5);
end
