function [uvolfilt,Oui,lvolfilt,Oli]=VidaRodFiltBank3D(vascBlockFileName,fbnk3Dcell)

% disp(' ');
% disp([num2str(length(fbnk3Dcell))]);
% disp(' ');
% 
 % load vessel block
loadedStruct = load(vascBlockFileName,'-mat');
loadedVariables = fieldnames(loadedStruct);
vascBlock = loadedStruct.(loadedVariables{1});

% initialize best orientation, max response=0
uvolfilt=zeros([size(vascBlock,1),size(vascBlock,2),size(vascBlock,3)],'single');
lvolfilt=uvolfilt+single(max(vascBlock(:)));
% initialize max response to 2x max raw val

Oui=uint8(zeros(size(vascBlock,1),size(vascBlock,2),size(vascBlock,3)));
Oli=Oui;
if size(uvolfilt,3)~=size(vascBlock,3)
  disp('pm not initialized')
  keyboard;    
end

% enddisp(['There are ',num2str(length(fbnk3Dcell)),' 3D rod filters']);
% for each filter in bank
for i=1:length(fbnk3Dcell)
%   disp(['on filter ',num2str(i),' of ',num2str(length(fbnk3Dcell)),' : ',datestr(now,'mm/dd/yy HH:MM:SS')]);
  filti=double(fbnk3Dcell{i});
  %   Cfi=correlate with oriented filter
  % disp(['convolving...']);

%   Cfi=single(VidaConv3DFreq(vascBlock,filti));
    Cfi = single(imfilter(single(vascBlock),filti));
    clear filti


  % Cfi=single(convn(vascBlock,filti,'same'));
  %   ui = find Cfi>volfilt
  % disp(['finding orientation response locations > current']);
  ui=find(Cfi>uvolfilt);
  % disp(['finding orientation response locations < current']);
  
  %   update volfilt at ui with Cfi
  % disp(['computing max response']);
  uvolfilt(ui)=Cfi(ui);
  % disp(['computing min response']);

% %   
% %   
% %   li=find(Cfi<lvolfilt);
% %   
% %   lvolfilt(li)=Cfi(li);
% %   %   update best orientation at points, ui with i
% %   % disp(['computing best orientation response']);
% %   Oui(ui)=uint8(i);
% %   % disp(['computing worst orientation response']);
% %   Oli(li)=uint8(i);
% %   pause(.02);
  
    
end

  lvolfilt = [];
  Oui = [];
  Oli = [];

