function outDataStructure = VidaRunSaveOrSkip3(inDataStructure,inStageParameters)
% function outStageParameters] = VidaRunSaveOrSkip3(inStageParameters)
%---
dataStructureFileName = inStageParameters.dataStructureFileName;
dataStructureVariableName = inStageParameters.dataStructureVariableName;
mainFunctionCallString = inStageParameters.mainFunctionCallString;
currentStageString = inStageParameters.currentStageString;
if isfield(inStageParameters,'codeFolder'),
    addpath(inStageParameters.codeFolder);
end%if isfield(inStageParameters,'codeFolder'),
%-----
progressFlags = inDataStructure.progressFlags;
rootDataFolder = inDataStructure.globalParameters.rootDataFolder;
%---
currentProgressFlag = [currentStageString,'Completed'];
functionHandle = str2func(mainFunctionCallString);
completionField = [currentStageString,'CompletionDate'];
%---
try
    stageCompletionDate = inDataStructure.completionDates.(completionField);
catch
    stageCompletionDate = 'unknown date';
end
statusString = [currentStageString,' previously completed on ',stageCompletionDate];
%---
if ~isfield(progressFlags,currentProgressFlag),
    progressFlags.(currentProgressFlag) = 0;
end %if ~isfield(progressFlags,currentProgressFlag),
%---
if progressFlags.(currentProgressFlag) ~= 1,
    disp(['rootDataFolder : ',rootDataFolder]);
        outDataStructure = functionHandle(inDataStructure);
    %---
    progressFlags.(currentProgressFlag) = 1;
    outDataStructure.progressFlags = progressFlags;
    saveSize = (getfield(whos('outDataStructure'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    saveString1 = [dataStructureVariableName,' = outDataStructure;'];
    saveString2 = ['save(''',dataStructureFileName,''' , ''',dataStructureVariableName,''',scs)'];
    eval(saveString1);
    eval(saveString2);
else
    disp(statusString);
    outDataStructure = inDataStructure;
end%progressFlags.(currentProgressFlag) ~= 1
%---
return




