path2vidaProcessingDir = '/home/pblinder/Desktop/FLATTEN_CORTEX/CX06_pbEH';
rootName = 'CX06_pbEH';
ptr2latestSEfile = '/home/pblinder/Desktop/FLATTEN_CORTEX/CX06_pbEH/VectorProjectFolder/SE2-2012_07_06-14_21_23-Mod-StrandEdit2-CX06_pbEH.mat';


%load the pre-threshold relaxation vectorizedStructure
load(fullfile(path2vidaProcessingDir,sprintf('%s-PreAddTRBridgesVectorProject.mat',rootName)))


%update progress flags
vidaProject.multiThreadProgress.thresholdRelaxingFlag = 0;
vidaProject.multiThreadProgress.restrandifyingFlag = 0;



%% add bridging strands and revectorize (the final result of TR is appended to the vectorProject
%update vectorizedStructrue on VectorProject
%STAGE 12 : Add TR Bridges
    disp(['Adding TR Bridges and Re-vectorizing: ',datestr(now)]);
        vectorProject = VidaAddTRBridges(vectorProject);
    vectorProject.progressFlags.addTRBridgesCompleted = 1;
    saveSize = (getfield(whos('vectorProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vectorProject.vectorProjectFileName,'vectorProject',scs);




%% load latest SE file and transfer labels and manual corrections
load(ptr2latestSEfile)
